var XnhdAPI;
(function (XnhdAPI) {
    let plats_param = {
        screenMode: "vertical",
        version: "1.0.0",
        //平台类型，具体参见下方Param.channelList说明
        platType: 2,
        //渠道类型，具体参见下方Param.channelList说明
        channelType: 1,
        nativeType: {},
        webType: {
            QuToutiao: {
                appid: ""
            },
            FunPepper: {
                game_id: 0,
                client_id: 'ra2514vk',
                mode: 'gold',
                redirect_url: '' //特殊跳转链接处理，一般不要填写
            },
            Xiaomi: {
                appid: "",
            },
        },
        liteType: {
            WxLiteGame: {
                appid: "",
                banner_ad_id: "",
                video_ad_id: [""],
                interstitial_ad_id: "",
                share_txt: [""],
                share_img: [""],
                channelIndex: 0
            },
            OppoLiteGame: {
                appid: "",
                appkey: "",
                appSecret: "",
                packageName: "",
                appName: "",
                bannerAd: "",
                interstitialAd: "",
                videoAd: "",
                mediaId: ""
            },
            VivoLiteGame: {
                packageName: "",
                CpID: "",
                appid: "",
                bannerAd: "",
                interstitialAd: ""
            },
            HudieLiteGame: {
                gameId: "",
                gameKey: "",
                share_txt: [""],
                share_img: [""],
                other: {
                    appid: "",
                    appkey: "",
                    appSid: "",
                    bannerAd: "",
                    videoAd: ""
                }
            },
            VivoPKGame: {
                GameID: "",
                GameSecret: "",
                GameKey: ""
            },
            BdLiteGame: {
                appid: "",
                appkey: "",
                appSid: "",
                bannerAd: "",
                videoAd: "",
                share_txt: [""],
                share_img: [""]
            },
            XiaomiLiteGame: {
                appid: "",
                appkey: "",
                appSecret: "",
                packageName: "",
                appName: "",
                videoAd: "",
            }
        }
    };
    /**
     * Native:APK，一般使用Java层提供的接口
     * Web:纯网页，一般使用浏览器的通用标准接口，Laya引擎自带兼容
     * Lite:轻游戏，一般使用特殊接口
     */
    let platType;
    (function (platType) {
        platType[platType["Native"] = 0] = "Native";
        platType[platType["Web"] = 1] = "Web";
        platType[platType["Lite"] = 2] = "Lite";
    })(platType = XnhdAPI.platType || (XnhdAPI.platType = {}));
    /**
     * 轻游戏
     */
    let liteType;
    (function (liteType) {
        liteType[liteType["Default"] = 0] = "Default";
        liteType[liteType["WxGame"] = 1] = "WxGame";
        liteType[liteType["OppoGame"] = 2] = "OppoGame";
        liteType[liteType["VivoGame"] = 3] = "VivoGame";
        liteType[liteType["HudieLiteGame"] = 4] = "HudieLiteGame";
        liteType[liteType["VivoPKGame"] = 5] = "VivoPKGame";
        liteType[liteType["BdLiteGame"] = 6] = "BdLiteGame";
        liteType[liteType["XiaomiLiteGame"] = 7] = "XiaomiLiteGame";
    })(liteType = XnhdAPI.liteType || (XnhdAPI.liteType = {}));
    /**
     * APK渠道
     */
    let nativeType;
    (function (nativeType) {
        nativeType[nativeType["Default"] = 0] = "Default";
        nativeType[nativeType["Xiaomi"] = 1] = "Xiaomi";
        nativeType[nativeType["OPPO"] = 2] = "OPPO";
        nativeType[nativeType["VIVO"] = 3] = "VIVO";
        nativeType[nativeType["MEIZU"] = 4] = "MEIZU";
        nativeType[nativeType["M4399"] = 5] = "M4399";
    })(nativeType = XnhdAPI.nativeType || (XnhdAPI.nativeType = {}));
    /**
     * 标准H5网页，外挂一些JSSDK
     */
    let webType;
    (function (webType) {
        webType[webType["Default"] = 0] = "Default";
        webType[webType["FunPepper"] = 1] = "FunPepper";
        webType[webType["QuToutiao"] = 2] = "QuToutiao";
        webType[webType["Xiaomi"] = 3] = "Xiaomi";
    })(webType = XnhdAPI.webType || (XnhdAPI.webType = {}));
    let languageType;
    (function (languageType) {
        languageType[languageType["zh_CN"] = 0] = "zh_CN";
        languageType[languageType["en_US"] = 1] = "en_US";
        languageType[languageType["zh_TW"] = 2] = "zh_TW";
        languageType[languageType["id_ID"] = 3] = "id_ID";
        languageType[languageType["vi_VN"] = 4] = "vi_VN";
        languageType[languageType["ja_JP"] = 5] = "ja_JP";
        languageType[languageType["ar_EG"] = 6] = "ar_EG";
    })(languageType = XnhdAPI.languageType || (XnhdAPI.languageType = {}));
    class Param {
    }
    //是否启用全平台日志打印
    Param.logSwitch = true;
    //屏幕方向，横版适配未做，暂不要搞横屏
    Param.screenMode = "vertical"; //horizontal,vertical
    //各平台渠道配置说明文件，json数据格式，各平台类型下方用数组记录渠道名称，各数组索引即对应渠道类型，如微信小游戏在平台=2 渠道=1位置
    Param.channelList = {
        //平台编号0：Android原生平台，一般使用Java层提供的接口
        0: ["Default", "Xiaomi", "OPPO", "VIVO", "MEIZU", "4399"],
        //平台编号1：网页原生平台，一般使用浏览器的通用标准接口，Laya引擎自带兼容
        1: ["Default", "FunPepper", "QuToutiao", "Xiaomi"],
        //平台编号2：小游戏平台，一般使用H5特殊接口
        2: ["Default", "WxLiteGame", "OppoLiteGame", "VivoLiteGame", "HudieLiteGame", "VivoPKGame", "BdLiteGame", "XiaomiLiteGame"],
    };
    //设计宽度，目前所有游戏的设计宽度恒定为750
    Param.screenWidth = 750;
    //根据设计宽度和屏幕实际长宽比例调整的设计高度，iPhone X系列高度=1624
    Param.screenHeight = 1334;
    //根据屏幕实际宽度，对设计宽度进行拉伸的比例倍数
    Param.screenScale = 1;
    //本地化语言专用，默认1-简体中文
    Param.languageList = ['zh-CN', 'en-US', 'zh-TW', 'id-ID', 'vi-VN', 'ja-JP', 'ar-EG'];
    Param.curLanguage = 0;
    //wxonShow事件暂存队列（废弃）
    Param.wxLiteOnShowLaunchArr = [];
    Param.wxLiteOnShowInGameArr = [];
    //处理微信小游戏环境下，iPhone X系列奇葩手机导航栏高度的屏幕适配调整
    Param.wxLiteBannerUIadjustParam = 0;
    //账号系统，如无特殊需求就不用
    Param.hasUserId = 0;
    XnhdAPI.Param = Param;
    /**
     * PC, IOS , Android
     */
    let deviceOS;
    (function (deviceOS) {
        deviceOS[deviceOS["PC"] = 0] = "PC";
        deviceOS[deviceOS["IOS"] = 1] = "IOS";
        deviceOS[deviceOS["Android"] = 2] = "Android";
    })(deviceOS = XnhdAPI.deviceOS || (XnhdAPI.deviceOS = {}));
    /**
     * 设备环境初始化，XnhdAPI初始化，Laya引擎初始化
     */
    function Init(callback = null, is3D = false) {
        if (window['qq']) {
            core.GameDef.plats_param.channelType === 2 && Laya.QGMiniAdapter.init();
            core.GameDef.plats_param.channelType === 7 && Laya.KGMiniAdapter.init();
            Laya.MiniAdpter.init(true, false);
        }
        else if (window['swan'] && laya.bd.mini.BMiniAdapter) {
            laya.bd.mini.BMiniAdapter.init();
        }
        else if (window['wx']) {
            Laya.MiniAdpter.init(true, false);
        }
        !is3D ? Laya.init(Laya.Browser.width, Laya.Browser.height, Laya.WebGL) : Laya3D.init(Laya.Browser.width, Laya.Browser.height);
        Laya.MouseManager.multiTouchEnabled = false;
        getLocalConfig();
        core.AudioAndSetting.Manager.init();
        XnhdAPI.DeviceInfo.inst.init();
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.init(Param.localConfig.liteType[Param.channelList["2"][1]], callback);
            return;
        }
        callback && callback();
        if (XnhdAPI.Param.platType === 0) {
            if (XnhdAPI.NativeGameAPI) {
                XnhdAPI.NativeGameAPI.init(callback);
            }
            return;
        }
    }
    XnhdAPI.Init = Init;
    function setErrorCallback(_errorCallback) {
        Param.errorCallback = _errorCallback;
    }
    XnhdAPI.setErrorCallback = setErrorCallback;
    /**
     * 上传游戏最高分给对应渠道
     * @param score 分数
     */
    function updateHighScore(score) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.updateScore(score);
            return;
        }
    }
    XnhdAPI.updateHighScore = updateHighScore;
    /*
     * 读取本地配置文件，具体参见本页顶端
     */
    function getLocalConfig() {
        XnhdAPI.Param.localConfig = core.GameDef.plats_param;
        let a = core.GameDef.plats_param.platType;
        if (typeof a === "number" && Param.channelList[a.toString()]) {
            XnhdAPI.Param.platType = core.GameDef.plats_param.platType;
            let b = core.GameDef.plats_param.channelType;
            if (typeof b === "number" && Param.channelList[a.toString()][b]) {
                XnhdAPI.Param.channelType = b;
            }
            else if (typeof b === "string" && Param.channelList[a.toString()].indexOf(b) > -1) {
                XnhdAPI.Param.channelType = Param.channelList[a.toString()].indexOf(b);
            }
            else {
                XnhdAPI.logError("配置文件的channelType参数错误");
            }
        }
        else {
            XnhdAPI.logError("配置文件的platType参数错误");
        }
        // Laya.loader.load("res/config/game_config.json", Laya.Handler.create(this, e => {
        //     XnhdAPI.Param.localConfig = Laya.loader.getRes("res/config/game_config.json");
        //     if (XnhdAPI.Param.localConfig) {
        //         XnhdAPI.Param.platType = XnhdAPI.Param.localConfig.platType;
        //         XnhdAPI.Param.channelType = XnhdAPI.Param.localConfig.channelType;
        //     } else {
        //         XnhdAPI.logError("get loadConfig Error");
        //     }
        //     callback();
        // }), null, Laya.Loader.JSON);
    }
    /**
     * 登录
     */
    function Login() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            // XnhdAPI.WxLiteGameAPI.login();
            return;
        }
        // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 2) {
        //     OppoLiteGameAPI.login();
        //     return;
        // }
    }
    XnhdAPI.Login = Login;
    /**
     * 分享图片接口，目前仅供微信使用
     * @param forReward 是否是为了奖励而进行分享
     * @param sceneNum 调起分享图片的场景编号，自定
     * @param successCallback 分享成功回调
     * @param failCallback 分享失败回调
     * @param text 分享标题，暂不支持修改图片
     * @param query 分享所带参数
     */
    function shareImage(forReward = false, sceneNum = 0, successCallback = null, failCallback = null, text = null, query = null) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.shareImage(forReward, successCallback, failCallback, sceneNum, text, query);
            return;
        }
    }
    XnhdAPI.shareImage = shareImage;
    /**暂不用 */
    function shareScreen(title, x, y, width, height) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.shareScreen(title, x, y, width, height);
        }
    }
    XnhdAPI.shareScreen = shareScreen;
    /**
     * 存储数据缓存
     * @param key 数据标识
     * @param content 数据内容
     * @param isInt 数据是否为整数
     * @param successCallback 保存成功回调
     */
    function saveDataToCache(key, content, isInt = false, successCallback = null) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.saveDataToCache(key, content, successCallback);
            return;
        }
        isInt && (content = content.toString());
        Laya.LocalStorage.setItem(key, content);
    }
    XnhdAPI.saveDataToCache = saveDataToCache;
    /**
     * 读取缓存
     * @param key 数据标识
     * @param isInt 是否Int
     */
    function readDataFromCache(key, isInt = false) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            let d = XnhdAPI.WxLiteGameAPI.getDataFromCache(key);
            if (isInt && typeof d === "string") {
                if (d.length === 0) {
                    d = 0;
                }
                else {
                    d = parseInt(d);
                }
            }
            return d;
        }
        let a = Laya.LocalStorage.getItem(key);
        if (isInt && a) {
            return parseInt(a);
        }
        return a;
    }
    XnhdAPI.readDataFromCache = readDataFromCache;
    /**
     * http请求
     * @param url 请求地址
     * @param callback 请求成功回调，包含返回数据
     * @param data 请求的数据，字符串
     * @param failCallback 请求失败的回调
     */
    function requestHttp(url, successCallback, data = "", failCallback = null) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.requestHttpOriginal(url, successCallback, data, failCallback);
            return;
        }
        normalRequestHttp(url, successCallback, data, failCallback);
    }
    XnhdAPI.requestHttp = requestHttp;
    var http_Instance;
    /**普通的http请求 */
    function normalRequestHttp(url, successCallback, data, failCallback) {
        http_Instance = new Laya.HttpRequest;
        http_Instance.http.timeout = 10000;
        http_Instance.http.withCredentials = true;
        http_Instance.once(Laya.Event.COMPLETE, this, res => {
            successCallback && successCallback(res);
        });
        http_Instance.once(Laya.Event.ERROR, this, f => {
            failCallback && failCallback(f);
        });
        http_Instance.send(url, data, 'post', 'text', ["Content-Type", "application/json"]);
    }
    // export function downloadFile(content, successCallback, failCallback) {
    // }
    /**
     * 程序回到前台时执行方法
     * @param callback 执行方法
     */
    function onShow(callback) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.setOnShow(callback);
            return;
        }
    }
    XnhdAPI.onShow = onShow;
    /**
     * 程序转入后台时执行方法
     * @param callback 执行方法
     */
    function onHide(callback) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.setOnHide(callback);
            return;
        }
    }
    XnhdAPI.onHide = onHide;
    /**
     * 初始化排行榜
     */
    function initRankList() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.init();
            return;
        }
    }
    XnhdAPI.initRankList = initRankList;
    /**
     * 显示竖版大排行榜
     * @param panel 加载到哪个panel区域
     */
    function showRankList(panel) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.showRankList(panel);
            return;
        }
    }
    XnhdAPI.showRankList = showRankList;
    /**
     * 竖版大排行榜上下拖动操作
     * @param offsetY 移动距离
     */
    function moveRankList(offsetY) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.moveRankList(offsetY);
            return;
        }
    }
    XnhdAPI.moveRankList = moveRankList;
    /**
     * 关闭所有类型排行榜
     */
    function closeRankList() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.closeWxSub();
            return;
        }
    }
    XnhdAPI.closeRankList = closeRankList;
    /**
     * 显示横版三人小排行榜
     * @param panel 加载到哪个panel区域
     */
    function showSmallRankList(panel) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.showSmallRankList(panel);
            return;
        }
    }
    XnhdAPI.showSmallRankList = showSmallRankList;
    /**
     * 初始化即将超越排行榜
     * @param panel 加载到哪个panel区域
     * @param score 初始化所需分数（或关卡等其他排序所需参数）
     */
    function initNextFriend(panel, score) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.showNextFriend(panel, score);
            return;
        }
    }
    XnhdAPI.initNextFriend = initNextFriend;
    /**
     * 更新即将超越排行榜
     * @param score 更新的分数（或关卡等其他排序所需参数）
     */
    function showNextFriend(score) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.changeNextFriend(score);
            return;
        }
    }
    XnhdAPI.showNextFriend = showNextFriend;
    /**
     * 显示banner广告（oppo小游戏的广告和NativeAPK的包还无法调整）
     * @param positionY banner广告显示到什么位置
     */
    function showBannerAd(adName, positionY) {
        if (window["qttGame"]) {
            console.log("jlog, run in showBannerAd.qttGame");
            window["qttGame"].showBanner();
            return;
        }
        else if (window['sdkToNative']) {
            window['ZhangYuBannerCb'] = function () { console.log("run in showBannerAd zhangyu -> callback"); };
            console.log("begin to showBannerAd banner zhangyu");
            window["sdkToNative"].postMessage('{"method": "showBannerAd", "callback":"window.ZhangYuBannerCb"}');
        }
        else if (bannerAD) {
            console.log("jlog, run in showBanner.bannerAD0");
            bannerAD.show();
            console.log("jlog, run in showBanner.bannerAD1");
        }
        // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
        //     XnhdAPI.WxLiteGameAPI.AdManager.Default.showWxLiteGameBannerAd(positionY);
        //     return;
        // }
        // if (XnhdAPI.Param.platType === 0) {
        //     XnhdAPI.NativeGameAPI.showBannerAd(positionY);
        //     return;
        // }
    }
    XnhdAPI.showBannerAd = showBannerAd;
    /**
     * 隐藏banner广告
     */
    function hideBannerAd(adName) {
        if (bannerAD) {
            bannerAD.hide();
        }
        else if (window['sdkToNative']) {
            window['ZhangYuHideBannerCb'] = function () { console.log("run in hideBannerAd zhangyu -> callback"); };
            console.log("begin to hideBanner banner zhangyu");
            window["sdkToNative"].postMessage('{"method": "hideBannerAd", "callback":"window.ZhangYuHideBannerCb"}');
        }
        else if (window["qttGame"]) {
            console.log("jlog, run in hideBannerAd.qttGame");
            window["qttGame"].hideBanner(adName);
            return;
        }
        // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
        //     XnhdAPI.WxLiteGameAPI.AdManager.Default.hideWxLiteGameBannerAd();
        //     return;
        // }
        // if (XnhdAPI.Param.platType === 0) {
        //     XnhdAPI.NativeGameAPI.hideBannerAd();
        //     return;
        // }
    }
    XnhdAPI.hideBannerAd = hideBannerAd;
    /**
     * 显示视频广告
     * @param successCallback 视频广告完整看完时的回调
     * @param failCallback 其他情况回调，如回调参数为空，表明视频没有加载成功，如果回调参数是字符串，表示用户没有看完广告
     */
    function showVideoAd(adName, successCallback, failCallback, noAdCallback) {
        if (window['qttGame']) {
            console.log("dsAd-jlog, run in showRewardAd.qttGame");
            window["qttGame"].showVideo(adName, (res) => {
                console.log("dsAd-jlog, run in showRewardAd.qttGame -> callback, res:" + res);
                if (res == 1) {
                    successCallback && successCallback();
                }
                else if (res == 0) {
                    console.log("dsAd-jlog, 视频填充不足, res:" + res);
                    noAdCallback && noAdCallback();
                }
                else if (res == 2) {
                    console.log("dsAd-jlog, 视频播放未完成, res:" + res);
                    failCallback && failCallback();
                }
            });
            return;
        }
        else if (window['sdkToNative']) {
            console.log("jlog, run in showVideoAd zhangyu");
            window['adCallbackZhangyuVideo'] = ret => {
                console.log("jlog, run in adCallbackZYReward, ret:", ret);
                if (typeof ret == 'string') {
                    try {
                        ret = JSON.parse(ret);
                    }
                    catch (e) {
                        console.log("jlog, run in adCallbackZYReward, catch");
                        noAdCallback && noAdCallback();
                        return;
                    }
                }
                if (ret.code == 0) {
                    console.log("jlog, run in adCallbackZYReward, succ");
                    successCallback && successCallback();
                }
                else {
                    console.log("jlog, run in adCallbackZYReward, fail");
                    noAdCallback && noAdCallback();
                }
            };
            window["sdkToNative"].postMessage('{"method": "showRewardVideoAd", "params":{"orientation":0}, "callback":"window.adCallbackZhangyuVideo"}');
        }
        else if (window['swan']) {
            if (!rewardAd) {
                initRewardAd();
            }
            if (rewardAd) {
                // 用户触发广告后，显示激励视频广告
                rewardAd.show().catch(() => {
                    // 失败重试
                    rewardAd.load()
                        .then(() => rewardAd.show())
                        .catch(err => {
                        noAdCallback && noAdCallback();
                        console.log('激励视频 广告显示失败1');
                    });
                });
                rewardAd.onClose(res => {
                    // 用户点击了【关闭广告】按钮
                    // 小于 2.1.0 的基础库版本，res 是一个 undefined
                    if (res && res.isEnded || res === undefined) {
                        successCallback && successCallback();
                    }
                    else {
                        // 播放中途退出，不下发游戏奖励
                        failCallback && failCallback();
                        console.log("播放中途退出，不下发游戏奖励");
                    }
                    //关闭的时候取消掉监听，防止造成重复调用
                    rewardAd.offClose();
                    rewardAd.offError();
                    rewardAd.load();
                });
            }
        }
        else if (window['tt'] || window['qq']) {
            if (rewardAd === null) {
                initRewardAd();
            }
            if (rewardAd) {
                // 用户触发广告后，显示激励视频广告
                rewardAd.show().catch(() => {
                    // 失败重试
                    rewardAd.load()
                        .then(() => rewardAd.show())
                        .catch(err => {
                        console.log('激励视频 广告显示失败1');
                        noAdCallback && noAdCallback();
                    });
                });
                window['onRewardClose'] = res => {
                    // 用户点击了【关闭广告】按钮
                    // 小于 2.1.0 的基础库版本，res 是一个 undefined
                    if (res && res.isEnded || res === undefined) {
                        successCallback && successCallback();
                    }
                    else {
                        // 播放中途退出，不下发游戏奖励
                        failCallback && failCallback();
                        console.log("播放中途退出，不下发游戏奖励");
                    }
                    //关闭的时候取消掉监听，防止造成重复调用
                    rewardAd.offClose(window['onRewardClose']);
                    // rewardAd.offError();
                    rewardAd.load();
                };
                rewardAd.onClose(window['onRewardClose']);
            }
        }
        // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
        //     XnhdAPI.WxLiteGameAPI.AdManager.Default.showWxLiteGameVideoAd(successCallback, failCallback)
        //     return;
        // }
        // if (XnhdAPI.Param.platType === 0) {
        //     XnhdAPI.NativeGameAPI.showVideoAd(successCallback, failCallback)
        //     return;
        // }
    }
    XnhdAPI.showVideoAd = showVideoAd;
    /**
     * 获取当前视频广告的状态，暂时仅限微信
     * 默认为0，此时广告状态异常，建议隐藏视频广告入口。
     * 返回1时，表明当前视频广告加载成功但没有适合该用户的情况，也建议隐藏广告入口，或者告知用户第二天再看。
     * 返回2时，表明当前视频广告正在加载中，可以稍后重试。
     * 返回3时，表明广告加载成功，可以拉起广告
     */
    function checkVideoAd() {
        return 3;
        // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
        //     // //断点调试，缺少videoReardy的初始化调用。加载一个初始化调试
        //     // XnhdAPI.WxLiteGameAPI.AdManager.Default.initAdManager()
        //     // if (XnhdAPI.WxLiteGameAPI.AdManager.Default.getVideoStatus()) {
        //     //     return 3;
        //     // } else {
        //     //     return 0;
        //     // }
        //     return 3;
        // } else if (XnhdAPI.Param.platType === 0) {
        //     return XnhdAPI.NativeGameAPI.checkVideoAd() ? 3 : 0;
        // } else {
        //     return 0;
        // }
    }
    XnhdAPI.checkVideoAd = checkVideoAd;
    let interstitialAd = null;
    /**
     * 显示插屏广告
     * @param successCallback 插屏广告关闭时的回调（即有广告收入时的成功回调）
     * @param failCallback 插屏广告显示失败时的回调
     */
    function showInterstitialAd(adName, successCallback, failCallback) {
        console.log("run in showInterstitialAd0");
        if (window['qttGame']) {
            window['qttGame'].showHDReward(adName);
        }
        else if (window['sdkToNative']) {
            console.log("begin to showVideoInteractionAd zhangyu");
            window["sdkToNative"].postMessage('{"method": "showVideoInteractionAd"}');
        }
        else if (window['tt']) {
            const isToutiaio = window['tt'].getSystemInfoSync().appName === "Toutiao";
            if (isToutiaio) {
                if (interstitialAd != null) {
                    interstitialAd.destroy();
                    interstitialAd = null;
                }
                interstitialAd = window['tt'].createInterstitialAd({
                    adUnitId: "48gj941j2d3bnomcdp"
                });
                console.log("create tt interstitialAd:", interstitialAd);
                interstitialAd.onError((err) => console.log("run in tt interstitialAd.inError:", err));
                interstitialAd.onLoad((err) => console.log("run in tt interstitialAd.onLoad:", err));
                interstitialAd.load()
                    .then(() => {
                    console.log("tt interstitialAd loaded");
                    interstitialAd.show();
                })
                    .catch(err => {
                    console.log("tt interstitialAd loaded error:", err);
                    console.log(err);
                });
            }
            else {
                console.log("tt not in toutiao");
            }
        }
        console.log("run in showInterstitialAd9");
        // else if(window['qq']){
        //     if(!ad){
        //         // 创建插屏广告实例，提前初始化
        //         ad = window['qq'].createInterstitialAd({
        //             adUnitId: 'e561f65da931aa4c5129b783071d05f4'
        //         })
        //         ad.onError(err => {
        //             console.log(err)
        //         })
        //     }
        //     ad.show().catch((err) => {
        //         console.error(err)
        //     })
        // }
        // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
        //     XnhdAPI.WxLiteGameAPI.AdManager.Default.showWxInterstitial(successCallback, failCallback)
        //     return;
        // }
        // if (XnhdAPI.Param.platType === 0) {
        //     XnhdAPI.NativeGameAPI.showInterstitialAd(successCallback, failCallback)
        //     return;
        // }
    }
    XnhdAPI.showInterstitialAd = showInterstitialAd;
    /**
     * 显示悬浮窗广告
     */
    function showFloatAd() {
        if (XnhdAPI.Param.platType === 0) {
            XnhdAPI.NativeGameAPI.showFloatAd();
            return;
        }
    }
    XnhdAPI.showFloatAd = showFloatAd;
    /**
     * SBvivoLite导致界面适配性出现问题，使用这个函数处理"局部坐标转换全局坐标"
     * @param fromSpr 某一节点
     * @param pos 该节点的坐标点
     */
    function localToGlobal(fromSpr, pos) {
        fromSpr.localToGlobal(pos);
        let a = new Laya.Point(pos.x / Param.screenScale, pos.y / Param.screenScale);
        return a;
    }
    XnhdAPI.localToGlobal = localToGlobal;
    /**
     * SBvivoLite导致界面适配性出现问题，使用这个函数处理"全局坐标转换局部坐标"
     * @param toSpr 转换到某一节点
     * @param pos 全局坐标点
     */
    function globalToLocal(toSpr, pos) {
        let a = new Laya.Point(pos.x * Param.screenScale, pos.y * Param.screenScale);
        toSpr.globalToLocal(a);
        return a;
    }
    XnhdAPI.globalToLocal = globalToLocal;
    //SBvivoLite导致界面适配性出现问题，必须使用这个函数才能获取真实的鼠标坐标
    function realMousePosition() {
        return new Laya.Point(Laya.stage.mouseX / Param.screenScale, Laya.stage.mouseY / Param.screenScale);
    }
    XnhdAPI.realMousePosition = realMousePosition;
    /**
     * 游戏加载进度条
     * @param num 进度百分比，正常传入整数0-100即可，传入101表示将加载页面关闭
     */
    function setLoadingProgress(num) {
        if (XnhdAPI.Param.platType === 0) {
            num < 101 && Laya.Browser.window.loadingView && Laya.Browser.window.loadingView.loading(num);
            return;
        }
    }
    XnhdAPI.setLoadingProgress = setLoadingProgress;
    /**
     * 设置语言
     * @param language 字符串，一般是国际标准代号，例如'zh-CN'代表简体中文
     */
    function setLanguage(language) {
        let a = Param.languageList.indexOf(language);
        if (a > -1) {
            Param.curLanguage = a;
        }
        else {
            XnhdAPI.logError('不支持当前传入的语言字符串：' + language);
        }
    }
    XnhdAPI.setLanguage = setLanguage;
    /**
     * 简易的屏幕居中黑色背景的Tips文字展示，lag秒钟后变淡销毁
     * @param tipsText 文字内容
     * @param lag 延迟销毁毫秒数
     */
    function showTips(tipsText, blackBg = true, lag = 2000) {
        // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === XnhdAPI.1) {
        //     WxLiteGameAPI.showWxToast(tipsText);
        // } else {
        let tips = Laya.stage.getChildByName("XnhdTips");
        if (tips) {
            Laya.Tween.clearAll(tips);
        }
        else {
            tips = new Laya.Label;
        }
        ;
        tips.width = 800;
        tips.scale(Param.screenScale, Param.screenScale);
        tips.color = "#ffffff";
        blackBg && (tips.bgColor = "#000000");
        tips.strokeColor = "#120bcf";
        tips.fontSize = 35;
        tips.stroke = 3;
        tips.bold = true;
        tips.align = "center";
        tips.padding = "20,35,20,35";
        tips.wordWrap = true;
        tips.text = tipsText;
        tips.cacheAs = "bitmap";
        tips.centerX = 0;
        tips.centerY = 0;
        tips.alpha = 0.9;
        tips.name = "XnhdTips";
        Laya.stage.addChild(tips);
        tips.zOrder = 10;
        Laya.Tween.to(tips, { alpha: 0 }, 2000, null, Laya.Handler.create(this, () => {
            tips.destroy();
        }), lag);
        // }
    }
    XnhdAPI.showTips = showTips;
    /*
       微信授权--记录数据
    */
    function WeChatAuthorization() {
        // XnhdAPI.WxLiteGameAPI.Param.openid = Date.now().toString();
        // let exportJson1 = {code :"",userInfo:""};
        // Laya.Browser.window.wx.login({
        //     success: (userRes) => {
        //         exportJson1.code = userRes.code;//向服务端传递code用于获取微信小游戏的用户唯一标识
        //         XnhdAPI.WxLiteGameAPI.Param.shareVar.code = exportJson1.code;
        //         let url_ = XnhdAPI.WxLiteGameAPI.Param.url_Info.server_url + "/api/game_openid.php?appId=" + XnhdAPI.WxLiteGameAPI.Param.appInfo.appid +
        //             "&code=" + exportJson1.code;
        //             Laya.Browser.window.wx.request({
        //                 url: url_,
        //                 fail: function (res) {
        //                     XnhdAPI.logDebug("openid Fail: " + JSON.stringify(res));
        //                 },
        //                 success: function (res) {
        //                     XnhdAPI.logDebug("openid Success: " + JSON.stringify(res));
        //                     if (res.statusCode == 200) {
        //                        let open = XnhdAPI.WxLiteGameAPI.getDataFromCache("openId");
        //                         if (typeof open === 'string' && open.length>0) {
        //                             XnhdAPI.WxLiteGameAPI.Param.openid = open;
        //                         }else{
        //                             XnhdAPI.WxLiteGameAPI.Param.openid = Date.now().toString();
        //                              XnhdAPI.WxLiteGameAPI.saveDataToCache("openId", XnhdAPI.WxLiteGameAPI.Param.openid, () => {
        //                                 XnhdAPI.logDebug("save openid success")
        //                             }, () => {
        //                                 XnhdAPI.logError("save openid fail")
        //                             })
        //                             XnhdAPI.WxLiteGameAPI.Subcontent.Manager.updateScore(0);
        //                         }
        //                     }
        //                 }
        //             })
        //        },
        // });
        //     let sysInfo = Laya.Browser.window.wx.getSystemInfoSync();
        //    //获取微信界面大小
        //     let width = sysInfo.screenWidth;
        //     let height = sysInfo.screenHeight;
        //     Laya.Browser.window.wx.getSetting({
        //         success (res) {
        //             console.log(res.authSetting);
        //             if (res.authSetting["scope.userInfo"]) {
        //                 console.log("用户已授权");
        //                 Laya.Browser.window.wx.getUserInfo({
        //                     success(res){
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.avatarUrl = res.userInfo.avatarUrl;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.nickName = res.userInfo.nickName;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.city = res.userInfo.city;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.language = res.userInfo.language;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.province = res.userInfo.province;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.gender = res.userInfo.gender;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.country = res.userInfo.country;
        //                         XnhdAPI.WxLiteGameAPI.updateUserInfo();
        //                         XnhdAPI.WxLiteGameAPI.saveUserData();
        //                         console.log(res);
        //                         exportJson1.userInfo = res.userInfo;
        //                         //此时可进行登录操作
        //                         console.log("kaishideshihou ----用户已授权",JSON.stringify(XnhdAPI.WxLiteGameAPI.Param.userInfo));
        //                     }
        //                 });
        //             }else {
        //                 console.log("用户未授权");
        //                 let button = Laya.Browser.window.wx.createUserInfoButton({
        //                     type: 'text',
        //                     text: '',
        //                     style: {
        //                         left: 0,
        //                         top: 0,
        //                         width: width,
        //                         height: height,
        //                         backgroundColor: '#00000000',//最后两位为透明度
        //                         color: '#ffffff',
        //                         fontSize: 20,
        //                         textAlign: "center",
        //                         lineHeight: height,
        //                     }
        //                 });
        //                 button.onTap((res) => {
        //                     if (res.userInfo) {
        //                         console.log("用户授权:", res);
        //                         exportJson1.userInfo = res.userInfo;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.avatarUrl = res.userInfo.avatarUrl;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.nickName = res.userInfo.nickName;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.city = res.userInfo.city;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.language = res.userInfo.language;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.province = res.userInfo.province;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.gender = res.userInfo.gender;
        //                         XnhdAPI.WxLiteGameAPI.Param.userInfo.country = res.userInfo.country;
        //                         XnhdAPI.WxLiteGameAPI.updateUserInfo();
        //                         XnhdAPI.WxLiteGameAPI.saveUserData();
        //                         console.log(res);
        //                         exportJson1.userInfo = res.userInfo;
        //                         console.log("kaishideshihou ----用户授权",JSON.stringify(XnhdAPI.WxLiteGameAPI.Param.userInfo));
        //                         //此时可进行登录操作
        //                         button.destroy();
        //                     }else {
        //                         console.log("用户拒绝授权:", res);
        //                     }
        //                 });
        //             }
        //         }
        //     })
    }
    XnhdAPI.WeChatAuthorization = WeChatAuthorization;
    /*
    *显示1,是激勵廣告 2.插屏广告 3仅显示 0 初始化   type 是否加金币
    */
    let ad = null;
    let bannerAD = null;
    let rewardAd = null;
    function initRewardAd() {
        if (window['tt']) {
            console.log("load tt video", window['tt']);
            if (rewardAd === null && window['tt'].createRewardedVideoAd) {
                // 创建激励视频广告实例，提前初始化
                rewardAd = window['tt'].createRewardedVideoAd({
                    adUnitId: '1gjd50j487dp1jj2d7'
                });
                rewardAd.onError(err => {
                    console.log("tt, createRewardedVideoAd error:", err);
                });
            }
        }
        else if (window['swan']) {
            if (rewardAd === null) {
                console.log("load swan video");
                rewardAd = window['swan'].createRewardedVideoAd({
                    adUnitId: "6954222",
                    appSid: "b71720d5",
                });
                rewardAd.onError(console.warn);
                rewardAd.onError(err => {
                    console.log("loadVideoError:", err);
                });
                rewardAd.load();
            }
        }
        else if (window['qq']) {
            console.log("load qq video", window['qq']);
            if (rewardAd === null && window['qq'].createRewardedVideoAd) {
                // 创建激励视频广告实例，提前初始化
                rewardAd = window['qq'].createRewardedVideoAd({
                    adUnitId: '7dd92bee6d80b4516ef78beda80db8b5'
                });
                rewardAd.onError(err => {
                    console.log("qq, createRewardedVideoAd error:", err);
                });
            }
        }
    }
    XnhdAPI.initRewardAd = initRewardAd;
    function showIneAd() {
        XnhdAPI.showInterstitialAd("over", null, null);
    }
    XnhdAPI.showIneAd = showIneAd;
    //type:1-加金币，2-加万能牌，3-加炸弹，4-加存牌
    function showRewardAd(type) {
        if (window['qttGame']) {
            console.log("dsAd-jlog, run in showRewardAd.qttGame");
            window["qttGame"].showVideo((res) => {
                console.log("dsAd-jlog, run in showRewardAd.qttGame -> callback, res:" + res);
                if (res == 1) {
                    if (type === 1) {
                        console.log('dsAd-jlog, run in adjustCoin1Num');
                        core.Player.Manager.adjustCoinNum(core.GameDef.gameParam.videoGold);
                        // this.coinText.text = core.Player.Manager.getCoinNum().toString();
                    }
                    else if (type === 2) {
                        core.GameLogic.Default.setOmnNum(1); //加一个万能牌
                        core.GameLogic.Default._useOmnipotentCard();
                    }
                    else if (type === 3) {
                        core.GameLogic.Default.setBomeNum(1); //如果播放结束，加一个炸弹
                        core.GameLogic.Default._useBomb();
                    }
                    else if (type === 4) {
                        core.GameLogic.Default.setCanSaveCardNum(1); //加一个存牌
                        core.GameLogic.Default._gameView.resetCardSaveTimes(core.GameLogic.Default.getCanSaveCardNum(), 1);
                    }
                }
                else if (res == 0) {
                    XnhdAPI.showTips(core.GameDef.localizationConfig.noVideoTips[core.GameDef.languageIndex]);
                    console.log("dsAd-jlog, 视频播放失败0, res:" + res);
                }
                else if (res == 2) {
                    XnhdAPI.showTips(core.GameDef.localizationConfig.finishVideoTips[core.GameDef.languageIndex]);
                    console.log("dsAd-jlog, 视频播放失败2, res:" + res);
                }
            });
            return;
        }
        else if (window['swan']) {
            if (!rewardAd) {
                initRewardAd();
            }
            if (rewardAd) {
                // 用户触发广告后，显示激励视频广告
                rewardAd.show().catch(() => {
                    // 失败重试
                    rewardAd.load()
                        .then(() => rewardAd.show())
                        .catch(err => {
                        console.log('激励视频 广告显示失败');
                    });
                });
                rewardAd.onClose(res => {
                    // 用户点击了【关闭广告】按钮
                    // 小于 2.1.0 的基础库版本，res 是一个 undefined
                    if (res && res.isEnded || res === undefined) {
                        if (type === 1) {
                            core.Player.Manager.adjustCoinNum(core.GameDef.gameParam.videoGold);
                            this.coinText.text = core.Player.Manager.getCoinNum().toString();
                        }
                        else if (type === 2) {
                            core.GameLogic.Default.setOmnNum(1); //加一个万能牌
                            core.GameLogic.Default._useOmnipotentCard();
                        }
                        else if (type === 3) {
                            core.GameLogic.Default.setBomeNum(1); //如果播放结束，加一个炸弹
                            core.GameLogic.Default._useBomb();
                        }
                        else if (type === 4) {
                            core.GameLogic.Default.setCanSaveCardNum(1); //加一个存牌
                            core.GameLogic.Default._gameView.resetCardSaveTimes(core.GameLogic.Default.getCanSaveCardNum(), 1);
                        }
                    }
                    else {
                        // 播放中途退出，不下发游戏奖励
                        console.log("播放中途退出，不下发游戏奖励");
                    }
                    //关闭的时候取消掉监听，防止造成重复调用
                    rewardAd.offClose();
                    rewardAd.offError();
                    rewardAd.load();
                });
            }
        }
        else if (window['tt'] || window['qq']) {
            console.log("showRewardAd tt||qq 0");
            if (rewardAd === null) {
                initRewardAd();
            }
            if (rewardAd) {
                console.log("showRewardAd tt||qq 1");
                // 用户触发广告后，显示激励视频广告
                rewardAd.show().catch(() => {
                    // 失败重试
                    rewardAd.load()
                        .then(() => rewardAd.show())
                        .catch(err => {
                        console.log('激励视频 广告显示失败');
                    });
                });
                window['onRewardClose'] = res => {
                    console.log("showRewardAd tt||qq 2");
                    // 用户点击了【关闭广告】按钮
                    // 小于 2.1.0 的基础库版本，res 是一个 undefined
                    if (res && res.isEnded || res === undefined) {
                        if (type === 1) {
                            core.Player.Manager.adjustCoinNum(core.GameDef.gameParam.videoGold);
                            this.coinText.text = core.Player.Manager.getCoinNum().toString();
                        }
                        else if (type === 2) {
                            core.GameLogic.Default.setOmnNum(1); //加一个万能牌
                            core.GameLogic.Default._useOmnipotentCard();
                        }
                        else if (type === 3) {
                            core.GameLogic.Default.setBomeNum(1); //如果播放结束，加一个炸弹
                            core.GameLogic.Default._useBomb();
                        }
                        else if (type === 4) {
                            core.GameLogic.Default.setCanSaveCardNum(1); //加一个存牌
                            core.GameLogic.Default._gameView.resetCardSaveTimes(core.GameLogic.Default.getCanSaveCardNum(), 1);
                        }
                    }
                    else {
                        // 播放中途退出，不下发游戏奖励
                        console.log("播放中途退出，不下发游戏奖励");
                    }
                    //关闭的时候取消掉监听，防止造成重复调用
                    rewardAd.offClose(window['onRewardClose']);
                    rewardAd.load();
                };
                console.log("showRewardAd tt||qq 3");
                rewardAd.onClose(window['onRewardClose']);
                console.log("showRewardAd tt||qq 9");
            }
        }
        else {
            if (type === 1) {
                console.log('dsAd-jlog, run in adjustCoin2Num');
                core.Player.Manager.adjustCoinNum(core.GameDef.gameParam.videoGold);
                // this.coinText.text = core.Player.Manager.getCoinNum().toString();
            }
            else if (type === 2) {
                core.GameLogic.Default.setOmnNum(1); //加一个万能牌
                core.GameLogic.Default._useOmnipotentCard();
            }
            else if (type === 3) {
                core.GameLogic.Default.setBomeNum(1); //如果播放结束，加一个炸弹
                core.GameLogic.Default._useBomb();
            }
            else if (type === 4) {
                core.GameLogic.Default.setCanSaveCardNum(1); //加一个存牌
                core.GameLogic.Default._gameView.resetCardSaveTimes(core.GameLogic.Default.getCanSaveCardNum(), 1);
            }
        }
        // if(rewardAd === null){
        //   // 创建激励视频广告实例，提前初始化
        //        rewardAd = Laya.Browser.window.wx.createRewardedVideoAd({
        //             adUnitId: 'adunit-7af720e268e83f11'
        //         })
        //        rewardAd.onError(err => {
        //             console.log(err)
        //         })
        // }
        // if(rewardAd){
        //     // 用户触发广告后，显示激励视频广告
        //     rewardAd.show().catch(() => {
        //         // 失败重试
        //         rewardAd.load()
        //             .then(() => rewardAd.show())
        //             .catch(err => {
        //                 console.log('激励视频 广告显示失败')
        //             })
        //     })
        //     rewardAd.onClose(res => {
        //         // 用户点击了【关闭广告】按钮
        //         // 小于 2.1.0 的基础库版本，res 是一个 undefined
        //         if (res && res.isEnded || res === undefined) {
        //             if(type === 1){
        //                 core.Player.Manager.adjustCoinNum(core.GameDef.gameParam.videoGold);
        //                 this.coinText.text = core.Player.Manager.getCoinNum().toString();
        //             }else if(type === 2){
        //                 core.GameLogic.Default.setOmnNum(1);//加一个万能牌
        //                 core.GameLogic.Default._useOmnipotentCard();
        //             }else if (type === 3){
        //                 core.GameLogic.Default.setBomeNum(1);//如果播放结束，加一个炸弹
        //                 core.GameLogic.Default._useBomb();
        //             }else if (type === 4){
        //                 core.GameLogic.Default.setCanSaveCardNum(1);//加一个存牌
        //                 core.GameLogic.Default._gameView.resetCardSaveTimes(core.GameLogic.Default.getCanSaveCardNum(),1);
        //             }
        //         }
        //         else {
        //             // 播放中途退出，不下发游戏奖励
        //             console.log("播放中途退出，不下发游戏奖励");
        //         }
        //         //关闭的时候取消掉监听，防止造成重复调用
        //         rewardAd.offClose();
        //         rewardAd.offError();
        //     })  
        // }
    }
    XnhdAPI.showRewardAd = showRewardAd;
    function initBannerAD() {
        console.log("jlog, run in initBannerAD0");
        if (window["qttGame"]) {
            console.log("jlog, run in initBannerAD.qttGame");
            return;
        }
        else if (window['sdkToNative']) {
            console.log("begin to init banner zhangyu");
            return;
        }
        else if (window['swan']) {
            console.log("jlog, run in initBannerAD.swan");
            let systemInfo = window['swan'].getSystemInfoSync();
            if (typeof (systemInfo) == 'string') {
                systemInfo = JSON.parse(systemInfo);
            }
            let screenHeight = systemInfo['screenHeight'];
            let screenWidth = systemInfo['screenWidth'];
            console.log("jlog, height:", screenHeight, ", width:", screenWidth);
            if (!bannerAD) {
                bannerAD = window['swan'].createBannerAd({
                    adUnitId: "6954221",
                    appSid: "b71720d5",
                    adIntervals: 30,
                    style: {
                        top: screenHeight - 80,
                        left: (screenWidth - 240 * systemInfo.pixelRatio) / 2,
                        width: 240
                    }
                });
                bannerAD.onResize((res) => {
                    console.log(' banner 广告位宽度变化:', res);
                    bannerAD.style.top = screenHeight - res.height;
                    bannerAD.style.left = (screenWidth - res.width) / 2;
                });
                bannerAD.onLoad(() => {
                    console.log("baidu banner show");
                    // this.showBanner2Time = Date.parse(new Date())/1000
                    bannerAD.style.width = 240;
                });
                bannerAD.onError((err) => {
                    console.log('baidu banner 广告错误:', err);
                    bannerAD.offError();
                });
            }
        }
        else if (window['tt']) {
            console.log("jlog, run in initBannerAD.tt");
            Laya.Browser.window.wx = window['tt'];
            // 创建 Banner 广告实例，提前初始化
            var phone = Laya.Browser.window.wx.getSystemInfoSync();
            var w = phone.screenWidth / 2;
            var h = phone.screenHeight;
            let lv = h / (w * 2);
            // console.log("ThePhoneWAndH"+phone.screenWidth+phone.screenHeight);
            if (!bannerAD) {
                bannerAD = Laya.Browser.window.wx.createBannerAd({
                    adUnitId: '1mo0bpwdlmg30f43pu',
                    style: {
                        left: 0,
                        top: 0,
                        width: 350
                    }
                });
                bannerAD.onError(err => {
                    console.log('tt banner 广告加载错误');
                    console.log(err);
                });
                bannerAD.onLoad(() => {
                    console.log('tt banner 广告加载成功');
                });
                window['bannerResizeFunc'] = size => {
                    console.log('tt banner onResize0, size:', size);
                    if (lv > 2) {
                        bannerAD.style.left = w - size.width / 2 + 0.1;
                        console.log('tt banner onResize1, w:', w, ", size.width:", size.width, "left:", bannerAD.style.left);
                        bannerAD.style.top = h - size.height - 10;
                        console.log(bannerAD);
                        console.log('tt banner onResize2, size:', size);
                    }
                    else {
                        console.log('tt banner onResize3, size:', size);
                        bannerAD.style.left = w - size.width / 2 + 0.1;
                        bannerAD.style.top = h - size.height + 0.1;
                        bannerAD.style.width = phone.screenWidth * 0.8;
                        console.log(bannerAD);
                        console.log('tt banner onResize4, size:', size);
                    }
                    console.log('tt banner onResize5, size:', size);
                    bannerAD.offResize(window['bannerResizeFunc']);
                    console.log('tt banner onResize6, size:', size);
                };
                bannerAD.onResize(window['bannerResizeFunc']);
                // bannerAD.onResize(function(size) {
                //     console.log('tt banner onResize0, size:', size)
                //     bannerAD.style.left = w - size.width / 2 +0.1;
                //     bannerAD.style.top = h - size.height + 0.1;
                //     // bannerAD.style.width = phone.screenWidth*0.8;
                //     console.log(bannerAD);      
                // })
                // //iphoneX 屏幕比例2.16
                // if(lv>2){
                //     bannerAD.onResize(function() {
                //         bannerAD.style.left = w - bannerAD.style.realWidth / 2 + 0.1;
                //         bannerAD.style.top = h - bannerAD.style.realHeight - 10;
                //         console.log(bannerAD);      
                //     })
                // }
            }
        }
        else if (window['qq']) {
            var phone = Laya.Browser.window.wx.getSystemInfoSync();
            var w = phone.screenWidth / 2;
            var h = phone.screenHeight;
            let lv = h / (w * 2);
            // console.log("ThePhoneWAndH"+phone.screenWidth+phone.screenHeight);
            if (!bannerAD) {
                bannerAD = Laya.Browser.window.wx.createBannerAd({
                    adUnitId: '24aeb5fc159f510e06eb1e68a451fa4e',
                    style: {
                        left: 0,
                        top: 0,
                        width: 350
                    }
                });
                bannerAD.onError(err => {
                    console.log(err);
                });
                bannerAD.onLoad(() => {
                    console.log('banner 广告加载成功');
                });
                window['bannerResizeFunc'] = size => {
                    console.log('tt banner onResize0, size:', size);
                    if (lv > 2) {
                        bannerAD.style.left = w - size.width / 2 + 0.1;
                        console.log('tt banner onResize1, w:', w, ", size.width:", size.width, "left:", bannerAD.style.left);
                        bannerAD.style.top = h - size.height - 10;
                        console.log(bannerAD);
                        console.log('tt banner onResize2, size:', size);
                    }
                    else {
                        console.log('tt banner onResize3, size:', size);
                        bannerAD.style.left = w - size.width / 2 + 0.1;
                        bannerAD.style.top = h - size.height + 0.1;
                        bannerAD.style.width = phone.screenWidth * 0.8;
                        console.log(bannerAD);
                        console.log('tt banner onResize4, size:', size);
                    }
                    console.log('tt banner onResize5, size:', size);
                    bannerAD.offResize(window['bannerResizeFunc']);
                    console.log('tt banner onResize6, size:', size);
                };
                bannerAD.onResize(window['bannerResizeFunc']);
            }
        }
        // Laya.Browser.window.wx = Laya.Browser.window.tt;
        // // 创建 Banner 广告实例，提前初始化
        // var phone = Laya.Browser.window.wx.getSystemInfoSync();
        // var w = phone.screenWidth / 2;
        // var h = phone.screenHeight;
        // let lv = h/(w*2);
        // // console.log("ThePhoneWAndH"+phone.screenWidth+phone.screenHeight);
        // if(!bannerAD){
        //     bannerAD = Laya.Browser.window.wx.createBannerAd({
        //     adUnitId: 'adunit-298ef1168f118105',
        //         style: {
        //             left: 0,
        //             top: 0,
        //             width: 350
        //         }
        //     });
        //     bannerAD.onError(err => {
        //         console.log(err)
        //     });
        //     bannerAD.onLoad(() => {
        //         console.log('banner 广告加载成功')
        //     });
        //     bannerAD.onResize(function() {
        //         bannerAD.style.left = w - bannerAD.style.realWidth / 2 +0.1;
        //         bannerAD.style.top = h - bannerAD.style.realHeight + 0.1;
        //         bannerAD.style.width = phone.screenWidth*0.8;
        //         console.log(bannerAD);      
        //     })
        //     //iphoneX 屏幕比例2.16
        //     if(lv>2){
        //         bannerAD.onResize(function() {
        //             bannerAD.style.left = w - bannerAD.style.realWidth / 2 + 0.1;
        //             bannerAD.style.top = h - bannerAD.style.realHeight - 10;
        //             console.log(bannerAD);      
        //         })
        //     }
        // }
    }
    XnhdAPI.initBannerAD = initBannerAD;
    function hideBanner(adName) {
        if (bannerAD) {
            bannerAD.hide();
        }
        else if (window['sdkToNative']) {
            window['ZhangYuHideBannerCb'] = function () { console.log("run in hideBannerAd zhangyu -> callback"); };
            console.log("begin to hideBanner banner zhangyu");
            window["sdkToNative"].postMessage('{"method": "hideBannerAd", "callback":"window.ZhangYuHideBannerCb"}');
        }
        else if (window["qttGame"]) {
            console.log("jlog, run in hideBanner.qttGame");
            window["qttGame"].hideBanner(adName);
            return;
        }
    }
    XnhdAPI.hideBanner = hideBanner;
    function showBanner(adName) {
        if (window["qttGame"]) {
            console.log("jlog, run in showBanner.qttGame");
            window["qttGame"].showBanner(adName);
            return;
        }
        else if (window['sdkToNative']) {
            window['ZhangYuBannerCb'] = function () { console.log("run in showBannerAd zhangyu -> callback"); };
            console.log("begin to showBannerAd banner zhangyu");
            window["sdkToNative"].postMessage('{"method": "showBannerAd", "callback":"window.ZhangYuBannerCb"}');
        }
        else if (bannerAD) {
            console.log("jlog, run in showBanner.bannerAD0");
            bannerAD.show();
            console.log("jlog, run in showBanner.bannerAD1");
        }
        // if(bannerAD){
        //     bannerAD.show();
        //     //宽度375以下的机型  隐藏掉banner的显示。
        //     var phone = Laya.Browser.window.wx.getSystemInfoSync();
        //     if(phone.screenWidth<375){
        //         bannerAD.hide();
        //     }
        // }
        // else{
        //     this.initBannerAD();
        //     bannerAD.show();
        // }
    }
    XnhdAPI.showBanner = showBanner;
    function initManagerWx() {
        // var wx = Laya.Browser.window.wx;
        //     wx.showShareMenu({
        //         withShareTicket: true,
        //     });
        //     wx.aldOnShareAppMessage(() => {
        //         return {
        //                 title:'今天，一起来消除方块吧！',
        //                 imageUrl:'https://mmocgame.qpic.cn/wechatgame/tkqueHfeL6Q339O6SXVTZxpKrttNLx1R003f2MPpL4ORIvniauMCLfn11ichMsjSX1/0',						
        //                 query:"", 
        //                 success: function (res) {
        //                     console.log('转发成功')
        //                 },
        //                 fail: function () {
        //                     console.log('转发失败')
        //                 }
        //             };
        //     });
    }
    XnhdAPI.initManagerWx = initManagerWx;
    /**
     * 打印调试log
     * @param msg
     */
    function logDebug(msg) {
        if (Param.logSwitch) {
            if (XnhdAPI.Param.platType === 0) {
                if (XnhdAPI.NativeGameAPI) {
                    XnhdAPI.NativeGameAPI.printLogToApk(msg);
                }
                else {
                    console.log("jlog:", msg);
                }
            }
            else {
                // 当前时间
                console.log(formatDateTime(Date.now()) + ":" + msg);
            }
        }
    }
    XnhdAPI.logDebug = logDebug;
    /**
     * 打印错误log
     * @param msg
     */
    function logError(msg) {
        if (Param.logSwitch) {
            if (XnhdAPI.Param.platType === 0) {
                XnhdAPI.NativeGameAPI.printErrorLogToApk(msg);
            }
            else {
                // 当前时间
                console.error(formatDateTime(Date.now()) + ":" + msg);
            }
        }
    }
    XnhdAPI.logError = logError;
    function formatDateTime(time) {
        // 格式化日期，获取今天的日期和时间
        let Dates = new Date(time);
        let year = Dates.getFullYear();
        let month = (Dates.getMonth() + 1) < 10 ? '0' + (Dates.getMonth() + 1) : (Dates.getMonth() + 1).toString();
        let day = Dates.getDate() < 10 ? '0' + Dates.getDate() : Dates.getDate().toString();
        let hour = Dates.getHours() < 10 ? '0' + Dates.getHours() : Dates.getHours().toString();
        let min = Dates.getMinutes() < 10 ? '0' + Dates.getMinutes() : Dates.getMinutes().toString();
        let second = Dates.getSeconds() < 10 ? '0' + Dates.getSeconds() : Dates.getSeconds().toString();
        return year + '-' + month + '-' + day + " " + hour + ":" + min + ":" + second;
    }
    /**
     * 转成特殊用途的按钮方法，目前暂只用于将开始游戏按钮转化成微信小游戏的授权按钮，一次性使用，用户点击后直接销毁并显示原按钮
     * @param button 传入需特殊用途化处理的button
     * @param imageUrl 传入这个button图片的地址，注意！如果这个按钮图片打入了大图集，那么必须要将这个按钮图放到别的地址，不能打入到大图集中；如果没有打入大图的话，传个空字符串即可
     * @param successCallback 用户授权成功时的回调
     * @param failCallback 用户授权失败时的回调
     */
    function specializeBtn(button, imageUrl, successCallback = null, failCallback = null) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.createBtnWithAuthorize(button, imageUrl, successCallback, failCallback);
            return;
        }
    }
    XnhdAPI.specializeBtn = specializeBtn;
    function showSpecialBtn() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.showBtnWithAuthorize();
            return;
        }
    }
    XnhdAPI.showSpecialBtn = showSpecialBtn;
    function hideSpecialBtn() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.hideBtnWithAuthorize();
            return;
        }
    }
    XnhdAPI.hideSpecialBtn = hideSpecialBtn;
    function exitProgram() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.exitProgram();
            return;
        }
    }
    XnhdAPI.exitProgram = exitProgram;
    function vibrateShort() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.vibrateShort();
            return;
        }
    }
    XnhdAPI.vibrateShort = vibrateShort;
})(XnhdAPI || (XnhdAPI = {}));
