var XnhdAPI;
(function (XnhdAPI) {
    var BdLiteGameAPI;
    (function (BdLiteGameAPI) {
        var Param = /** @class */ (function () {
            function Param() {
            }
            Param.appInfo = {
                appid: "",
                appkey: "",
                adSid: "",
                banner: "",
                video: ""
            };
            Param.shareInfo = {
                share_txt: [],
                share_img: []
            };
            return Param;
        }());
        BdLiteGameAPI.Param = Param;
        function exitProgram() {
            swan.exit();
        }
        BdLiteGameAPI.exitProgram = exitProgram;
        function init(baiduLiteGameConfig, callback) {
            Param.appInfo.appid = baiduLiteGameConfig.appid;
            Param.appInfo.appkey = baiduLiteGameConfig.appkey;
            Param.appInfo.adSid = baiduLiteGameConfig.appSid;
            Param.appInfo.banner = baiduLiteGameConfig.bannerAd;
            Param.appInfo.video = baiduLiteGameConfig.videoAd;
            Param.shareInfo.share_img = baiduLiteGameConfig.share_img;
            Param.shareInfo.share_txt = baiduLiteGameConfig.share_txt;
            swan.onError(function (error) {
                XnhdAPI.logError(error.message);
                XnhdAPI.Param.errorCallback && XnhdAPI.Param.errorCallback(error.message);
            });
            AdManager.Default.initAdManager();
            swan.showShareMenu();
            swan.onShareAppMessage(function (res) {
                var r = XnhdAPI.Tools.randomInt(0, Param.shareInfo.share_img.length - 1);
                return {
                    title: Param.shareInfo.share_txt[r],
                    imageUrl: Param.shareInfo.share_img[r]
                };
            });
            callback && callback();
        }
        BdLiteGameAPI.init = init;
        function requestHttpOriginal(url, callback, data, failCallback) {
            if (failCallback === void 0) { failCallback = null; }
            XnhdAPI.logDebug("request >> " + url);
            swan.request({
                method: "POST",
                url: url,
                data: data,
                success: function (e) {
                    callback(e);
                },
                fail: function (f) {
                    if (failCallback) {
                        failCallback();
                    }
                    XnhdAPI.logDebug("wxLiteGame requestHttp fail >>" + f.toString());
                }
            });
        }
        BdLiteGameAPI.requestHttpOriginal = requestHttpOriginal;
        function shareImage(_param, successCallback, failCallback) {
            var r = XnhdAPI.Tools.randomInt(0, Param.shareInfo.share_img.length - 1);
            swan.shareAppMessage({
                title: Param.shareInfo.share_txt[r],
                imageUrl: Param.shareInfo.share_img[r]
            });
        }
        BdLiteGameAPI.shareImage = shareImage;
        var AdManager = /** @class */ (function () {
            function AdManager() {
                this._bannerAd = null;
                this._videoAd = null;
                this._bannerReady = false;
                this._bannerNeedshow = false;
                this._bannerTop = XnhdAPI.Param.screenHeight;
                this._videoReady = false;
                this._videoFailCode = 3010003;
            }
            AdManager.prototype.initAdManager = function () {
                var info = swan.getSystemInfoSync();
                this.adScreenWidth = info.screenWidth;
                this.adScreenHeight = info.screenHeight;
                var top = Math.floor(XnhdAPI.Param.screenHeight * (0.835 - 0.036 * (XnhdAPI.Param.screenHeight - 1334) / 290));
                this._bannerTop = Math.floor(top / (750 / this.adScreenWidth * this.adScreenHeight) * this.adScreenHeight);
                this.initBanner();
                this.initVideo();
                // Laya.timer.frameLoop(10800, this, this.baiduBannerLoop);
            };
            AdManager.prototype.baiduBannerLoop = function () {
                this.destroyBannerAd();
                Laya.timer.frameOnce(60, this, this.initBanner);
            };
            AdManager.prototype.initBanner = function (lag) {
                var _this = this;
                if (lag === void 0) { lag = 1; }
                if (Param.appInfo.banner.length > 5) {
                    var leftDistance = this.adScreenWidth * 0.075;
                    if (this.adScreenWidth * 0.85 < 300) {
                        leftDistance = (this.adScreenWidth - 300) / 2;
                    }
                    try {
                        this._bannerAd = swan.createBannerAd({
                            adUnitId: Param.appInfo.banner,
                            appSid: Param.appInfo.adSid,
                            style: {
                                left: Math.floor(leftDistance),
                                top: this._bannerTop,
                                width: Math.floor(this.adScreenWidth * 0.85)
                            }
                        });
                        this._bannerAd.onLoad(function () {
                            _this._bannerReady = true;
                            if (_this._bannerNeedshow) {
                                _this._bannerAd.show();
                            }
                        });
                        this._bannerAd.onError(function (f) {
                            _this._bannerReady = false;
                            _this._bannerNeedshow = true;
                            XnhdAPI.logError("load WxLiteGameBannerAd fail, errMsg >> " + JSON.stringify(f));
                            _this._bannerAd.offError();
                            _this._bannerAd.offLoad();
                            _this._bannerAd.destroy();
                            Laya.timer.once(lag * 500, _this, _this.initBanner, [lag * 2]);
                        });
                    }
                    catch (e) {
                        Laya.timer.once(lag * 500, this, this.initBanner, [lag * 2]);
                    }
                }
            };
            AdManager.prototype.showBannerAd = function (top) {
                this._bannerTop = Math.floor(top / (750 / this.adScreenWidth * this.adScreenHeight) * this.adScreenHeight);
                // if (this._bannerReady) {
                //     if (this._bannerNeedshow) {
                //         this._bannerNeedshow = false;
                //         this._bannerAd.show();
                //     }
                //     Laya.timer.frameOnce(1, this, () => { this._bannerAd.style.top = this._bannerTop });
                // }
                !this._bannerNeedshow && this.initBanner(1);
                this._bannerNeedshow = true;
            };
            AdManager.prototype.hideBannerAd = function () {
                // this._bannerNeedshow = true;
                // if (this._bannerReady) {
                //     this._bannerAd.hide();
                // }
                this._bannerNeedshow && this.destroyBannerAd();
            };
            AdManager.prototype.destroyBannerAd = function () {
                if (this._bannerAd != null) {
                    try {
                        this._bannerAd.offError();
                        this._bannerAd.offLoad();
                        this._bannerAd.destroy();
                        this._bannerAd = null;
                        this._bannerReady = false;
                        this._bannerNeedshow = false;
                    }
                    catch (e) {
                        XnhdAPI.logDebug("error: position: destroyWxLiteGameBannerAd >>" + e.toString());
                    }
                }
            };
            AdManager.prototype.initVideo = function () {
                var _this = this;
                this._videoFailCode = 3010003;
                if (Param.appInfo.video.length > 5) {
                    try {
                        if (this._videoAd != null) {
                            this._videoAd.destroy();
                        }
                        this._videoAd = swan.createRewardedVideoAd({
                            adUnitId: Param.appInfo.video,
                            appSid: Param.appInfo.adSid,
                        });
                    }
                    catch (e) {
                        XnhdAPI.logError("create videoAd fail, wxgameBug");
                        if (this._videoAd != null) {
                            this._videoAd.destroy();
                            this._videoAd = null;
                        }
                        Laya.timer.once(500, this, this.initVideo);
                        return;
                    }
                    try {
                        this._videoAd.onLoad(function () {
                            _this._videoReady = true;
                            _this._videoFailCode = 0;
                        });
                        this._videoAd.onError(function (f) {
                            _this._videoReady = false;
                            XnhdAPI.logError("Load videoAd fail, errMsg >> " + +JSON.stringify(f));
                            _this._videoFailCode = f.errCode;
                            if (typeof f.errCode === "number") {
                                if ([3010000, 3010001, 3010002, 3010003].indexOf(f.errCode) > -1) {
                                    Laya.timer.once(5000, _this, function () {
                                        _this._videoAd.load();
                                    });
                                }
                            }
                            else {
                                Laya.timer.once(5000, _this, function () {
                                    _this._videoAd.load();
                                });
                            }
                        });
                    }
                    catch (e) {
                        XnhdAPI.logError("videoAd fail, bdgameBug");
                        Laya.timer.once(500, this, this.initVideo);
                        return;
                    }
                }
            };
            AdManager.prototype.getVideoStatus = function () {
                return this._videoFailCode;
            };
            AdManager.prototype.showVideoAd = function (successCallback, failCallback) {
                var _this = this;
                if (this._videoReady) {
                    this._videoReady = false;
                    this._videoFailCode = 3010003;
                    this._videoAd.onClose(function (res) {
                        if (res === undefined || (res && res.isEnded)) {
                            successCallback && successCallback();
                        }
                        else {
                            failCallback && failCallback("sbBD");
                        }
                        _this._videoAd.offClose();
                    });
                    this._videoAd.show();
                }
                else {
                    failCallback && failCallback();
                }
            };
            AdManager.Default = new AdManager();
            return AdManager;
        }());
        BdLiteGameAPI.AdManager = AdManager;
    })(BdLiteGameAPI = XnhdAPI.BdLiteGameAPI || (XnhdAPI.BdLiteGameAPI = {}));
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=BdLiteGameAPI.js.map