var XnhdAPI;
(function (XnhdAPI) {
    var OppoLiteGameAPI;
    (function (OppoLiteGameAPI) {
        var Param = /** @class */ (function () {
            function Param() {
            }
            Param.userInfo = {
                uid: "",
                nickName: "",
                avatar: "",
                token: "",
                sex: "",
                birthday: "",
                phoneNum: "",
                location: "",
            };
            Param.appInfo = {
                appid: "",
                appKey: "",
                appSecret: "",
                packageName: "",
                appName: ""
            };
            Param.otherInfo = {
                payCallbackUrl: "",
                oppoLiteAppVersion: "",
                canPay: false
            };
            Param.advertiseInfo = {
                mediaId: "",
                bannerAd: "",
                interstitialAd: "",
                videoAd: "",
                isDownLoaded: false,
            };
            Param.loadingPage = null;
            Param.oppoLiteActivityInfo = {
                code: 0
            };
            Param.delayFunc = [];
            return Param;
        }());
        OppoLiteGameAPI.Param = Param;
        function vibrateShort() {
            qg.vibrateShort();
        }
        OppoLiteGameAPI.vibrateShort = vibrateShort;
        function exitProgram() {
            qg.exitApplication();
        }
        OppoLiteGameAPI.exitProgram = exitProgram;
        function init(oppoLiteGameConfig, callback) {
            Param.appInfo.appid = oppoLiteGameConfig.appid.toString();
            Param.appInfo.appKey = oppoLiteGameConfig.appKey;
            Param.appInfo.appSecret = oppoLiteGameConfig.appSecret;
            Param.appInfo.packageName = oppoLiteGameConfig.packageName;
            Param.appInfo.appName = oppoLiteGameConfig.appName;
            Param.advertiseInfo.bannerAd = oppoLiteGameConfig.bannerAd.toString();
            Param.advertiseInfo.interstitialAd = oppoLiteGameConfig.interstitialAd.toString();
            Param.advertiseInfo.videoAd = oppoLiteGameConfig.videoAd.toString();
            Param.advertiseInfo.mediaId = oppoLiteGameConfig.mediaId.toString();
            setLoadingProgress(0);
            AdManager.Default.init();
            callback && callback();
            login(null);
        }
        OppoLiteGameAPI.init = init;
        function login(callback) {
            XnhdAPI.logDebug("oppoLogin的pkgName：" + Param.appInfo.packageName);
            try {
                qg.login({
                    pkgName: Param.appInfo.packageName,
                    success: function (res) {
                        XnhdAPI.logDebug("oppoLogin的参数：" + JSON.stringify(res));
                        try {
                            Param.userInfo.uid = res.uid;
                            Param.userInfo.token = res.token;
                            Param.userInfo.nickName = res.nickName;
                            Param.userInfo.avatar = res.avatar;
                            Param.userInfo.sex = res.sex;
                            Param.userInfo.birthday = res.birthday;
                            Param.userInfo.phoneNum = res.phoneNum;
                            Param.userInfo.location = res.location;
                            dealWithSome();
                            callback && callback();
                        }
                        catch (e) {
                            XnhdAPI.logDebug("OppoLiteGame Login success but fail JSON.parse>> " + e.toString());
                        }
                    },
                    fail: function (f) {
                        XnhdAPI.logError("oppoLogin Fail：" + JSON.stringify(f));
                    }
                });
            }
            catch (f) {
                XnhdAPI.logDebug("OppoLiteGame Login fail >> " + f.toString());
            }
        }
        OppoLiteGameAPI.login = login;
        function dealWithSome() {
            for (var i = 0; i < Param.delayFunc.length; i++) {
                Param.delayFunc[i]();
            }
            Param.delayFunc = [];
        }
        function updateRankScore(score, lag) {
            if (lag === void 0) { lag = 1; }
            var delayFunc = function () {
                var _this = this;
                XnhdAPI.requestHttp('https://game.batwan.cn/interface/oppo_rank.php', function (res) {
                    XnhdAPI.logDebug('上传活动分数成功：' + JSON.stringify(res));
                }, JSON.stringify({
                    appid: Param.appInfo.appid,
                    userId: Param.userInfo.uid,
                    rankScore: score
                }), function (f) {
                    XnhdAPI.logDebug('上传分数失败：' + f);
                    Laya.timer.once(lag * 1000, _this, updateRankScore, [score, 2 * lag]);
                });
            };
            if (Param.appInfo.appid.length === 0) {
                Param.delayFunc.push(delayFunc);
            }
            else {
                delayFunc();
            }
        }
        OppoLiteGameAPI.updateRankScore = updateRankScore;
        function requestActivityInfo(actid, lag) {
            if (lag === void 0) { lag = 1; }
            var delayFunc = function () {
                var _this = this;
                XnhdAPI.requestHttp('https://game.batwan.cn/interface/oppo_act.php', function (res) {
                    Param.oppoLiteActivityInfo[actid.toString()] = res;
                    XnhdAPI.logDebug('获取活动成功：' + JSON.stringify(res));
                }, JSON.stringify({
                    appid: Param.appInfo.appid,
                    actid: actid
                }), function (f) {
                    XnhdAPI.logDebug('获取活动' + actid.toString() + '失败：' + f);
                    Laya.timer.once(lag * 1000, _this, requestActivityInfo, [actid, 2 * lag]);
                });
            };
            if (Param.appInfo.appid.length === 0) {
                Param.delayFunc.push(delayFunc);
            }
            else {
                delayFunc();
            }
        }
        OppoLiteGameAPI.requestActivityInfo = requestActivityInfo;
        /**
         * oppoLiteGame游戏初始加载进度条
         * @param num 0~100
         */
        function setLoadingProgress(num) {
            // if (parseInt(Param.otherInfo.oppoLiteAppVersion) >= 1031) {
            if (num < 101 && num > -1) {
                try {
                    qg.setLoadingProgress({
                        progress: num
                    });
                }
                catch (f) {
                    XnhdAPI.logError("OppoLiteGame setLoadingProgress " + num.toString() + " fail >> " + f.toString());
                }
            }
            else {
                try {
                    qg.loadingComplete({
                        success: function (res) {
                        }
                    });
                }
                catch (f) {
                    XnhdAPI.logError("OppoLiteGame loadingComplete fail >> " + f.toString());
                }
            }
            // } else {
            //     if (num < 100 && num > -1) {
            //         if (Param.loadingPage != null) {
            //             Param.loadingPage = new Laya.Image("unpack/SprBlack.png");
            //             Param.loadingPage.zOrder = 10;
            //             Param.loadingPage.size(Laya.Browser.width, Laya.Browser.height);
            //             Laya.stage.addChild(Param.loadingPage);
            //             let imgWel = new Laya.Image("unpack/oppoLoading.png");
            //             imgWel.anchorX = 0.5;
            //             imgWel.anchorY = 0.5;
            //             imgWel.scale(XnhdAPI.Param.screenScale, XnhdAPI.Param.screenScale);
            //             Param.loadingPage.addChild(imgWel);
            //             imgWel.pos(Laya.Browser.width / 2, Laya.Browser.height / 2);
            //         }
            //     } else if (num >= 100) {
            //         Laya.Tween.to(Param.loadingPage, { alpha: 0 }, 500, null, Laya.Handler.create(this, () => {
            //             Param.loadingPage.destroy();
            //         }), 500)
            //     }
            // }
        }
        OppoLiteGameAPI.setLoadingProgress = setLoadingProgress;
        function saveDataToCache(key, content, isNumber) {
            if (isNumber) {
                content = content.toString();
            }
            localStorage.setItem(key, content);
        }
        OppoLiteGameAPI.saveDataToCache = saveDataToCache;
        function getDataFromCache(key, isInt) {
            var a = localStorage.getItem(key);
            if (isInt && a) {
                return parseInt(a);
            }
            return a;
        }
        OppoLiteGameAPI.getDataFromCache = getDataFromCache;
        var AdManager = /** @class */ (function () {
            function AdManager() {
                this._bannerAd = null;
                this._videoAd = null;
                this._bannerAdShow = false;
                this._videoAdLoaded = false;
                this._interstitialAdLoaded = false;
            }
            AdManager.prototype.getInterstitialAdStatus = function () {
                return this._interstitialAdLoaded;
            };
            AdManager.prototype.getVideoStatus = function () {
                return this._videoAdLoaded;
            };
            AdManager.prototype.init = function () {
                var _this = this;
                // XnhdAPI.logDebug("广告初始化开始")
                if (Param.advertiseInfo.mediaId.length > 0) {
                    qg.initAdService({
                        appId: Param.advertiseInfo.mediaId,
                        isDebug: true,
                        success: function (res) {
                            // XnhdAPI.logDebug("广告初始化完毕，开始初始化广告细项")
                            _this.initBannerAd();
                            _this.initInterstitialAd();
                            _this.initVideoAd();
                        },
                        fail: function (f) {
                            XnhdAPI.logDebug("fail:" + f);
                        },
                    });
                }
            };
            AdManager.prototype.initBannerAd = function () {
                var _this = this;
                if (Param.advertiseInfo.bannerAd.length > 0) {
                    // XnhdAPI.logDebug("初始化banner");
                    this._bannerAd = qg.createBannerAd({
                        posId: Param.advertiseInfo.bannerAd
                    });
                    this._bannerAd.onError(function (e) {
                        XnhdAPI.logError("OppoLite bannerAd load error >>" + JSON.stringify(e));
                    });
                    this._bannerAd.onHide(function (e) {
                        // XnhdAPI.logDebug("隐藏banner");
                        _this._bannerAdShow = false;
                    });
                }
            };
            AdManager.prototype.hideBannerAd = function () {
                if (Param.advertiseInfo.bannerAd.length > 0 && this._bannerAd) {
                    this._bannerAd.hide();
                }
            };
            AdManager.prototype.showOppoLiteBannerAd = function () {
                if (!this._bannerAdShow) {
                    this._bannerAdShow = true;
                    try {
                        this._bannerAd && this._bannerAd.show();
                    }
                    catch (e) {
                        XnhdAPI.logError("OppoLite bannerAd show error >>" + e.toString());
                    }
                }
            };
            AdManager.prototype.initInterstitialAd = function (successCallback) {
                var _this = this;
                if (successCallback === void 0) { successCallback = null; }
                if (Param.advertiseInfo.interstitialAd.length > 0) {
                    // XnhdAPI.logDebug("初始化Interstitial");
                    try {
                        this._interstitialAd = qg.createInsertAd({
                            posId: Param.advertiseInfo.interstitialAd
                        });
                        this._interstitialAd.onLoad(function (s) {
                            _this._interstitialAdLoaded = true;
                            // XnhdAPI.logDebug("Interstitial Load成功");
                            successCallback && successCallback();
                        });
                        this._interstitialAd.onError(function (e) {
                            XnhdAPI.logError("OppoLite interstitialAd load error >>" + JSON.stringify(e));
                            _this._interstitialAdLoaded = false;
                            Laya.timer.once(10000, _this, function () {
                                _this._interstitialAd.load(successCallback);
                            });
                        });
                        this._interstitialAd.load();
                    }
                    catch (e) {
                        XnhdAPI.logError("OppoLite interstitialAd onLoad error >>" + e.toString());
                    }
                }
            };
            AdManager.prototype.showOppoLiteInterstitialAd = function () {
                var _this = this;
                if (this._interstitialAd && this._interstitialAdLoaded) {
                    this._interstitialAd.onShow(function () {
                        _this._interstitialAd.offShow();
                        _this._interstitialAd.load();
                    });
                    this._interstitialAd.show();
                }
            };
            AdManager.prototype.initVideoAd = function () {
                var _this = this;
                if (Param.advertiseInfo.videoAd.length > 0) {
                    // XnhdAPI.logDebug("初始化视频");
                    try {
                        this._videoAd = qg.createRewardedVideoAd({
                            posId: Param.advertiseInfo.videoAd
                        });
                        this._videoAd.onLoad(function (s) {
                            // XnhdAPI.logDebug("视频缓存完毕");
                            _this._videoAdLoaded = true;
                        });
                        this._videoAd.onError(function (e) {
                            _this.videoErrorFun(e);
                        });
                        this._videoAd.load();
                    }
                    catch (e) {
                        XnhdAPI.logError("OppoLite videoAd init error >>" + e.toString());
                    }
                }
            };
            AdManager.prototype.videoErrorFun = function (e) {
                var _this = this;
                XnhdAPI.logDebug("OppoLite videoAd load error >>" + JSON.stringify(e));
                this._videoAdLoaded = false;
                // if (this._interstitialAdLoadNum < 20) {
                Laya.timer.once(30000, this, function () {
                    _this._videoAd.load();
                });
            };
            AdManager.prototype.showOppoLiteVideoAd = function (successCallback, failCallback) {
                var _this = this;
                if (successCallback === void 0) { successCallback = null; }
                if (failCallback === void 0) { failCallback = null; }
                if (this._videoAd && this._videoAdLoaded) {
                    this._videoAd.onVideoStart(function () {
                        _this._videoAd.offVideoStart();
                        _this._videoAdLoaded = false;
                        _this._videoAd.load();
                    });
                    this._videoAd.onClose(function (res) {
                        _this._videoAd.offClose();
                        XnhdAPI.logDebug('OPPO小游戏获得视频奖励：' + JSON.stringify(res));
                        res && res.isEnded && successCallback && successCallback();
                    });
                    this._videoAd.show();
                }
                else {
                    failCallback && failCallback();
                }
            };
            AdManager.Default = new AdManager();
            return AdManager;
        }());
        OppoLiteGameAPI.AdManager = AdManager;
        var Battle = /** @class */ (function () {
            function Battle() {
            }
            /**
             * success(res) 回调函数
             * code	string	状态code
             * message	string	返回的消息
             * pkgName	string	游戏包名
             * tableId	string	分配的桌子id
             * tableToken	string	分配的桌子token
             * players	Array	用户列表
             *
             * uid	string	临时分配的用户id，该id不是为真实用户uid
             * name	string	昵称
             * headIcon	string	头像
             * sex	string	性别 ，M为男性，F为女性
             * tag	number	0:正常用户, 1: ai机器人
             * @param callback
             */
            Battle.prototype.init = function (callback) {
                var _this = this;
                login(function () {
                    XnhdAPI.logDebug("获取对战对象");
                    _this._Battle = qg.getBattle();
                    XnhdAPI.logDebug("设置常用回调");
                    _this._Battle.onGameStart(function (r) {
                        XnhdAPI.logDebug("对战开始" + JSON.stringify(r));
                        _this._gameStartCallback && _this._gameStartCallback(r);
                    });
                    _this._Battle.onMessage(function (m) {
                        _this._gameMsgCallback && _this._gameMsgCallback(m);
                    });
                    _this.battleInit(callback);
                });
            };
            Battle.prototype.battleInit = function (callback) {
                XnhdAPI.logDebug("开始初始化对战");
                this._Battle.init({
                    success: function (res) {
                        XnhdAPI.logDebug("对战初始化成功" + JSON.stringify(res));
                        callback(res);
                    },
                    fail: function (f) {
                        XnhdAPI.logDebug("对战初始化失败" + JSON.stringify(f));
                    }
                });
            };
            Battle.prototype.setGameStartFun = function (callback) {
                this._gameStartCallback = callback;
            };
            Battle.prototype.setOnMessage = function (callback) {
                this._gameMsgCallback = callback;
            };
            Battle.prototype.postMessage = function (msg) {
                this._Battle.postMessage({
                    type: 1,
                    data: msg
                });
            };
            Battle.prototype.updateMsg = function () {
            };
            Battle.prototype.quitGame = function (result) {
                var _status = result === 1 ? 2 : result === 2 ? 4 : 3;
                this._Battle.postGameStatus({
                    status: _status
                });
            };
            Battle.prototype.game_Ready = function (_data) {
                this._Battle.postGameStatus({
                    status: 1,
                    data: _data,
                    success: function () {
                        XnhdAPI.logDebug("init ok");
                    }
                });
            };
            Battle.Manager = new Battle;
            return Battle;
        }());
        OppoLiteGameAPI.Battle = Battle;
    })(OppoLiteGameAPI = XnhdAPI.OppoLiteGameAPI || (XnhdAPI.OppoLiteGameAPI = {}));
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=OppoLiteGameAPI.js.map