var XnhdAPI;
(function (XnhdAPI) {
    var VivoLiteGameAPI;
    (function (VivoLiteGameAPI) {
        var Param = /** @class */ (function () {
            function Param() {
            }
            Param.labelAdjustX = 10;
            Param.labelAdjustY = 10;
            Param.userInfo = {
                openid: "",
                id: "",
                unionid: "",
                nickname: "",
                avatar: Object,
            };
            Param.appInfo = {
                packageName: "",
                CpID: "",
                AppID: ""
            };
            Param.temp = {
                token: "",
            };
            Param.advertiseInfo = {
                bannerAd: "",
                interstitialAd: ""
            };
            Param.callback = {
                onShow: null,
                onHide: null
            };
            return Param;
        }());
        VivoLiteGameAPI.Param = Param;
        function exitProgram() {
            qg.exitApplication();
        }
        VivoLiteGameAPI.exitProgram = exitProgram;
        function init(vivoLiteGameConfig, callback) {
            Param.appInfo.packageName = vivoLiteGameConfig.packageName;
            Param.appInfo.CpID = vivoLiteGameConfig.CpID;
            Param.appInfo.AppID = vivoLiteGameConfig.AppID;
            Param.advertiseInfo.bannerAd = vivoLiteGameConfig.bannerAd;
            Param.advertiseInfo.interstitialAd = vivoLiteGameConfig.interstitialAd;
            // Laya.Browser.window.qg.onAudioInterruptionEnd(f => {
            //     core.GameAudioManager.Default.playMusic()
            // })
            AdManager.Default.init();
            setLoadingProgress(0);
            qg.onShow(function (s) {
                Param.callback.onShow && Param.callback.onShow(s);
            });
            qg.onHide(function (h) {
                Param.callback.onHide && Param.callback.onHide(h);
            });
            if (qg.getSystemInfoSync().platformVersionCode > 1040) {
                Param.labelAdjustX = 0;
                Param.labelAdjustY = 0;
            }
            callback && callback();
        }
        VivoLiteGameAPI.init = init;
        function setOnShow(callback) {
            Param.callback.onShow = callback;
        }
        VivoLiteGameAPI.setOnShow = setOnShow;
        function setOnHide(callback) {
            Param.callback.onHide = callback;
        }
        VivoLiteGameAPI.setOnHide = setOnHide;
        function setLoadingProgress(num) {
            if (num < 100) {
                var a = Laya.stage.getChildByName("vivoLoading");
                if (a) {
                }
                else {
                    var imgWel = new Laya.Image("unpack/Loading.png");
                    imgWel.name = "vivoLoading";
                    imgWel.zOrder = 10;
                    imgWel.centerX = 0;
                    imgWel.centerY = 0;
                    Laya.stage.addChild(imgWel);
                }
            }
            else {
                try {
                    var loadingImg_1 = Laya.stage.getChildByName("vivoLoading");
                    if (loadingImg_1) {
                        Laya.Tween.to(loadingImg_1, { alpha: 0 }, 1000, null, Laya.Handler.create(this, function () {
                            loadingImg_1.destroy();
                        }));
                    }
                }
                catch (e) {
                }
            }
        }
        VivoLiteGameAPI.setLoadingProgress = setLoadingProgress;
        function saveDataToCache(key, content, isInt) {
            if (isInt) {
                content = content.toString();
            }
            // Laya.LocalStorage.setItem(key, content)
            Laya.Browser.window.qg.setStorage({
                key: key,
                value: content,
                success: function (data) {
                    XnhdAPI.logError("Vivo saveDataToCache " + key + " success");
                },
                fail: function (data, code) {
                    XnhdAPI.logError("Vivo saveDataToCache " + key + (" code = " + code));
                }
            });
        }
        VivoLiteGameAPI.saveDataToCache = saveDataToCache;
        function getDataFromCache(key, isInt) {
            // let a = Laya.LocalStorage.getItem(key);
            var a = Laya.Browser.window.qg.getStorageSync({
                key: key
            });
            if (isInt && a) {
                return parseInt(a);
            }
            return a;
        }
        VivoLiteGameAPI.getDataFromCache = getDataFromCache;
        function adjustLabel(labelArr) {
            for (var i = 0; i < labelArr.length; i++) {
                labelArr[i].x += Param.labelAdjustX;
                labelArr[i].y += Param.labelAdjustY;
            }
        }
        VivoLiteGameAPI.adjustLabel = adjustLabel;
        var AdManager = /** @class */ (function () {
            function AdManager() {
                this._bannerAd = null;
                this._interstitialAd = null;
                this._bannerAdLoaded = false;
                this._interstitialAdLoaded = false;
            }
            AdManager.prototype.init = function () {
                if (Laya.Browser.window.qg.getSystemInfoSync().platformVersionCode < 1031) {
                    XnhdAPI.logError("不支持广告");
                }
                else {
                    // 支持广告
                    this.initBannerAd();
                    this.initInterstitialAd();
                }
            };
            AdManager.prototype.initBannerAd = function () {
                var _this = this;
                try {
                    if (Param.advertiseInfo.bannerAd.length > 5) {
                        this._bannerAd = Laya.Browser.window.qg.createBannerAd({
                            posId: Param.advertiseInfo.bannerAd,
                            style: {}
                        });
                        this._bannerAd.onLoad(function (res) {
                            _this._bannerAdLoaded = true;
                        });
                        this._bannerAd.onError(function (err) {
                            XnhdAPI.logError("Banner广告拉取失败" + JSON.stringify(err));
                        });
                    }
                }
                catch (e) {
                    XnhdAPI.logError('Banner广告创建失败' + e.toString());
                }
            };
            AdManager.prototype.initInterstitialAd = function () {
                var _this = this;
                try {
                    if (Param.advertiseInfo.interstitialAd.length > 5) {
                        this._interstitialAd = Laya.Browser.window.qg.createInterstitialAd({
                            posId: Param.advertiseInfo.interstitialAd
                        });
                        this._interstitialAd.onLoad(function (res) {
                            XnhdAPI.logError("interstitial广告拉取成功");
                            _this._interstitialAdLoaded = true;
                        });
                        this._interstitialAd.onError(function (err) {
                            XnhdAPI.logError("interstitial广告拉取失败" + JSON.stringify(err));
                            Laya.timer.once(30000, _this, function () {
                                _this._interstitialAd.load();
                            });
                        });
                    }
                }
                catch (e) {
                    XnhdAPI.logError('interstitial广告创建失败' + e.toString());
                }
            };
            AdManager.prototype.getInterstitialAdStatus = function () {
                return this._interstitialAdLoaded;
            };
            AdManager.prototype.showBannerAd = function (positionY, delay) {
                if (delay === void 0) { delay = 60; }
                if (this._bannerAd && this._bannerAdLoaded) {
                    this._bannerAd.show();
                }
                else {
                    Laya.timer.frameOnce(delay, this, this.showBannerAd, [positionY, 2 * delay]);
                }
            };
            AdManager.prototype.hideBannerAd = function () {
                this._bannerAd && this._bannerAd.hide();
            };
            AdManager.prototype.showInterstitialAd = function (successCallback, failCallback) {
                var _this = this;
                if (this._interstitialAd && this._interstitialAdLoaded) {
                    this._interstitialAd.onClose(function (res) {
                        _this._interstitialAd.offClose();
                        _this._interstitialAdLoaded = false;
                        successCallback && successCallback();
                    });
                    this._interstitialAd.show();
                }
                else {
                    failCallback && failCallback();
                }
            };
            AdManager.Default = new AdManager();
            return AdManager;
        }());
        VivoLiteGameAPI.AdManager = AdManager;
    })(VivoLiteGameAPI = XnhdAPI.VivoLiteGameAPI || (XnhdAPI.VivoLiteGameAPI = {}));
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=VivoLiteGameAPI.js.map