var XnhdAPI;
(function (XnhdAPI) {
    var VivoPKGameAPI;
    (function (VivoPKGameAPI) {
        var Param = /** @class */ (function () {
            function Param() {
            }
            Param.appInfo = {
                version: 2,
                gameId: 0,
                gameKey: "",
                gameSecret: ""
            };
            Param.sendURL = ["gamebattleapi.vivo.com.cn:80", "43.255.230.242:10024"];
            return Param;
        }());
        VivoPKGameAPI.Param = Param;
        function init(vivoLiteGameConfig, callback) {
            Param.appInfo.gameId = vivoLiteGameConfig.GameID;
            Param.appInfo.gameKey = vivoLiteGameConfig.GameKey;
            Param.appInfo.gameSecret = vivoLiteGameConfig.GameSecret;
            GameSDK.setOnInitCB(function (e) {
                // XnhdAPI.logDebug("vivoPKGame初始化：" + JSON.stringify(e))
                if (e.error === 0) {
                    GameSDK.setOrientation(1);
                    GameSDK.setOnRoomInfoCB(function (e) {
                        // XnhdAPI.logDebug("从vivo平台处拿到的getRoomInfo = " + JSON.stringify(e))
                        if (e.error === 0) {
                            Param.getRoomCallback && Param.getRoomCallback(e);
                        }
                        else {
                            GameSDK.getRoomInfo();
                        }
                    });
                    GameSDK.setOnReadyCB(function (e) {
                        Param.gameReadyCallback && Param.gameReadyCallback(e);
                    });
                    GameSDK.setOnStartCB(function () {
                        GameSDK.hideLoadProgress();
                        Param.gameStartCallback && Param.gameStartCallback();
                    });
                    GameSDK.setOnMessageCB(function (e) {
                        Param.gameMsgCallback && Param.gameMsgCallback(e);
                    });
                    GameSDK.setOnFinishCB(function (e) {
                        Param.gameFinishCallback && Param.gameFinishCallback(e);
                    });
                    GameSDK.setOnPauseCB(function () {
                        // core.SceneManager.Default.curScene && core.GameAudioManager.Default.stopAll();
                        // XnhdAPI.logDebug("触发了游戏暂停，停止音效，停止计时器");
                        Laya.timer.scale = 0;
                    });
                    GameSDK.setOnResumeCB(function (e) {
                        Laya.timer.scale = 1;
                        // XnhdAPI.logDebug("触发了游戏恢复，播放音乐，打开计时器");
                        core.SceneManager.Default.getCurScene() && core.AudioAndSetting.Manager.playMusic();
                    });
                    callback();
                }
                else {
                    GameSDK.init(Param.appInfo.version, Param.appInfo.gameId, Param.appInfo.gameKey, Param.appInfo.gameSecret);
                }
            });
            GameSDK.init(Param.appInfo.version, Param.appInfo.gameId, Param.appInfo.gameKey, Param.appInfo.gameSecret);
        }
        VivoPKGameAPI.init = init;
        function setPKLoadingProgress(num) {
            if (num < 101 && num > -1) {
                try {
                    num < 1 && (num = 1);
                    num > 100 && (num = 100);
                    GameSDK.setLoadProgress(num);
                }
                catch (f) {
                    XnhdAPI.logError("vivoPKGame setLoadingProgress " + num.toString() + " fail >> " + f.toString());
                }
            }
            else {
                try {
                    GameSDK.setAudio(1, 100);
                }
                catch (f) {
                    XnhdAPI.logError("vivoPKGame loadingComplete fail >> " + f.toString());
                }
            }
        }
        VivoPKGameAPI.setPKLoadingProgress = setPKLoadingProgress;
        function getRoomInfo(callback) {
            if (callback === void 0) { callback = null; }
            Param.getRoomCallback = callback;
            GameSDK.getRoomInfo();
        }
        VivoPKGameAPI.getRoomInfo = getRoomInfo;
        function gameReady(readyMsg) {
            GameSDK.ready(readyMsg);
        }
        VivoPKGameAPI.gameReady = gameReady;
        function setGameReadyFunc(callback) {
            if (callback === void 0) { callback = null; }
            Param.gameReadyCallback = callback;
        }
        VivoPKGameAPI.setGameReadyFunc = setGameReadyFunc;
        function setGameStartFunc(callback) {
            if (callback === void 0) { callback = null; }
            Param.gameStartCallback = callback;
        }
        VivoPKGameAPI.setGameStartFunc = setGameStartFunc;
        function setGameMsgFunc(callback) {
            if (callback === void 0) { callback = null; }
            Param.gameMsgCallback = callback;
        }
        VivoPKGameAPI.setGameMsgFunc = setGameMsgFunc;
        function setOnFinishFunc(callback) {
            if (callback === void 0) { callback = null; }
            Param.gameFinishCallback = callback;
        }
        VivoPKGameAPI.setOnFinishFunc = setOnFinishFunc;
        function updateGameResult(win) {
            GameSDK.gameOver(win);
        }
        VivoPKGameAPI.updateGameResult = updateGameResult;
        function quitGame(result) {
            /**
             * 废弃quit，用finish
             */
            // GameSDK.quit(reason);
            GameSDK.finish(result);
        }
        VivoPKGameAPI.quitGame = quitGame;
        function sendMsg(msg) {
            GameSDK.broadcast(msg, 0);
        }
        VivoPKGameAPI.sendMsg = sendMsg;
    })(VivoPKGameAPI = XnhdAPI.VivoPKGameAPI || (XnhdAPI.VivoPKGameAPI = {}));
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=VivoPKGameAPI.js.map