var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var XnhdAPI;
(function (XnhdAPI) {
    var XnhdWxPush;
    (function (XnhdWxPush) {
        /**
         * 显示大Banner，父节点必须是一个空image，根据父节点size决定banner内容分布
         * @param parent 父节点必须是一个空image，根据父节点size决定banner内容分布
         */
        function showBigBanner(parent, failShowBanner) {
            if (failShowBanner === void 0) { failShowBanner = true; }
            if (canShow()) {
                pushManager.Inst.delayShow_otherApp(function () {
                    parent.skin = '';
                    Param.bigBanner.parent && Param.bigBanner.destroy();
                    Param.bigBanner.init(parent);
                });
                return Param.bigBanner;
            }
            else if (failShowBanner) {
                XnhdAPI.showBannerAd(XnhdAPI.Param.screenHeight - 230);
            }
        }
        XnhdWxPush.showBigBanner = showBigBanner;
        /**
         * 显示底部Banner，父节点必须是一个空image，自动靠边屏幕左侧
         * @param parent 父节点必须是一个空image
         */
        function showBotBanner(parent, failShowBanner) {
            if (failShowBanner === void 0) { failShowBanner = true; }
            if (canShow()) {
                pushManager.Inst.delayShow_otherApp(function () {
                    parent.skin = '';
                    Param.botBanner.parent && Param.botBanner.destroy();
                    Param.botBanner.init(parent);
                });
                return Param.botBanner;
            }
            else if (failShowBanner) {
                XnhdAPI.showBannerAd(XnhdAPI.Param.screenHeight - 230);
            }
        }
        XnhdWxPush.showBotBanner = showBotBanner;
        /**
         * 隐藏底部Banner
         */
        function hideBotBanner() {
            Param.botBanner && Param.botBanner.parent && Param.botBanner.destroy();
        }
        XnhdWxPush.hideBotBanner = hideBotBanner;
        /**
         * 显示抽屉式drawer的btn入口，父节点必须是一个空image，根据父节点pos决定draweIcon显示位置
         * @param parent 父节点必须是一个空Image
         * @param closeCallback 关闭drawView时需要执行的方法
         * @param tittle 顶部标题文字
         */
        function showDrawBtn(parent, closeCallback, tittle) {
            if (closeCallback === void 0) { closeCallback = null; }
            if (tittle === void 0) { tittle = ""; }
            if (canShow()) {
                Param.closeCallback.drawView = closeCallback;
                pushManager.Inst.delayShow_otherApp(function () {
                    parent.skin = '';
                    Param.drawBtn && Param.drawBtn.destroy();
                    Param.drawBtn.init(parent, closeCallback);
                });
                return Param.drawBtn;
            }
        }
        XnhdWxPush.showDrawBtn = showDrawBtn;
        /**
         * 显示抽屉式drawerView
         * @param closeCallback 关闭drawView时需要执行的方法
         * @param tittle 顶部标题文字
         */
        function showDrawView(closeCallback, tittle) {
            if (closeCallback === void 0) { closeCallback = null; }
            if (tittle === void 0) { tittle = ""; }
            if (canShow()) {
                Param.closeCallback.drawView = closeCallback;
                pushManager.Inst.delayShow_otherApp(function () {
                    Param.drawView && Param.drawView.destroy();
                    Param.drawView.init();
                });
                return Param.drawView;
            }
        }
        XnhdWxPush.showDrawView = showDrawView;
        /**
         * 显示摇晃式Icon，父节点必须是一个空image，根据父节点pos决定icon显示位置
         * @param parent 父节点必须是一个空Image
         */
        function showShakeIcon(parent) {
            if (canShow()) {
                pushManager.Inst.delayShow_ShakeIcon(function () {
                    parent.skin = '';
                    Param.shakeIcon && Param.shakeIcon.destroy();
                    Param.shakeIcon.init(parent);
                });
                return Param.shakeIcon;
            }
        }
        XnhdWxPush.showShakeIcon = showShakeIcon;
        /**
         * 显示退出Icon，父节点必须是一个空image，根据父节点pos决定icon显示位置
         * @param pannel 父节点必须是一个空Image
         */
        function showExitBtn(parent, closeCallback) {
            if (closeCallback === void 0) { closeCallback = null; }
            if (canShow()) {
                Param.closeCallback.exitView = closeCallback;
                pushManager.Inst.delayShow_otherApp(function () {
                    parent.skin = '';
                    Param.exitBtn && Param.exitBtn.destroy();
                    Param.exitBtn.init(parent);
                });
                return Param.exitBtn;
            }
        }
        XnhdWxPush.showExitBtn = showExitBtn;
        function wxPushInit(data) {
            pushManager.Inst.initPushData(data);
        }
        XnhdWxPush.wxPushInit = wxPushInit;
        function canShow() {
            return XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1 && XnhdAPI.WxLiteGameAPI.checkVerify() && XnhdAPI.WxLiteGameAPI.Param.appInfo.customADType === 0 && pushManager.Inst.initAdv();
        }
        var Param = /** @class */ (function () {
            function Param() {
            }
            Param.closeCallback = {
                exitView: null,
                drawView: null,
            };
            return Param;
        }());
        var pushManager = /** @class */ (function () {
            function pushManager() {
            }
            pushManager.prototype.initAdv = function () {
                if (Param.shakeIcon) { }
                else {
                    Param.bigBanner = new bigBanner;
                    Param.botBanner = new botBanner;
                    Param.drawBtn = new drawerIcon;
                    Param.shakeIcon = new advIcon;
                    Param.exitBtn = new exitIcon;
                    Param.exitView = new exitView;
                    Param.drawView = new drawerView;
                }
                return true;
            };
            pushManager.prototype.delayShow_ShakeIcon = function (callback) {
                if (this.mainAdv) {
                    callback();
                }
                else {
                    var r = XnhdAPI.Tools.randomInt(5, 15);
                    Laya.timer.frameOnce(r, this, this.delayShow_ShakeIcon, [callback]);
                }
            };
            pushManager.prototype.delayShow_otherApp = function (callback) {
                if (this.appList && this.appList.length) {
                    callback();
                }
                else {
                    var r = XnhdAPI.Tools.randomInt(5, 15);
                    Laya.timer.frameOnce(r, this, this.delayShow_otherApp, [callback]);
                }
            };
            pushManager.prototype.getAppList = function () {
                if (this.appList && this.appList.length) {
                    return JSON.parse(JSON.stringify(this.appList));
                }
                return [];
            };
            pushManager.prototype.getAdvData = function () {
                if (this.mainAdv) {
                    return JSON.parse(JSON.stringify(this.mainAdv));
                }
                return null;
            };
            pushManager.prototype.initPushData = function (e) {
                var _this = this;
                this.mainAdv = this.formatData(e.adv);
                Laya.loader.load(this.mainAdv.skin, Laya.Handler.create(this, function () {
                    _this.mainAdv.skinCache = true;
                }));
                this.appList = [];
                var _loop_1 = function (i) {
                    var a = this_1.formatData(e.appList[i]);
                    if (a.appid != XnhdAPI.WxLiteGameAPI.Param.appInfo.appid) {
                        Laya.loader.load(a.skin, Laya.Handler.create(this_1, function () {
                            a.skinCache = true;
                        }));
                        this_1.appList.push(a);
                    }
                };
                var this_1 = this;
                for (var i in e.appList) {
                    _loop_1(i);
                }
            };
            pushManager.prototype.formatData = function (originalData) {
                return {
                    appid: this.turnString(originalData.appid),
                    name: this.turnString(originalData.appname),
                    skin: this.turnString(originalData.icon),
                    qrcode: this.turnString(originalData.qrcode),
                    path: this.turnString(originalData.path),
                    description: this.turnString(originalData.desc),
                    pv: typeof originalData.pv === "string" ? originalData.pv : Math.floor(originalData.pv / 10000).toString() + "万人在玩",
                    statid: this.turnString(originalData.statid),
                    skinCache: false,
                };
            };
            pushManager.prototype.turnString = function (data) {
                return typeof data === "string" ? data : "";
            };
            pushManager.Inst = new pushManager;
            return pushManager;
        }());
        var bigBanner = /** @class */ (function (_super) {
            __extends(bigBanner, _super);
            function bigBanner() {
                var _this = _super.call(this) || this;
                _this._iconStyle = 1;
                _this._iconBgArr = [];
                _this.skin = "unpack/xnhdPush/bigBanner_skin.png";
                _this.sizeGrid = "30,30,30,30,0";
                _this._upper = new Laya.Image("unpack/xnhdPush/bigBanner_upper.png");
                _this._upper.sizeGrid = "0,20,0,20,0";
                _this._upperZi = new Laya.Image("unpack/xnhdPush/bigBanner_zi.png");
                _this._upperZi.anchorX = 0.5;
                _this._upperZi.anchorY = 0.5;
                _this.addChild(_this._upper);
                _this._upperZi.size(583, 48);
                _this._upper.addChild(_this._upperZi);
                return _this;
            }
            bigBanner.prototype.init = function (parant) {
                parant.addChild(this);
                this.size(parant.width, parant.height);
                this._upper.width = this.width;
                this._upper.height = 75;
                var _scale = this._upper.width / this._upperZi.width;
                _scale > 1 && (_scale = 1);
                this._upperZi.scale(_scale, _scale);
                this._upperZi.pos(this._upper.width / 2, this._upper.height / 2);
                var _iMax = Math.floor((this.height - 85) / 260);
                var _jMax = Math.floor((this.width - 20) / 200);
                if (_jMax > 0 && _iMax > 0) {
                    var _widthPiece = Math.floor((this.width - 20) / _jMax);
                    var _heightPiece = Math.floor((this.height - 85) / _iMax);
                    var _iconNum = _jMax * _iMax;
                    var appList = pushManager.Inst.getAppList();
                    appList.sort(function (a, b) {
                        return XnhdAPI.Tools.randomInt(0, 1) * 2 - 1;
                    });
                    for (var i = 0; i < _iMax; i++) {
                        for (var j = 0; j < _jMax; j++) {
                            if (appList.length > 0) {
                                var _bg = new Laya.Image("unpack/xnhdPush/bigBanner_iconBg.png");
                                _bg.sizeGrid = "25,25,25,25,0";
                                _bg.size(160, 220);
                                this.addChild(_bg);
                                _bg.pos(j * _widthPiece + 10 + (_widthPiece - 160) / 2, i * _heightPiece + 75 + (_heightPiece - 220) / 2);
                                this._iconBgArr.push(_bg);
                                var _icon = Laya.Pool.getItemByClass("gameIcon", gameIcon);
                                _bg.addChild(_icon);
                                _icon.size(_bg.width, _bg.height);
                                _icon.pos(0, 0);
                                _icon.initData(appList.shift(), this._iconStyle);
                                _icon.setMonitorOn();
                            }
                        }
                    }
                }
            };
            bigBanner.prototype.destroy = function () {
                for (var i = 0; i < this._iconBgArr.length; i++) {
                    this._iconBgArr[i].destroy();
                }
                this._iconBgArr = [];
                this.removeSelf();
                XnhdAPI.hideBannerAd();
            };
            return bigBanner;
        }(Laya.Image));
        var botBanner = /** @class */ (function (_super) {
            __extends(botBanner, _super);
            function botBanner() {
                var _this = _super.call(this) || this;
                _this._iconStyle = 2;
                _this._pannelMoveNum = 120;
                _this._V = 1;
                _this._needMove = true;
                _this._allIconWidth = 0;
                _this._curPannelX = 0;
                _this._lastMouseX = 0;
                _this.size(750, 220);
                var a = new Laya.Image('unpack/xnhdPush/botBanner_frame.png');
                a.pos(33, 20);
                a.size(684, 180);
                _this.addChild(a);
                // let b = new Laya.Image('unpack/xnhdPush/botBanner_zi.png');
                // b.pos(11, 20);
                // b.size(49, 193);
                // this.addChild(b);
                var c = new Laya.Image('unpack/xnhdPush/botBannerBg.png');
                c.pos(10, 10);
                c.size(a.width - 20, a.height - 20);
                a.addChild(c);
                _this._pannel = new Laya.Panel;
                _this._pannel.pos(c.x, c.y);
                _this._pannel.size(c.width, c.height);
                a.addChild(_this._pannel);
                return _this;
            }
            botBanner.prototype.init = function (parent) {
                parent.addChild(this);
                parent.size(750, 220);
                this._pannel.hScrollBarSkin = 'unpack/xnhdPush/hscroll.png';
                var appList = pushManager.Inst.getAppList();
                appList.sort(function (a, b) {
                    return XnhdAPI.Tools.randomInt(0, 1) * 2 - 1;
                });
                var num = appList.length;
                for (var i = 0; i < num; i++) {
                    var _icon = Laya.Pool.getItemByClass("gameIcon", gameIcon);
                    this._pannel.addChild(_icon);
                    _icon.size(126, 150);
                    _icon.initData(appList[i], this._iconStyle);
                    if (num > 3) {
                        _icon.pos(10 + i * 136, 5);
                        this._allIconWidth = _icon.x + 146 - this._pannel.width;
                    }
                    else {
                        var k = Math.floor(this._pannel.width / num);
                        _icon.pos(k * i + (k - 136) / 2, 5);
                    }
                    _icon.setMonitorOn();
                }
                if (num > 3) {
                    var c = new Laya.Image('unpack/xnhdPush/botBannerBg.png');
                    c.pos(this._allIconWidth + this._pannel.width, 13);
                    c.size(1, 144);
                    this._pannel.addChild(c);
                    Laya.timer.frameLoop(1, this, this.allIconMoveLoop);
                    this.resetPannelMoveNum();
                    this.monitorOn();
                }
            };
            botBanner.prototype.allIconMoveLoop = function () {
                if (this._needMove) {
                    if (this._pannelMoveNum) {
                        this._pannelMoveNum--;
                    }
                    else {
                        this._curPannelX += this._V;
                        if (this._curPannelX < 0) {
                            this.resetPannelMoveNum();
                            this.setV(false);
                        }
                        else if (this._curPannelX > this._allIconWidth) {
                            this.resetPannelMoveNum();
                            this.setV(true);
                        }
                        this._pannel.scrollTo(this._curPannelX);
                    }
                }
            };
            botBanner.prototype.monitorOn = function () {
                this._pannel.on(Laya.Event.MOUSE_DOWN, this, this.playerPress);
                Laya.stage.on(Laya.Event.MOUSE_UP, this, this.playerRelease);
            };
            botBanner.prototype.playerPress = function () {
                this._needMove = false;
                this._lastMouseX = Laya.stage.mouseX;
            };
            botBanner.prototype.playerRelease = function () {
                this.resetPannelMoveNum();
                this._needMove = true;
                if (this._lastMouseX > Laya.stage.mouseX) {
                    this.setV(false);
                }
                else if (this._lastMouseX < Laya.stage.mouseX) {
                    this.setV(true);
                }
                this._curPannelX = this._pannel.hScrollBar.value;
            };
            botBanner.prototype.setV = function (left) {
                this._V = left ? -1 : 1;
            };
            botBanner.prototype.resetPannelMoveNum = function () {
                this._pannelMoveNum = 120;
            };
            botBanner.prototype.destroy = function () {
                this._pannel.destroyChildren();
                this._pannel.off(Laya.Event.MOUSE_DOWN, this, this.playerPress);
                this._pannel.scrollTo(0);
                Laya.stage.off(Laya.Event.MOUSE_UP, this, this.playerRelease);
                this.removeSelf();
                XnhdAPI.hideBannerAd();
            };
            return botBanner;
        }(Laya.Image));
        var drawerIcon = /** @class */ (function (_super) {
            __extends(drawerIcon, _super);
            function drawerIcon() {
                var _this = _super.call(this) || this;
                _this.skin = 'unpack/xnhdPush/drawerIcon.png';
                _this.size(75, 60);
                _this.anchorY = 0.5;
                _this._redPot = new Laya.Image('unpack/xnhdPush/redPot.png');
                _this.addChild(_this._redPot);
                _this._redPot.pos(55, -2);
                return _this;
            }
            drawerIcon.prototype.init = function (parent, closeCallback) {
                parent.addChild(this);
                parent.size(75, 60);
                this._redPot.visible = true;
                this.scale(1, 1);
                this.y = 37;
                this.on(Laya.Event.MOUSE_DOWN, this, this.showDrawView, [closeCallback]);
                Laya.timer.frameLoop(600, this, this.shakeLoop);
            };
            drawerIcon.prototype.shakeLoop = function () {
                var _this = this;
                var duration = 60;
                var _loop_2 = function (i) {
                    var _s = Math.abs(Math.sin(Math.PI * 2 / duration * i)) * 0.15 + 1;
                    Laya.timer.frameOnce(i + 1, this_2, function () {
                        _this.scale(_s, _s);
                    });
                };
                var this_2 = this;
                for (var i = 0; i < duration; i++) {
                    _loop_2(i);
                }
                Laya.timer.frameOnce(duration, this, function () {
                    _this.scale(1, 1);
                });
            };
            drawerIcon.prototype.showDrawView = function (closeCallback) {
                this._redPot.visible = false;
                showDrawView(closeCallback);
            };
            drawerIcon.prototype.destroy = function () {
                this.off(Laya.Event.MOUSE_DOWN, this, this.showDrawView);
                Laya.timer.clear(this, this.shakeLoop);
                this.removeSelf();
            };
            return drawerIcon;
        }(Laya.Image));
        var drawerView = /** @class */ (function (_super) {
            __extends(drawerView, _super);
            function drawerView() {
                var _this = _super.call(this) || this;
                _this._iconStyle = 3;
                _this._bg = new Laya.Image("unpack/xnhdPush/SprBlack.png");
                _this.addChild(_this._bg);
                _this._bg.alpha = 0.8;
                _this._bg.size(750, 1624);
                _this._bg.sizeGrid = "10,10,10,10,0";
                _this._bg.on(Laya.Event.CLICK, _this, function (e) {
                    e.stopPropagation();
                });
                _this._centerView = new Laya.Image('unpack/xnhdPush/bigBanner_skin.png');
                _this.addChild(_this._centerView);
                _this._centerView.sizeGrid = '30,30,30,30,0';
                _this._centerView.size(548, 616);
                _this._centerView.x = 101;
                var c = new Laya.Image('unpack/xnhdPush/bigBanner_upper.png');
                c.sizeGrid = "0,20,0,20,0";
                c.size(548, 75);
                _this._centerView.addChild(c);
                _this._closeBtn = new Laya.Image('unpack/xnhdPush/img_close.png');
                _this._closeBtn.size(59, 59);
                _this._closeBtn.pos(8, 8);
                _this._centerView.addChild(_this._closeBtn);
                var b = new Laya.Image('unpack/xnhdPush/drawer_zi.png');
                b.pos(140, 11);
                _this._centerView.addChild(b);
                _this._refreshBtn = new Laya.Image('unpack/xnhdPush/drawer_refresh.png');
                _this.addChild(_this._refreshBtn);
                _this._refreshBtn.x = 210;
                _this._allIconLayer = new Laya.Image;
                _this._centerView.addChild(_this._allIconLayer);
                _this._allIconLayer.pos(9, 75);
                return _this;
            }
            drawerView.prototype.init = function () {
                Laya.stage.addChild(this);
                XnhdAPI.WxLiteGameAPI.AdManager.Default.hideWxLiteGameBannerAd();
                this.scale(XnhdAPI.Param.screenScale, XnhdAPI.Param.screenScale);
                this._centerView.y = (XnhdAPI.Param.screenHeight - this._centerView.height) / 2;
                this._refreshBtn.y = this._centerView.y + 660;
                this._closeBtn.once(Laya.Event.CLICK, this, this.destroy);
                this._refreshBtn.on(Laya.Event.CLICK, this, this.refreshAllIcon);
                this.refreshAllIcon();
            };
            drawerView.prototype.refreshAllIcon = function () {
                this._allIconLayer.destroyChildren();
                var appList = pushManager.Inst.getAppList();
                appList.sort(function (b, a) {
                    return XnhdAPI.Tools.randomInt(0, 1) * 2 - 1;
                });
                for (var i = 0; i < 9; i++) {
                    if (i > appList.length - 1) {
                        break;
                    }
                    var _icon = Laya.Pool.getItemByClass("gameIcon", gameIcon);
                    this._allIconLayer.addChild(_icon);
                    _icon.size(144, 144);
                    _icon.initData(appList[i], this._iconStyle);
                    _icon.pos(25 + (i % 3) * 169, 25 + Math.floor(i / 3) * 169);
                    _icon.setMonitorOn();
                }
            };
            drawerView.prototype.destroy = function () {
                this._allIconLayer.destroyChildren();
                this.removeSelf();
                Param.closeCallback.drawView && Param.closeCallback.drawView();
            };
            return drawerView;
        }(Laya.Image));
        var exitIcon = /** @class */ (function (_super) {
            __extends(exitIcon, _super);
            function exitIcon() {
                var _this = _super.call(this) || this;
                _this.skin = 'unpack/xnhdPush/backBtn.png';
                return _this;
            }
            exitIcon.prototype.init = function (parent) {
                parent.addChild(this);
                this.on(Laya.Event.MOUSE_DOWN, this, this.openExitView);
            };
            exitIcon.prototype.openExitView = function () {
                Param.exitView.init();
            };
            exitIcon.prototype.destroy = function () {
                this.off(Laya.Event.MOUSE_DOWN, this, this.openExitView);
                this.removeSelf();
            };
            return exitIcon;
        }(Laya.Image));
        var exitView = /** @class */ (function (_super) {
            __extends(exitView, _super);
            function exitView() {
                var _this = _super.call(this) || this;
                _this._iconStyle = 4;
                _this._iconBgArr = [];
                _this.skin = 'unpack/xnhdPush/SprBlack.png';
                _this.size(750, 1624);
                _this.on(Laya.Event.CLICK, _this, function (e) {
                    e.stopPropagation();
                });
                _this._centerView = new Laya.Image;
                _this._centerView.skin = "unpack/xnhdPush/bigBanner_skin.png";
                _this._centerView.sizeGrid = "30,30,30,30,0";
                _this._centerView.width = 670;
                _this._centerView.pos(40, 100);
                _this.addChild(_this._centerView);
                var _upper = new Laya.Image("unpack/xnhdPush/bigBanner_upper.png");
                _upper.sizeGrid = "0,20,0,20,0";
                _upper.size(670, 75);
                _this._centerView.addChild(_upper);
                _this._exitBtn = new Laya.Image('unpack/xnhdPush/backBtn.png');
                _upper.addChild(_this._exitBtn);
                _this._exitBtn.pos(5, 5);
                _this._allIconPanel = new Laya.Panel;
                _this._allIconPanel.pos(9, 75);
                _this._allIconPanel.width = _this._centerView.width - 18;
                _this._allIconPanel.vScrollBarSkin = 'unpack/xnhdPush/vscroll.png';
                _this._centerView.addChild(_this._allIconPanel);
                return _this;
            }
            exitView.prototype.init = function () {
                Laya.stage.addChild(this);
                XnhdAPI.WxLiteGameAPI.AdManager.Default.hideWxLiteGameBannerAd();
                this.scale(XnhdAPI.Param.screenScale, XnhdAPI.Param.screenScale);
                this._exitBtn.once(Laya.Event.CLICK, this, this.destroy);
                var k = XnhdAPI.Param.screenHeight - 1334; //1624-1334 = 290
                var ratio = k / (1624 - 1334);
                this._centerView.height = Math.floor(XnhdAPI.Param.screenHeight - 40 - 67 * ratio - this._centerView.y);
                this._allIconPanel.height = this._centerView.height - 75 - 18;
                var appList = pushManager.Inst.getAppList();
                appList.sort(function (a, b) {
                    return XnhdAPI.Tools.randomInt(0, 1) * 2 - 1;
                });
                var num = appList.length;
                for (var i = 0; i < num; i++) {
                    var _bg = new Laya.Image("unpack/xnhdPush/exit_iconBg.png");
                    _bg.sizeGrid = "25,25,25,25,0";
                    _bg.size(612, 160);
                    _bg.pos(20, i * 180 + 20);
                    this._allIconPanel.addChild(_bg);
                    var _icon = Laya.Pool.getItemByClass("gameIcon", gameIcon);
                    _bg.addChild(_icon);
                    _icon.size(612, 160);
                    _icon.pos(0, 0);
                    _icon.initData(appList[i], this._iconStyle);
                    _icon.setMonitorOn();
                }
            };
            exitView.prototype.destroy = function () {
                this._allIconPanel.destroyChildren();
                this.removeSelf();
                Param.closeCallback.exitView && Param.closeCallback.exitView();
            };
            return exitView;
        }(Laya.Image));
        var gameIcon = /** @class */ (function (_super) {
            __extends(gameIcon, _super);
            function gameIcon() {
                var _this = _super.call(this) || this;
                _this.gameName = new Laya.Label;
                _this.icon = new Laya.Image();
                _this.pv = new Laya.Label;
                _this.desc = new Laya.Label;
                _this.redPot = new Laya.Image;
                _this.addChild(_this.icon);
                _this.addChild(_this.gameName);
                _this.addChild(_this.pv);
                _this.addChild(_this.desc);
                _this.addChild(_this.redPot);
                return _this;
            }
            gameIcon.prototype.setMonitorOn = function () {
                this.on(Laya.Event.CLICK, this, this.clickFunc);
            };
            gameIcon.prototype.clickFunc = function () {
                var myData = this._data;
                this.redPot.visible = false;
                XnhdAPI.WxLiteGameAPI.openMiniApp(myData.appid, 1, myData.path, myData.statid, myData.qrcode);
                this._clickCallBack && this._clickCallBack(myData.appid);
            };
            /**
             * 1=大banner，2=小banner，3=抽屉，4=退出页面，5=shakeIcon
             * @param data
             * @param style 1=大banner，2=小banner，3=抽屉，4=退出页面，5=shakeIcon
             */
            gameIcon.prototype.initData = function (data, style) {
                this.icon.skin = "unpack/xnhdPush/drawer_iconBg.png";
                this.setIconData(data);
                this.checkIcon(data);
                this.setPv();
                this.setDescription();
                this.setName();
                switch (style) {
                    //大banner，游戏名称及多少人在玩在icon下方
                    case 1: {
                        this.gameName.visible = true;
                        this.pv.visible = true;
                        this.desc.visible = false;
                        this.redPot.visible = false;
                        this.icon.size(120, 120);
                        this.icon.pos(20, 20);
                        this.gameName.anchorX = 0.5;
                        this.gameName.fontSize = 24;
                        this.gameName.color = '#fff';
                        this.gameName.pos(80, 148);
                        var _s = this.gameName.width > 160 ? 160 / this.gameName.width : 1;
                        this.gameName.scale(_s, _s);
                        this.pv.fontSize = 24;
                        this.pv.color = '#fff';
                        this.pv.anchorX = 0.5;
                        this.pv.pos(80, 178);
                        _s = this.pv.width > 160 ? 160 / this.pv.width : 1;
                        break;
                    }
                    //小banner，除了icon、name外有新加的一个name背景
                    case 2: {
                        this.gameName.visible = true;
                        this.pv.visible = false;
                        this.desc.visible = false;
                        this.redPot.visible = false;
                        this.gameName.anchorX = 0.5;
                        this.gameName.fontSize = 20;
                        this.gameName.color = '#fff';
                        this.gameName.pos(63, 131);
                        this.icon.size(this.width, this.width);
                        this.icon.pos(0, 0);
                        // let a = new Laya.Image('unpack/xnhdPush/botBanner_ziBg.png');
                        // a.size(126,35);
                        // a.pos(0,114);
                        // this.icon.addChild(a)
                        break;
                    }
                    //抽屉，只有红点______(去除游戏名称及多少人在玩)
                    case 3: {
                        this.gameName.visible = false;
                        this.pv.visible = false;
                        this.desc.visible = false;
                        this.redPot.visible = true;
                        this.icon.size(this.width, this.height);
                        this.icon.pos(0, 0);
                        this.redPot.pos(130, -6);
                        break;
                    }
                    //退出页面，横版，有游戏名称、描述及多少人在玩
                    case 4: {
                        this.gameName.visible = true;
                        this.pv.visible = true;
                        this.desc.visible = true;
                        this.redPot.visible = false;
                        this.icon.size(140, 140);
                        this.icon.pos(10, 10);
                        this.gameName.anchorX = 0;
                        this.gameName.fontSize = 46;
                        this.gameName.color = '#fff';
                        this.gameName.pos(160, 10);
                        this.gameName.scale(1, 1);
                        this.pv.fontSize = 32;
                        this.pv.color = '#fff';
                        this.pv.anchorX = 0;
                        this.pv.scale(1, 1);
                        this.pv.pos(160, 118);
                        this.desc.fontSize = 26;
                        this.desc.color = '#fff';
                        this.desc.anchorX = 0;
                        this.desc.size(442, 52);
                        this.desc.overflow = 'hidden';
                        this.desc.valign = 'middle';
                        this.desc.wordWrap = true;
                        this.desc.pos(160, 63);
                        break;
                    }
                    //shakeIcon
                    case 5: {
                        this.gameName.visible = false;
                        this.pv.visible = false;
                        this.desc.visible = false;
                        this.redPot.visible = false;
                        this.icon.size(this.width, this.height);
                        this.icon.pos(0, 0);
                    }
                }
            };
            gameIcon.prototype.setIconData = function (data) {
                this._data = JSON.parse(JSON.stringify(data));
            };
            gameIcon.prototype.getIconData = function () {
                return this._data;
            };
            gameIcon.prototype.setPv = function () {
                this.pv.text = this._data.pv;
            };
            gameIcon.prototype.setDescription = function () {
                this.desc.text = this._data.description;
            };
            gameIcon.prototype.setName = function () {
                this.gameName.text = this._data.name;
            };
            gameIcon.prototype.checkIcon = function (data) {
                this.icon.skin = data.skin;
            };
            gameIcon.prototype.setClickFunc = function (callback) {
                this._clickCallBack = callback;
            };
            gameIcon.prototype.destroy = function () {
                this.offAll(Laya.Event.CLICK);
                this.icon.destroyChildren();
                this.removeSelf();
                Laya.Pool.recover("gameIcon", this);
            };
            return gameIcon;
        }(Laya.Image));
        var advIcon = /** @class */ (function (_super) {
            __extends(advIcon, _super);
            function advIcon() {
                var _this = _super.call(this) || this;
                _this.anchorX = 0.5;
                _this.anchorY = 0.5;
                return _this;
            }
            advIcon.prototype.init = function (parent) {
                var min = Math.min(parent.width, parent.height);
                parent.addChild(this);
                this.size(min, min);
                this.pos(min / 2, min / 2);
                var data = pushManager.Inst.getAdvData();
                this.scale(1, 1);
                this.rotation = 0;
                this.initData(data, 5);
                Laya.timer.frameLoop(360, this, this.shakeLoop);
                this.setMonitorOn();
            };
            advIcon.prototype.shakeLoop = function () {
                var _this = this;
                var duration = 120;
                var a = !XnhdAPI.Tools.randomInt(0, 1);
                var _loop_3 = function (i) {
                    if (a) {
                        var _r_1 = Math.sin(Math.PI * 2 / duration * i) * 20;
                        Laya.timer.frameOnce(i, this_3, function () {
                            _this.rotation = _r_1;
                        });
                    }
                    else {
                        var _s_1 = Math.abs(Math.sin(Math.PI * 2 / duration * i)) * 0.15 + 1;
                        Laya.timer.frameOnce(i, this_3, function () {
                            _this.scale(_s_1, _s_1);
                        });
                    }
                };
                var this_3 = this;
                for (var i = 0; i < duration; i++) {
                    _loop_3(i);
                }
                Laya.timer.frameOnce(duration, this, function () {
                    _this.scale(1, 1);
                    _this.rotation = 0;
                });
            };
            advIcon.prototype.destroy = function () {
                Laya.timer.clear(this, this.shakeLoop);
                this.removeSelf();
                Laya.Pool.recover("advIcon", this);
            };
            return advIcon;
        }(gameIcon));
    })(XnhdWxPush = XnhdAPI.XnhdWxPush || (XnhdAPI.XnhdWxPush = {}));
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=XnhdWxpush.js.map