var XnhdAPI;
(function (XnhdAPI) {
    var XiaomiLiteGameAPI;
    (function (XiaomiLiteGameAPI) {
        var Param = /** @class */ (function () {
            function Param() {
            }
            Param.userInfo = {
                uid: "",
                session: "",
                nickName: "",
                avatarUrl: "",
                gender: "",
            };
            Param.appInfo = {
                appid: "",
                appKey: "",
                appSecret: "",
                packageName: "",
                appName: ""
            };
            Param.advertiseInfo = {
                videoAd: "",
            };
            Param.loadingPage = null;
            return Param;
        }());
        XiaomiLiteGameAPI.Param = Param;
        function init(XiaomiLiteGameConfig, callback) {
            Param.appInfo.appid = XiaomiLiteGameConfig.appid.toString();
            Param.appInfo.appKey = XiaomiLiteGameConfig.appKey;
            Param.appInfo.appSecret = XiaomiLiteGameConfig.appSecret;
            Param.appInfo.packageName = XiaomiLiteGameConfig.packageName;
            Param.appInfo.appName = XiaomiLiteGameConfig.appName;
            Param.advertiseInfo.videoAd = XiaomiLiteGameConfig.videoAd.toString();
            setLoadingProgress(0);
            AdManager.Default.init();
            callback && callback();
        }
        XiaomiLiteGameAPI.init = init;
        function login(callback) {
            try {
                qg.login({
                    pkgName: Param.appInfo.packageName,
                    success: function (res) {
                        XnhdAPI.logDebug("xiaomiLogin的参数：" + JSON.stringify(res));
                        try {
                            Param.userInfo.uid = res.appAccountId;
                            Param.userInfo.session = res.session;
                            callback();
                        }
                        catch (e) {
                            XnhdAPI.logDebug("XiaomiLiteGame Login success but fail JSON.parse>> " + e.toString());
                        }
                    },
                    fail: function (f) {
                        XnhdAPI.logError("xiaomiLogin Fail：" + JSON.stringify(f));
                    }
                });
            }
            catch (f) {
                XnhdAPI.logDebug("XiaomiLiteGame Login fail >> " + f.toString());
            }
        }
        XiaomiLiteGameAPI.login = login;
        /**
         * XiaomiLiteGame游戏初始加载进度条
         * @param num 0~100
         */
        function setLoadingProgress(num) {
            // if (parseInt(Param.otherInfo.XiaomiLiteAppVersion) >= 1031) {
            if (num < 101 && num > -1) {
                try {
                    qg.setLoadingProgress({
                        progress: num
                    });
                }
                catch (f) {
                    XnhdAPI.logError("XiaomiLiteGame setLoadingProgress " + num.toString() + " fail >> " + f.toString());
                }
            }
            else {
                try {
                    qg.loadingComplete({
                        success: function (res) {
                        }
                    });
                }
                catch (f) {
                    XnhdAPI.logError("XiaomiLiteGame loadingComplete fail >> " + f.toString());
                }
            }
            // } else {
            //     if (num < 100 && num > -1) {
            //         if (Param.loadingPage != null) {
            //             Param.loadingPage = new Laya.Image("unpack/SprBlack.png");
            //             Param.loadingPage.zOrder = 10;
            //             Param.loadingPage.size(Laya.Browser.width, Laya.Browser.height);
            //             Laya.stage.addChild(Param.loadingPage);
            //             let imgWel = new Laya.Image("unpack/oppoLoading.png");
            //             imgWel.anchorX = 0.5;
            //             imgWel.anchorY = 0.5;
            //             imgWel.scale(XnhdAPI.Param.screenScale, XnhdAPI.Param.screenScale);
            //             Param.loadingPage.addChild(imgWel);
            //             imgWel.pos(Laya.Browser.width / 2, Laya.Browser.height / 2);
            //         }
            //     } else if (num >= 100) {
            //         Laya.Tween.to(Param.loadingPage, { alpha: 0 }, 500, null, Laya.Handler.create(this, () => {
            //             Param.loadingPage.destroy();
            //         }), 500)
            //     }
            // }
        }
        XiaomiLiteGameAPI.setLoadingProgress = setLoadingProgress;
        function saveDataToCache(key, content, isNumber) {
            if (isNumber) {
                content = content.toString();
            }
            localStorage.setItem(key, content);
        }
        XiaomiLiteGameAPI.saveDataToCache = saveDataToCache;
        function getDataFromCache(key, isInt) {
            var a = localStorage.getItem(key);
            if (isInt && a) {
                return parseInt(a);
            }
            return a;
        }
        XiaomiLiteGameAPI.getDataFromCache = getDataFromCache;
        var AdManager = /** @class */ (function () {
            function AdManager() {
                this._bannerAd = null;
                this._videoAd = null;
                this._bannerAdShow = false;
                this._videoAdLoaded = false;
                this._interstitialAdLoaded = false;
            }
            AdManager.prototype.getInterstitialAdStatus = function () {
                return this._interstitialAdLoaded;
            };
            AdManager.prototype.getVideoStatus = function () {
                return this._videoAdLoaded;
            };
            AdManager.prototype.init = function () {
                // this.initBannerAd();
                // this.initInterstitialAd();
                this.initVideoAd();
            };
            // private initBannerAd() {
            //     if (Param.advertiseInfo.bannerAd.length > 0) {
            //         // XnhdAPI.logDebug("初始化banner");
            //         this._bannerAd = qg.createBannerAd({
            //             posId: Param.advertiseInfo.bannerAd
            //         })
            //         this._bannerAd.onError(e => {
            //             XnhdAPI.logError("XiaomiLite bannerAd load error >>" + JSON.stringify(e));
            //         })
            //         this._bannerAd.onHide(e => {
            //             // XnhdAPI.logDebug("隐藏banner");
            //             this._bannerAdShow = false;
            //         })
            //     }
            // }
            // public hideBannerAd() {
            //     if (Param.advertiseInfo.bannerAd.length > 0 && this._bannerAd) {
            //         this._bannerAd.hide();
            //     }
            // }
            // public showOBannerAd() {
            //     if (!this._bannerAdShow) {
            //         this._bannerAdShow = true;
            //         try { this._bannerAd && this._bannerAd.show(); } catch (e) { XnhdAPI.logError("XiaomiLite bannerAd show error >>" + e.toString()); }
            //     }
            // }
            // private initInterstitialAd(successCallback: Function = null) {
            //     if (Param.advertiseInfo.interstitialAd.length > 0) {
            //         // XnhdAPI.logDebug("初始化Interstitial");
            //         try {
            //             this._interstitialAd = qg.createInsertAd({
            //                 posId: Param.advertiseInfo.interstitialAd
            //             })
            //             this._interstitialAd.onLoad(s => {
            //                 this._interstitialAdLoaded = true;
            //                 // XnhdAPI.logDebug("Interstitial Load成功");
            //                 successCallback && successCallback();
            //             })
            //             this._interstitialAd.onError(e => {
            //                 XnhdAPI.logError("XiaomiLite interstitialAd load error >>" + JSON.stringify(e));
            //                 this._interstitialAdLoaded = false;
            //                 Laya.timer.once(10000, this, () => {
            //                     this._interstitialAd.load(successCallback);
            //                 })
            //             })
            //             this._interstitialAd.load();
            //         } catch (e) {
            //             XnhdAPI.logError("XiaomiLite interstitialAd onLoad error >>" + e.toString());
            //         }
            //     }
            // }
            // public showInterstitialAd() {
            //     if (this._interstitialAd && this._interstitialAdLoaded) {
            //         this._interstitialAd.onShow(() => {
            //             this._interstitialAd.offShow();
            //             this._interstitialAd.load();
            //         })
            //         this._interstitialAd.show();
            //     }
            // }
            AdManager.prototype.initVideoAd = function () {
                var _this = this;
                if (Param.advertiseInfo.videoAd.length > 0) {
                    // XnhdAPI.logDebug("初始化视频");
                    try {
                        this._videoAd = qg.createRewardedVideoAd({
                            adUnitId: Param.advertiseInfo.videoAd
                        });
                        this._videoAd.onLoad(function (s) {
                            // XnhdAPI.logDebug("视频缓存完毕");
                            _this._videoAdLoaded = true;
                        });
                        this._videoAd.onError(function (e) {
                            _this.videoErrorFun(e);
                        });
                        this._videoAd.load();
                    }
                    catch (e) {
                        XnhdAPI.logError("XiaomiLite videoAd init error >>" + e.toString());
                    }
                }
            };
            AdManager.prototype.videoErrorFun = function (e) {
                var _this = this;
                XnhdAPI.logDebug("XiaomiLite videoAd load error >>" + JSON.stringify(e));
                this._videoAdLoaded = false;
                // if (this._interstitialAdLoadNum < 20) {
                Laya.timer.once(30000, this, function () {
                    _this._videoAd.load();
                });
            };
            AdManager.prototype.showVideoAd = function (successCallback, failCallback) {
                var _this = this;
                if (successCallback === void 0) { successCallback = null; }
                if (failCallback === void 0) { failCallback = null; }
                if (this._videoAd && this._videoAdLoaded) {
                    this._videoAd.onVideoStart(function () {
                        _this._videoAd.offVideoStart();
                        _this._videoAdLoaded = false;
                        _this._videoAd.load();
                    });
                    this._videoAd.onClose(function (res) {
                        _this._videoAd.offClose();
                        XnhdAPI.logDebug('Xiaomi快游戏获得视频奖励：' + JSON.stringify(res));
                        res && res.isEnded && successCallback && successCallback();
                    });
                    this._videoAd.show();
                }
                else {
                    failCallback && failCallback();
                }
            };
            AdManager.Default = new AdManager();
            return AdManager;
        }());
        XiaomiLiteGameAPI.AdManager = AdManager;
    })(XiaomiLiteGameAPI = XnhdAPI.XiaomiLiteGameAPI || (XnhdAPI.XiaomiLiteGameAPI = {}));
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=XiaomiLiteGameAPI.js.map