var XnhdAPI;
(function (XnhdAPI) {
    var FunPepperWebGameAPI;
    (function (FunPepperWebGameAPI) {
        var Param = /** @class */ (function () {
            function Param() {
            }
            Param.appInfo = {
                client_id: '',
                game_id: '',
                mode: '',
                env: 'pro',
                redirect_url: '' //消灭星星对战版特殊处理
            };
            Param.clientInfo = {
                access_token: '',
                code: '',
                expires_in: '',
                refresh_token: '',
                scope: '',
                unionid: '',
            };
            Param.userInfo = {
                open_id: '',
                username: '',
                gender: 0,
                avatar: '',
                country_code: '',
                uplive_code: '',
                language: ''
            };
            Param.httpUrl = {
                access_token: 'http://go.pickbox.cn/BattleServer/Applications/Battle/api/fun_oauth.php',
                userInfo: 'http://go.pickbox.cn/BattleServer/Applications/Battle/api/fun_userinfo.php',
                goldBalance: 'http://go.pickbox.cn/BattleServer/Applications/Battle/api/fun_goldBalance.php',
            };
            Param.callback = {
                getGoldBalance: null,
            };
            return Param;
        }());
        function init(funPepperGameConfig, callback) {
            Param.appInfo.client_id = funPepperGameConfig.client_id;
            Param.appInfo.game_id = funPepperGameConfig.game_id;
            Param.appInfo.mode = funPepperGameConfig.mode;
            Param.appInfo.redirect_url = funPepperGameConfig.redirect_url;
            openSdk.init({
                env: Param.appInfo.env,
                client_id: Param.appInfo.client_id,
                game_id: Param.appInfo.game_id,
                mode: Param.appInfo.mode,
            });
            getCodeAndRedirectUrl(callback);
        }
        FunPepperWebGameAPI.init = init;
        function rechargeGold() {
            openSdk.rechargeGold();
        }
        FunPepperWebGameAPI.rechargeGold = rechargeGold;
        function getGameId() {
            return Param.appInfo.game_id;
        }
        FunPepperWebGameAPI.getGameId = getGameId;
        function getRoomInfo() {
            return Param.onlyForHallLogic;
        }
        FunPepperWebGameAPI.getRoomInfo = getRoomInfo;
        function getClientId() {
            return Param.appInfo.client_id;
        }
        FunPepperWebGameAPI.getClientId = getClientId;
        function quitGame() {
            openSdk.quitGame();
        }
        FunPepperWebGameAPI.quitGame = quitGame;
        function goldBalance_get(callback) {
            Param.callback.getGoldBalance = callback;
            getUserGoldBalance();
        }
        FunPepperWebGameAPI.goldBalance_get = goldBalance_get;
        function updateEnterGame(callback) {
            if (callback === void 0) { callback = null; }
            if (typeof Param.userInfo.open_id === 'string' && Param.userInfo.open_id.length > 0) {
                openSdk.ping({
                    open_id: Param.userInfo.open_id,
                    success: function () {
                        callback && callback();
                    }
                });
            }
        }
        FunPepperWebGameAPI.updateEnterGame = updateEnterGame;
        function getOauth(callback) {
            XnhdAPI.requestHttp(Param.httpUrl.access_token, function (e) {
                try {
                    e = JSON.parse(e);
                    if (e.code === 200) {
                        Param.clientInfo.access_token = e.data.access_token;
                        Param.clientInfo.expires_in = e.data.expires_in;
                        Param.clientInfo.refresh_token = e.data.refresh_token;
                        Param.userInfo.open_id = e.data.open_id;
                        Param.clientInfo.scope = e.data.scope;
                        Param.clientInfo.unionid = e.data.unionid;
                        Param.onlyForHallLogic = e.roomInfo;
                        updateEnterGame();
                        openSdk.receiveGold({
                            open_id: Param.userInfo.open_id,
                            getGoldSuccess: function () {
                                getUserGoldBalance();
                            }
                        });
                    }
                    else {
                        XnhdAPI.logError('FunPepper getOpenidAndAccessToken Fail: ' + e.data);
                        openSdk.oauth({
                            redirect_url: Param.appInfo.redirect_url,
                        });
                    }
                }
                catch (f) { }
                Param.curLanguage = XnhdAPI.WebGameAPI.getUrlParam("_lang");
                XnhdAPI.setLanguage(Param.curLanguage);
                callback && callback();
            }, JSON.stringify({
                game_id: '1',
                code: Param.clientInfo.code,
                redirect_uri: Param.appInfo.redirect_url,
            }), function (f) {
                XnhdAPI.logDebug('FunPepper getOpenidAndAccessToken Fail: ' + f.toString());
                getOauth(callback);
            });
        }
        function getUserInfo(callback) {
            XnhdAPI.requestHttp(Param.httpUrl.userInfo, function (e) {
                try {
                    e = JSON.parse(e);
                    if (e.code === 200) {
                        Param.userInfo.username = e.data.username;
                        Param.userInfo.gender = e.data.gender;
                        Param.userInfo.avatar = e.data.avatar;
                        Param.userInfo.country_code = e.data.country_code;
                        Param.userInfo.uplive_code = e.data.uplive_code;
                        Param.userInfo.language = e.data.language;
                    }
                }
                catch (f) { }
                callback && callback(e);
            }, JSON.stringify({
                open_id: Param.userInfo.open_id,
            }), function (f) {
                XnhdAPI.logDebug('FunPepper getUserInfo Fail: ' + f.toString());
                getUserInfo(callback);
            });
        }
        FunPepperWebGameAPI.getUserInfo = getUserInfo;
        function getUserGoldBalance() {
            XnhdAPI.requestHttp(Param.httpUrl.goldBalance, function (e) {
                try {
                    e = JSON.parse(e);
                    Param.callback.getGoldBalance && Param.callback.getGoldBalance(e.data);
                    Param.callback.getGoldBalance = null;
                }
                catch (f) { }
            }, JSON.stringify({
                open_id: Param.userInfo.open_id,
            }), function (f) {
                XnhdAPI.logDebug('FunPepper getUserGoldBalance Fail: ' + f.toString());
                getUserGoldBalance();
            });
        }
        function getCodeAndRedirectUrl(callback) {
            var url_ = Laya.Browser.window.location.href;
            var inde_ = url_.indexOf(".html");
            inde_ += 5;
            if (Param.appInfo.redirect_url.length > 0) { }
            else {
                Param.appInfo.redirect_url = url_.substring(0, inde_);
            }
            Param.clientInfo.code = XnhdAPI.WebGameAPI.getUrlParam("code");
            if (typeof Param.clientInfo.code === 'string' && Param.clientInfo.code.length > 0) {
                getOauth(callback);
            }
            else {
                openSdk.oauth({
                    redirect_url: Param.appInfo.redirect_url,
                });
            }
        }
    })(FunPepperWebGameAPI = XnhdAPI.FunPepperWebGameAPI || (XnhdAPI.FunPepperWebGameAPI = {}));
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=FunPepperWebGameAPI.js.map