var XnhdAPI;
(function (XnhdAPI) {
    var QuTouTiaorWebGameAPI;
    (function (QuTouTiaorWebGameAPI) {
        var Param = /** @class */ (function () {
            function Param() {
            }
            Param.appInfo = {
                app_id: "",
                platform: "",
                ticket: "",
                bannerId: "",
                videoId: ""
            };
            Param.userInfo = {
                time: 0,
                openid: "",
                nickname: "",
                avatar: "",
                union_id: ""
            };
            Param.getUserInfoUrl = "https://game.batwan.cn/interface/qttlogin.php";
            return Param;
        }());
        QuTouTiaorWebGameAPI.Param = Param;
        function init(quTouTiaoGameConfig, callback) {
            Param.appInfo.app_id = quTouTiaoGameConfig.appid;
            Param.appInfo.bannerId = quTouTiaoGameConfig.banner_ad;
            Param.appInfo.videoId = quTouTiaoGameConfig.video_ad;
            Param.appInfo.platform = XnhdAPI.WebGameAPI.getUrlParam("platform");
            Param.appInfo.ticket = XnhdAPI.WebGameAPI.getUrlParam("ticket");
            getUserInfo(callback);
        }
        QuTouTiaorWebGameAPI.init = init;
        function getUserInfo(callback) {
            var a = XnhdAPI.readDataFromCache("QuTouTiaoUserInfo");
            if (typeof a === "string") {
                a = JSON.parse(a);
                if (a.time - Date.now() > 7 * 24 * 3600 * 1000) {
                    requestUserInfo(callback);
                }
                else {
                    Param.userInfo.openid = a.openid;
                    Param.userInfo.nickname = a.nickname;
                    Param.userInfo.avatar = a.avatar;
                    Param.userInfo.union_id = a.union_id;
                    Param.userInfo.time = a.time;
                    callback && callback();
                }
            }
            else {
                requestUserInfo(callback);
            }
        }
        function requestUserInfo(callback) {
            var _this = this;
            var imgWel = new Laya.Image("unpack/Loading.png");
            imgWel.name = "Loading";
            imgWel.zOrder = 10;
            imgWel.centerX = 0;
            imgWel.centerY = 0;
            imgWel.scale(XnhdAPI.Param.screenScale, XnhdAPI.Param.screenScale);
            Laya.stage.addChild(imgWel);
            XnhdAPI.requestHttp(Param.getUserInfoUrl, function (e) {
                try {
                    e = JSON.parse(e);
                    Param.userInfo.openid = e.data.openid;
                    Param.userInfo.nickname = e.data.nickname;
                    Param.userInfo.avatar = e.data.avatar;
                    Param.userInfo.union_id = e.data.union_id;
                    Param.userInfo.time = Date.now();
                    callback && callback();
                    var loadingImg_1 = Laya.stage.getChildByName("Loading");
                    if (loadingImg_1) {
                        Laya.Tween.to(loadingImg_1, { alpha: 0 }, 1000, null, Laya.Handler.create(_this, function () {
                            loadingImg_1.destroy();
                        }));
                    }
                    saveQuTouTiaoUserInfo();
                }
                catch (f) { }
            }, JSON.stringify({
                app_id: Param.appInfo.app_id,
                platform: Param.appInfo.platform,
                ticket: Param.appInfo.ticket
            }));
        }
        function saveQuTouTiaoUserInfo() {
            XnhdAPI.saveDataToCache("QuTouTiaoUserInfo", JSON.stringify(Param.userInfo));
        }
        var AdManager = /** @class */ (function () {
            function AdManager() {
                this._bannerLoad = false;
                this.initBanner();
                this.initVideo();
            }
            AdManager.prototype.initBanner = function () {
                if (Param.appInfo.bannerId.length > 0) {
                    this._bannerDiv = document.createElement("div");
                    this._bannerDiv.id = "div1";
                    this._bannerDiv.style.position = "absolute";
                    this._bannerDiv.style.top = (Laya.Browser.clientHeight - 80).toString() + "px";
                    this._bannerDiv.style.left = "0px";
                    this._bannerDiv.style.width = (Laya.Browser.clientWidth).toString() + "px";
                    this._bannerDiv.style.height = "80px";
                    this._bannerDiv.style.zIndex = "100001";
                    document.body.appendChild(this._bannerDiv);
                }
            };
            AdManager.prototype.initVideo = function () {
                if (Param.appInfo.videoId.length > 0) {
                    this._videoDiv = document.createElement("div");
                    this._videoDiv.id = "div2";
                    this._videoDiv.style.position = "absolute";
                    this._videoDiv.style.top = "80px";
                    this._videoDiv.style.left = "0px";
                    this._videoDiv.style.width = (Laya.Browser.clientWidth).toString() + "px";
                    this._videoDiv.style.height = (Laya.Browser.clientHeight).toString() + "px";
                    this._videoDiv.style.zIndex = "100002";
                    document.body.appendChild(this._videoDiv);
                }
            };
            AdManager.prototype.showBannerAd = function () {
                if (this._bannerDiv) {
                    if (this._bannerDiv.hidden) {
                        this._bannerDiv.hidden = false;
                    }
                    else if (!this._bannerLoad) {
                        this._bannerLoad = true;
                        qttGame.cpcAd({ aid: Param.appInfo.bannerId, container: "div1" });
                    }
                }
            };
            AdManager.prototype.hideBannerAd = function () {
                this._bannerDiv.hidden = true;
            };
            AdManager.prototype.getVideoStatus = function () {
                return Param.appInfo.videoId.length > 0;
            };
            AdManager.prototype.showVideoAd = function (successCallback, failCallback) {
                if (successCallback === void 0) { successCallback = null; }
                if (failCallback === void 0) { failCallback = null; }
                qttGame.cpcAd({
                    aid: Param.appInfo.videoId,
                    container: 'div2',
                    adType: 'video',
                    endedCallback: function () {
                        console.log('播放完毕，领取奖励。');
                        successCallback();
                    }
                });
            };
            AdManager.Default = new AdManager();
            return AdManager;
        }());
        QuTouTiaorWebGameAPI.AdManager = AdManager;
    })(QuTouTiaorWebGameAPI = XnhdAPI.QuTouTiaorWebGameAPI || (XnhdAPI.QuTouTiaorWebGameAPI = {}));
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=QuToutiaoWebGameAPI.js.map