var core;
(function (core) {
    class GameDef {
        /**
         * 上传最高分
         */
        static updateHighScore() {
            if (GameDef.isRank) {
                GameDef.updateWorldRankData(GameDef.maxScore.ranking, null, null);
            }
            else {
                XnhdAPI.updateHighScore(core.GameDef.maxScore.normal);
            }
        }
        /**
         * 上传世界排行榜分数方法
         * @param score score=0或其他非number类型时，仅获取排行榜分数
         * @param successCallBack
         * @param failCallback
         */
        static updateWorldRankData(score, successCallBack, failCallback, login_code = "", anonymousCode = "") {
            // if(core.GameDef.myWorldRankInfo['lastScore'] == score){
            //     console.log("same score...")
            //     successCallBack && successCallBack(core.GameDef.myWorldRankInfo['lastRet']);
            //     return;
            // }
            if (window['tt'] && login_code == "") {
                let self = this;
                window['tt'].login({
                    success(login_res) {
                        console.log(`userinfo login调用成功111:${login_res.code} ${login_res.anonymousCode}`);
                        self.updateWorldRankData(score, successCallBack, failCallback, login_res.code, login_res.anonymousCode);
                    },
                    fail(res) {
                        console.log(`userinfo login调用失败11`);
                        failCallback && failCallback(res);
                    }
                });
                return;
            }
            let _nouce = Date.now();
            let _param = {
                appId: "tt9abbec060591b6d7",
                score: score,
                openId: GameDef.myWorldRankInfo.openid,
                nickName: GameDef.myWorldRankInfo.nickName,
                avatarUrl: GameDef.myWorldRankInfo.avatarUrl,
                loginCode: login_code,
                anonymousCode: anonymousCode,
                nouce: _nouce,
                sign: XnhdAPI.Encrypt.hex_md5("tt9abbec060591b6d7" + GameDef.myWorldRankInfo.openid + _nouce),
            };
            typeof score === 'number' && score > 0 && (_param['score'] = score);
            XnhdAPI.requestHttp(GameDef.worldRankListUrl, e => {
                core.GameDef.myWorldRankInfo['lastScore'] = score;
                core.GameDef.myWorldRankInfo['lastRet'] = e;
                successCallBack && successCallBack(e);
            }, JSON.stringify(_param), f => {
                failCallback && failCallback(f);
            });
            // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            //     XnhdAPI.WxLiteGameAPI.updateWorldRankData(score, successCallBack, failCallback, GameDef.worldRankListUrl)
            // } else {
            //     let _nouce = Date.now();
            //     let _param = {
            //         appId: GameDef.myWorldRankInfo.appid,
            //         openId: GameDef.myWorldRankInfo.openid,
            //         nickName: GameDef.myWorldRankInfo.nickName,
            //         avatarUrl: GameDef.myWorldRankInfo.avatarUrl,
            //         nouce: _nouce,
            //         sign: XnhdAPI.Encrypt.hex_md5(GameDef.myWorldRankInfo.appid + GameDef.myWorldRankInfo.openid + _nouce),
            //     }
            //     typeof score === 'number' && score > 0 && (_param['score'] = score);
            //     XnhdAPI.requestHttp(GameDef.worldRankListUrl, e => {
            //         successCallBack && successCallBack(e);
            //     }, JSON.stringify(_param), f => {
            //         failCallback && failCallback(f);
            //     })
            // }
        }
        static itemLevelParseNum(level) {
            if (level < 0) {
                return 0;
            }
            let i = 0;
            for (; i < 11; i++) {
                let min = (5 + i) * i / 2;
                let max = (6 + i) * (i + 1) / 2;
                if (level > min - 1 && level < max) {
                    break;
                }
            }
            return i;
        }
        static saveMaxScore() {
            XnhdAPI.saveDataToCache("maxScore", GameDef.maxScore, true);
        }
    }
    //渠道配置参数，参考XnhdAPI.ts
    GameDef.plats_param = {
        screenMode: "vertical",
        version: "1.0.0",
        platType: 0,
        channelType: 0,
        nativeType: {},
        webType: {},
        liteType: {
            WxLiteGame: {
                appid: "wxa8fab25ec9b86ff4",
                banner_ad_id: "",
                video_ad_id: [""],
                interstitial_ad_id: "",
                share_txt: [""],
                share_img: [""],
                channelIndex: 0
            },
        }
    };
    //世界排行榜需要的信息，调用世界排行榜前，必须将下列信息完善才可以继续
    GameDef.myWorldRankInfo = {
        appid: "",
        openid: '',
        avatarUrl: '',
        nickName: '',
    };
    //世界排行榜地址
    // public static worldRankListUrl = 'https://my100.372124.com/worldrank/game_rank.php';
    GameDef.worldRankListUrl = 'https://app.dashitech.cn/game/api/zpwworldrank';
    // 过往语言编号及顺序
    // zh-CN = 0,//简体中文
    // en-US = 1,//美式英文
    // zh-TW = 2,//台湾繁体中文
    // id-ID = 3,//印度尼西亚语
    // vi-VN = 4,//越南语
    // ja-JP = 5,//日语
    // ar-EG = 6,//阿拉伯语
    GameDef.languageIndex = -1;
    //本地化翻译配置，与languageIndex对应
    GameDef.localizationConfig = {
        itemDescription: {
            OmnipotentCard: ['万能牌', 'Omnipotent', '萬能牌'],
            Bomb: ['全屏炸弹', 'Bomb', '全屏炸彈'],
            CardSaved: ['存牌', 'Save', '存牌'],
            ThinkingTime: ['思考时长', 'Thinking Time', '思考時長'],
            Coin: ['金币', 'Gold', '金幣'],
            //复数表示方式
            pluralType: [' x', ' x', ' x']
        },
        highScore: ['最高分', 'Max Score', '最高分'],
        share: ['分享', 'Share', '分享'],
        noVideoTips: ['暂无广告，请稍后重试', 'No Advertisement. Please try later.', '暫無廣告，請稍後重試'],
        finishVideoTips: ['观看完广告才能获得奖励', 'Please finish the video', '觀看完廣告才能獲得獎勵'],
        LackOfCoin: {
            title: ['金币不足', 'Not Enough Gold', '金幣不足'],
            tips: ['免费领取一些金币', 'Get Gold For Free!', '免費領取一些金幣'],
            confirmBtn: ['领取', 'Get', '領取']
        },
        GameView: {
            rankingCountDown: ['思考倒计时', 'Thinking Time', '思考倒計時'],
            curLevel: ['第{0}关  合成{1}', 'Level {0}  Synthesis {1}', '第{0}關  合成{1}'],
            gameTips: [
                ["相同数字的纸牌可进行横拖合成", "连续合成可以获得更多分数", "存牌非常有用，一定要选择合适的时机", "将游戏分享给好友可获得步数，一定不要错过", "过关的要求会逐渐提升，512、1024、2048……", "排位赛功能道具不可购买", "排位赛有每一步的思考时间限制", "排位赛积分是世界排行，自由模式是好友排行"],
                ["Cards of the same number can be dragged and combined", "Continuous synthesis can get more scores", "Depositing is very useful, be sure to choose the right time", "Share the game to your friends to get gold coins, don't miss it.", "The requirements for customs clearance will gradually increase, 512, 1024, 2048…", "Qualifying function items are not available for purchase", "Qualifying time limit for each step of qualifying", "Qualifying points are world rankings, free mode is friends rankings"],
                ["相同數字的紙牌可進行橫拖合成", "連續合成可以獲得更多分數", "存牌非常有用，一定要選擇合適的時機", "將游戲分享給好友可獲得金幣，一定不要錯過", "過關的要求會逐漸提升，512、1024、2048……", "排位賽功能道具不可購買", "排位賽有每一步的思考時間限制", "排位賽積分是世界排行，自由模式是好友排行"]
            ],
            gameGuide: [
                ['可以将两张相同数字的纸牌合并成更大的牌', '连续合成可以获得更多分数', '万能牌可以代替任意数字纸牌，合成2048可得到倍数加成', '相同数字的纸牌进行拖拽合成，炸弹牌合成时可以消掉整列', '恭喜，您已顺利完成新手引导，赶快点击“确定”继续挑战。'],
                ['Please Continue As Instructed', 'Please Continue As Instructed', 'Please Continue As Instructed', 'Please Continue As Instructed', 'You Have Completed Guide'],
                ['可以將兩張相同數字的紙牌合併成更大的牌', '連續合成可以獲得更多分數', '萬能牌可代替任意數字紙牌,合成2048可得到倍數加成', '相同數字的紙牌進行拖拽合成, 炸彈牌合成時,可消掉整列', '相同數字的紙牌可進行橫拖合成', '您已順利完成新手指引,趕快點擊[確定]繼續挑戰。']
            ],
            gameGuideFinish: ['恭喜', 'Congratulations', '恭喜'],
            gameGuideFinishConfirmBtn: ['确 定', 'Ok', '確 定'],
            cannotUseBomb: ['您手上有一张{OmnipotentCard}，不能使用{Bomb}', "You can't use {Bomb} with {OmnipotentCard} in hand.", '您手上有一張{OmnipotentCard}，不能使用{Bomb}'],
        },
        LevelUpView: {
            title: ['恭喜过关', 'Congratulations', '恭喜過關'],
            normalGetCoin: ['直接领取', 'Get', '直接領取'],
            extraGetCoin: ['超值领取', 'Extra Get', '超值領取']
        },
        GameOverView: {
            title: ['再接再厉', 'GoodJob', '再接再厲'],
            restart: ['重新开始', 'Restart', '重新開始'],
            backMain: ['返回主页', 'Back', '返回主頁']
        },
        PauseLayer: {
            title: ['游戏暂停', 'Game Paused', '遊戲暫停'],
            continueBtn: ['继续游戏', 'Continue', '繼續遊戲'],
            tips: ['(存档数据不会丢失)', '(Archived Data Is Not Lost)', '(存檔數據不會丟失)']
        },
        MainView: {
            logo: ['unpack/zpwlogo.png', 'unpack/zpwlogo_yw.png', 'unpack/zpwlogo_ft.png'],
            normalBtn: ['普通模式', 'Normal', '普通模式'],
            rankBtn: ['排位模式', 'Ranking', '排位模式'],
            cultivateBtn: ['能力养成', 'Cultivate', '能力養成'],
            storeBtn: ['皮肤', 'Skin', '皮膚'],
            soundBtn: ['音效', 'Sound', '音效'],
            ranklistBtn: ['排行榜', 'RankList', '排行榜'],
            languageBtn: ['语言', 'Language', '語言'],
        },
        cultivateLayer: {
            title: ['能力养成', 'Cultivate', '能力養成'],
            availableTimes: ['排位赛可用次数', 'Available times in Ranking', '排位賽可用次數'],
            ThinkingTime: ['排位赛可用次数', 'Thinking time in Ranking', '排位賽可用次數'],
            levelUp: ['升级', 'LeveL Up', '升级'],
            successLevelUp: ['升级成功', 'LeveL Up Success!', '升級成功'],
            maxLevel: ['满级', 'Max', '滿級'],
        },
        ranklistLayer: {
            friend: ['好友排行', 'Friend', '好友排行'],
            world: ['世界排行', 'World', '世界排行'],
        },
        turntableLayer: {
            startBtn: ['开始', 'Start', '開始'],
            tips: ['获得', 'Get ', '獲得'],
            title: ['恭喜您成功通过了第{0}关\n获得一次抽奖机会', "Congratulations! You passed level {0}\nLet's start the turntable and get a reward!", '恭喜您成功通過了{0}關\n獲得一次抽獎獎勵']
        },
        storeLayer: {
            title: ['商店', 'Store', '商店'],
            purchase: ['购买', 'Purchase', '購買'],
            Activated: ['已激活', 'Activated', '已激活'],
            unlock: ['排位赛第{0}关解锁', 'Unlock with Ranking Level {0}', '排位賽第{0}關解鎖'],
            curRankLevel: ['排位赛最高关：{0}', 'Highest Level in Ranking: {0}', '排位賽最高關：{0}'],
        },
        renewLayer: {
            title: ['提示', 'Attention', '提示'],
            tips: ['没有可以放牌的位置了\n但有炸弹未使用', 'There is no room for next card.\nBut you still have bomb', '沒有可以放牌的位置了\n但有炸彈未使用'],
            useBtn: ['使用', 'Use it', '使用'],
            giveUpBtn: ['放弃', 'Waive', '放棄'],
        }
    };
    //背景皮肤地址及对应参数，param1表示排位赛模式进行到第几关就可以解锁该背景
    GameDef.bgParam = [
        { url: "unpack/bg/bj0.jpg", type: Laya.Loader.IMAGE, param1: 0 },
        { url: "unpack/bg/bj1.jpg", type: Laya.Loader.IMAGE, param1: 2 },
        { url: "unpack/bg/bj2.jpg", type: Laya.Loader.IMAGE, param1: 4 },
        { url: "unpack/bg/bj3.jpg", type: Laya.Loader.IMAGE, param1: 6 },
        { url: "unpack/bg/bj4.jpg", type: Laya.Loader.IMAGE, param1: 8 },
        { url: "unpack/bg/bj5.jpg", type: Laya.Loader.IMAGE, param1: 10 },
        { url: "unpack/bg/bj6.jpg", type: Laya.Loader.IMAGE, param1: 12 },
        { url: "unpack/bg/bj7.jpg", type: Laya.Loader.IMAGE, param1: 14 },
        { url: "unpack/bg/bj8.jpg", type: Laya.Loader.IMAGE, param1: 16 },
        { url: "unpack/bg/bj9.jpg", type: Laya.Loader.IMAGE, param1: 18 },
        { url: "unpack/bg/bj10.jpg", type: Laya.Loader.IMAGE, param1: 20 },
        { url: "unpack/bg/bj11.jpg", type: Laya.Loader.IMAGE, param1: 22 },
        { url: "unpack/bg/bj12.jpg", type: Laya.Loader.IMAGE, param1: 24 },
        { url: "unpack/bg/bj13.jpg", type: Laya.Loader.IMAGE, param1: 26 },
        { url: "unpack/bg/bj14.jpg", type: Laya.Loader.IMAGE, param1: 28 },
    ];
    //扑克花纹皮肤地址及对应参数，param1表示多少金币解锁
    GameDef.stampParam = [
        { url: "unpack/stamp/hw0.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw1.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw2.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw3.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw4.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw5.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw6.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw7.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw8.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw9.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw10.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw11.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw12.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw13.png", type: Laya.Loader.IMAGE, param1: 100 },
        { url: "unpack/stamp/hw14.png", type: Laya.Loader.IMAGE, param1: 100 },
    ];
    /**
     *
     *
     * 以下如无必要都不要修改
     *
     *
     */
    //自测用测试开关
    GameDef.selfTest = false;
    GameDef.gameParam = {
        //扑克参数
        cardSize: {
            s: {
                width: 137,
                height: 186
            },
            b: {
                width: 204,
                height: 278
            }
        },
        //扑克动画参数
        cardPickAniY: 100,
        //游戏区域参数
        gameArea: {
            x0: 134,
            y0: 110,
            x_Space: 160,
            y_Space: 69,
            y_max: 690 - 80,
            x_Adjust: 32,
            y_Adjust: 44
        },
        //关卡目标
        level: [512, 512, 1024, 1024, 1024, 2048, 2048, 2048, 2048, 4096, 4096, 4096, 4096, 4096, 8192],
        //扑克概率
        card: {
            RandType: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3],
            RandNumber: [1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, 1024, 512, 256, 128, 64, 32, 16, 8, 4, 2, -1],
            RandCdId: [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 11, 11, 11, 11, 11, 11, 11, 11, 11, 12],
            RandCd: [0, 0, 0, 0, 3, 0, 0, 0, 0, 1, 50, 50, 50, 50, 50, 50, 50, 50, 50, 50, 20],
            ConditionMinDouble: [0, 10, 5, 3, 1, 1, 1, 1, 1, 1, 0, 11, 6, 4, 1, 1, 1, 1, 1, 1, 0],
            ConditionMaxDouble: [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 15, 15, 15, 15, 15, 15, 15, 15, 15, 10],
            RatePut0_8: [0, 0, 0, 0, 1600, 1700, 1700, 1700, 1700, 1600, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
            RatePut9_16: [0, 0, 0, 0, 1600, 1700, 1700, 1700, 1700, 1600, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 100],
            RatePut17_24: [0, 0, 0, 0, 1600, 1700, 1700, 1700, 1700, 1600, 0, 0, 0, 0, 10, 15, 20, 20, 20, 15, 400],
            RatePut25_32: [0, 0, 0, 0, 1600, 1700, 1700, 1700, 1700, 1600, 0, 0, 0, 0, 20, 30, 40, 40, 40, 30, 800],
            AddRateFactor: [0, 500, 700, 1600, 200, 200, 200, 200, 200, 200, 0, 1, 1, 1, -3, -4, -6, -6, -6, -4, -100],
            RateLower: [0, 0, 0, 0, 1000, 1200, 1700, 1700, 1700, 1600, 0, 5, 5, 5, 5, 5, 10, 10, 10, 10, 300],
            RateUpper: [0, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 2000, 0, 20, 20, 20, 20, 30, 40, 40, 40, 30, 800],
        },
        flyCardNum: [12, 8, 4, 4, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 8],
        //普通模式闯关获得金币数量
        rewardGold: [3, 3, 5, 5, 5, 8, 8, 8, 8, 10, 10, 10, 10, 10, 12],
        //普通模式闯关看视频额外获得金币数量
        videoGold: 30,
        //排位养成模式每等级升级1次所需金币量，共10等级
        rankLevelUpCoin: [10, 15, 20, 25, 30, 35, 40, 45, 50, 55],
        //排位赛转盘设置
        rankTurntable: [
            { name: 'Coin', num: 100, probability: 5 },
            { name: 'CardSaved', num: 1, probability: 15 },
            { name: 'Coin', num: 5, probability: 20 },
            { name: 'OmnipotentCard', num: 1, probability: 10 },
            { name: 'Bomb', num: 1, probability: 5 },
            { name: 'CardSaved', num: 1, probability: 10 },
            { name: 'Coin', num: 10, probability: 20 },
            { name: 'OmnipotentCard', num: 1, probability: 15 },
        ]
    };
    GameDef.isRank = false;
    GameDef.maxScore = {
        normal: 0,
        ranking: 0,
    };
    core.GameDef = GameDef;
})(core || (core = {}));
