var core;
(function (core) {
    class Player {
        constructor() {
            /**每个礼包领取间隔，秒*/
            this.libaoTimesArr = [120, 180, 300, 600, 600, 600, 600, 600, 600, 600];
            /**每次转盘领取间隔，秒 */
            // private zhuanpanTimesArr: number[] = [0, 600, 600]
            this._PlayerStatus = {
                limitLibao: {
                    Day: 0,
                    RemainSeconds: 0,
                    Times: 0,
                },
                turntable: {
                    Day: 0,
                    // RemainSeconds: 0,
                    Time: 0,
                },
                // inviteFriendsList: [],
                itemList: {
                    stamp: {
                        own: [0],
                        cur: 0,
                    },
                    bg: {
                        own: [0],
                        cur: 0
                    },
                    Coin: 100,
                    rankItemLevel: {
                        OmnipotentCard: 0,
                        Bomb: 0,
                        CardSaved: 0,
                        ThinkingTime: 0
                    }
                },
                onlineSeconds: 0,
                freeItemIimes: 1,
            };
            this._countDownLoopInterval = 15;
        }
        initPlayerManager() {
            let today = Math.floor(Date.now() / 86400000);
            this._PlayerStatus.limitLibao.Day = today;
            this._PlayerStatus.turntable.Day = today;
            this._PlayerStatus.onlineSeconds = 0;
            this._PlayerStatus.turntable.Time = 0;
            // this._PlayerStatus.itemList.Coin = 100;
            let a = XnhdAPI.readDataFromCache("itemList");
            if (a && a.length > 0) {
                try {
                    a = JSON.parse(a);
                    if (a.itemList.bg) {
                        this._PlayerStatus.itemList.bg.cur = a.itemList.bg.cur;
                        this._PlayerStatus.itemList.bg.own = a.itemList.bg.own;
                    }
                    if (a.itemList.stamp) {
                        this._PlayerStatus.itemList.stamp.cur = a.itemList.stamp.cur;
                        this._PlayerStatus.itemList.stamp.own = a.itemList.stamp.own;
                    }
                    typeof a.itemList.Coin && (this._PlayerStatus.itemList.Coin = a.itemList.Coin);
                    if (a.itemList.rankItemLevel) {
                        this._PlayerStatus.itemList.rankItemLevel.OmnipotentCard = a.itemList.rankItemLevel.OmnipotentCard;
                        this._PlayerStatus.itemList.rankItemLevel.Bomb = a.itemList.rankItemLevel.Bomb;
                        this._PlayerStatus.itemList.rankItemLevel.CardSaved = a.itemList.rankItemLevel.CardSaved;
                        this._PlayerStatus.itemList.rankItemLevel.ThinkingTime = a.itemList.rankItemLevel.ThinkingTime;
                    }
                    if (typeof a.limitLibao.Day === "number" && a.limitLibao.Day === today) {
                        this._PlayerStatus.limitLibao.Times = a.limitLibao.Times;
                        this._PlayerStatus.limitLibao.RemainSeconds = (a.limitLibao.RemainSeconds > 0 && a.limitLibao.RemainSeconds < this.libaoTimesArr[this._PlayerStatus.limitLibao.Times]) ? a.limitLibao.RemainSeconds : this.libaoTimesArr[this._PlayerStatus.limitLibao.Times];
                    }
                    if (typeof a.turntable.Day === "number" && a.turntable.Day >= today) {
                        // this.PlayerStatus.zhuanpan.RemainSeconds = a.zhuanpan.RemainSeconds;
                        this._PlayerStatus.turntable.Time = a.turntable.Time;
                        a.onlineSeconds && (this._PlayerStatus.onlineSeconds = a.onlineSeconds);
                    }
                    typeof a.freeItemIimes === "number" && (this._PlayerStatus.freeItemIimes = a.freeItemIimes);
                    // typeof a.continueTimes === "number" && (this._PlayerStatus.continueTimes = a.continueTimes);
                    // this.requestInviteList();
                    // this.startCountDownTime();
                    return;
                }
                catch (e) {
                    XnhdAPI.logError("initItemManager Failed >> " + e.toString());
                }
            }
            // this.resetPlayerStatus();
            // this.requestInviteList();
            // this.startCountDownTime();
            this.savePlayerData();
        }
        /**
         * 开始礼包、转盘等的计时
         */
        startCountDownTime() {
            this._countDownLoopInterval = 15;
            Laya.timer.loop(1000, this, this.timeLoop);
        }
        /**
         * 停止礼包、转盘等的计时
         */
        stopCountDownTime() {
            Laya.timer.clear(this, this.timeLoop);
        }
        /**
         * 礼包、转盘倒计时执行方法
         */
        timeLoop() {
            this._PlayerStatus.limitLibao.RemainSeconds > 0 && this._PlayerStatus.limitLibao.RemainSeconds--;
            // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            //     if (this._PlayerStatus.onlineSeconds < 600) {
            //         this._PlayerStatus.onlineSeconds++;
            //     } else if (this._PlayerStatus.onlineSeconds === 600) {
            //         XnhdAPI.WxLiteGameAPI.AdManager.Default.showDrawer();
            //         this._PlayerStatus.onlineSeconds = 601;
            //     }
            // console.log("onlineSeconds >> " + this.PlayerStatus.onlineSeconds.toString());
            // }
            if (this._countDownLoopInterval === 0) {
                this.savePlayerData();
                this._countDownLoopInterval = 14;
            }
            else {
                this._countDownLoopInterval--;
            }
        }
        savePlayerData() {
            XnhdAPI.saveDataToCache("itemList", JSON.stringify(this._PlayerStatus), false);
        }
        adjustCoinNum(num) {
            console.log("dsAd-jlog, run in adjustCoinNum0, now:" + this._PlayerStatus.itemList.Coin + ", num:" + num);
            this._PlayerStatus.itemList.Coin += num;
            console.log("dsAd-jlog, run in adjustCoinNum1, now:" + this._PlayerStatus.itemList.Coin);
            this.savePlayerData();
        }
        /**获取某样道具的数量*/
        getCoinNum() {
            return this._PlayerStatus.itemList.Coin;
        }
        rankItemLevel_get(type) {
            return this._PlayerStatus.itemList.rankItemLevel[type];
        }
        rankItemLevel_levelUp(type) {
            this._PlayerStatus.itemList.rankItemLevel[type]++;
            this.savePlayerData();
        }
        /**获取可打开的限时礼包剩余时间，秒。注：-1时表示达到今日领取上限*/
        getLibaoRemainTime() {
            let a;
            if (this._PlayerStatus.limitLibao.Times === this.libaoTimesArr.length) {
                a = -1;
            }
            else {
                a = this._PlayerStatus.limitLibao.RemainSeconds;
                a = a > 0 ? a : 0;
            }
            return a;
        }
        /**领取限时礼包时，存下当前秒数，为下一次礼包倒计时做准备*/
        saveTimeOfGettingLibao() {
            this._PlayerStatus.limitLibao.Times++;
            XnhdAPI.logDebug('礼包打开次数：' + this._PlayerStatus.limitLibao.Times);
            this._PlayerStatus.limitLibao.RemainSeconds = this.libaoTimesArr[this._PlayerStatus.limitLibao.Times];
            XnhdAPI.logDebug('礼包剩余时间：' + this._PlayerStatus.limitLibao.RemainSeconds);
            this.savePlayerData();
        }
        getTimeOfGettingLibao() {
            return this._PlayerStatus.limitLibao.Times;
        }
        // /**
        //  * 请求邀请好友数据
        //  */
        // public requestInviteList() {
        //     if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
        //         XnhdAPI.WxLiteGameAPI.requestInviteList(res => {
        //             core.Player.Manager.getInviteFriends(res);
        //         })
        //     }
        // }
        // /**
        //  * 邀请好友，输入获得的邀请好友数组，返回json格式数据，默认输入null，直接获得本地缓存的好友数组
        //  * @param inputFriendsArr 输入本次拿到的邀请好友列表
        //  */
        // public getInviteFriends(inputFriends: any[] = null): FriendsInviteInfo[] {
        //     if (inputFriends) {
        //         let inputFriendsArr;
        //         //处理前先复制一份，按照openid排序
        //         try {
        //             inputFriendsArr = JSON.parse(JSON.stringify(inputFriends));
        //         } catch (e) {
        //             inputFriendsArr = inputFriends.slice(0);
        //         }
        //         //按照openid排序，跟邀请好友页面排序顺序一致
        //         inputFriendsArr.sort((a: core.FriendsInviteInfo, b: core.FriendsInviteInfo) => {
        //             return a.openid > b.openid ? -1 : 1
        //         })
        //         for (let i = 0; i < inputFriendsArr.length; i++) {
        //             this.putInFriendsList(inputFriendsArr[i]);
        //         }
        //         this.savePlayerData();
        //     }
        //     return this._PlayerStatus.inviteFriendsList
        // }
        // /**
        //  * 将好友信息做判断累加放入数组内
        //  * @param friendInformation 好友信息
        //  */
        // private putInFriendsList(friendInformation: any) {
        //     let putInTest = true;
        //     for (let i = 0; i < this._PlayerStatus.inviteFriendsList.length; i++) {
        //         if (friendInformation.openid === this._PlayerStatus.inviteFriendsList[i].openid) {
        //             putInTest = false;
        //             break;
        //         }
        //     }
        //     if (putInTest) {
        //         let a: FriendsInviteInfo = {
        //             index: this._PlayerStatus.inviteFriendsList.length,
        //             openid: friendInformation.openid,
        //             avatar: friendInformation.avatar,
        //             nickname: friendInformation.nick,
        //             getReward: false
        //         };
        //         this._PlayerStatus.inviteFriendsList.push(a);
        //     }
        // }
        // /**
        //  * 从邀请的某位好友处拿到奖励
        //  * @param friendInformation 好友的信息
        //  */
        // public getRewardsFromOneFriend(friendInformation: FriendsInviteInfo): boolean {
        //     for (let i = 0; i < this._PlayerStatus.inviteFriendsList.length; i++) {
        //         if (friendInformation.openid === this._PlayerStatus.inviteFriendsList[i].openid && !this._PlayerStatus.inviteFriendsList[i].getReward) {
        //             this._PlayerStatus.inviteFriendsList[i].getReward = true;
        //             this.savePlayerData();
        //             return true;
        //         }
        //     }
        //     return false;
        // }
        /**领取转盘奖励时，存下当前状态，为下一次做准备*/
        saveTimeOfZhuanpan() {
            this._PlayerStatus.turntable.Time++;
            // this.PlayerStatus.zhuanpan.RemainSeconds = this.zhuanpanTimesArr[this.PlayerStatus.zhuanpan.Time];
            this.savePlayerData();
        }
        getTimesOfZhuanpan() {
            return this._PlayerStatus.turntable.Time;
        }
        getZhuanpanTicketNum() {
            return this._PlayerStatus.itemList["10"];
        }
        getFreeItemIimes() {
            return this._PlayerStatus.freeItemIimes;
        }
        /**一般调整免费道具获得数量时都伴随道具改变，本处就不用saveData */
        adjustFreeItemIimes(num) {
            this._PlayerStatus.freeItemIimes += num;
        }
        getCurSkin_stamp() {
            return this._PlayerStatus.itemList.stamp.cur;
        }
        getCurSkin_bg() {
            return this._PlayerStatus.itemList.bg.cur;
        }
        setCurSkin_stamp(id) {
            if (id > -1 && id < core.GameDef.stampParam.length && this._PlayerStatus.itemList.stamp.own.indexOf(id) > -1) {
                this._PlayerStatus.itemList.stamp.cur = id;
                this.savePlayerData();
            }
        }
        setCurSkin_bg(id) {
            if (id > -1 && id < core.GameDef.bgParam.length && this._PlayerStatus.itemList.bg.own.indexOf(id) > -1) {
                this._PlayerStatus.itemList.bg.cur = id;
                this.savePlayerData();
            }
        }
        unlockSkin_stamp(id) {
            if (id > -1 && id < core.GameDef.stampParam.length && this._PlayerStatus.itemList.stamp.own.indexOf(id) < 0) {
                this._PlayerStatus.itemList.stamp.own.push(id);
                this.savePlayerData();
                return true;
            }
            return false;
        }
        unlockSkin_bg(id) {
            if (id > -1 && id < core.GameDef.bgParam.length && this._PlayerStatus.itemList.bg.own.indexOf(id) < 0) {
                this._PlayerStatus.itemList.bg.own.push(id);
                this.savePlayerData();
                return true;
            }
            return false;
        }
        checkSkin_stamp(id) {
            if (id > -1 && id < core.GameDef.stampParam.length && this._PlayerStatus.itemList.stamp.own.indexOf(id) > -1) {
                return true;
            }
            return false;
        }
        checkSkin_bg(id) {
            if (id > -1 && id < core.GameDef.bgParam.length && this._PlayerStatus.itemList.bg.own.indexOf(id) > -1) {
                return true;
            }
            return false;
        }
    }
    Player.Manager = new Player;
    Player.ItemType = {
        OmnipotentCard: 'OmnipotentCard',
        Bomb: 'Bomb',
        CardSaved: 'CardSaved',
        ThinkingTime: 'ThinkingTime',
        Coin: 'Coin',
        TurntableTicket: 'TurntableTicket'
    };
    core.Player = Player;
})(core || (core = {}));
