// 程序入口
var GameMain;
(function (GameMain) {
    var Start = /** @class */ (function () {
        function Start() {
            var _this = this;
            this.loadingSwitch = 1;
            this.langSwitch = 1;
            XnhdAPI.Init(function () {
                core.Player.Manager.initPlayerManager();
                core.AudioAndSetting.Manager.init();
                _this.showLanguagueSelectView();
                var wx = Laya.Browser.window.wx;
                wx.showShareMenu({
                    withShareTicket: true,
                });
                wx.onShareAppMessage(function () {
                    return {
                        title: '今天，一起来消除方块吧！',
                        imageUrl: XnhdAPI.Param.localConfig.liteType[XnhdAPI.Param.channelList["2"][1]],
                        query: "",
                    };
                });
                XnhdAPI.initRankList();
            });
            Laya.loader.load([
                "unpack/zpwlogo.png",
                'unpack/fymdbbs.png',
                'unpack/fymdbhs.png',
                'unpack/lsanht.png',
            ], Laya.Handler.create(this, function () {
                _this.showLanguagueSelectView();
                var allres = [
                    { url: "res/atlas/common.atlas", type: Laya.Loader.ATLAS },
                    { url: "res/atlas/game.atlas", type: Laya.Loader.ATLAS },
                    { url: "res/atlas/other.atlas", type: Laya.Loader.ATLAS },
                    { url: "res/atlas/card.atlas", type: Laya.Loader.ATLAS },
                ];
                allres = allres.concat(core.GameDef.bgParam, core.GameDef.stampParam);
                Laya.loader.load(allres, Laya.Handler.create(_this, _this.onLoad));
            }), Laya.Handler.create(this, this.loadingProgress, null, false), Laya.Loader.IMAGE);
        }
        Start.prototype.loadingProgress = function (num) {
            // if (XnhdAPI.Param.platType === 2 && (XnhdAPI.Param.channelType === 1 || XnhdAPI.Param.channelType === 6)) {
            // 	// this._loadingProgress.setProgress(num);
            // } else {
            num = Math.floor(num * 100);
            num > 100 && (num = 100);
            num < 0 && (num = 0);
            XnhdAPI.setLoadingProgress(num);
            // }
        };
        Start.prototype.showLanguagueSelectView = function () {
            var _this = this;
            if (this.langSwitch === 0) {
                if (core.GameDef.languageIndex < 0) {
                    // XnhdAPI.setLoadingProgress(100);
                    core.AudioAndSetting.Manager.playMusic();
                    new view.langView(function () {
                        _this.onLoad();
                    });
                }
                else {
                    this.onLoad();
                }
            }
            else {
                this.langSwitch--;
            }
        };
        Start.prototype.showFPS = function () {
            this.fps = new Laya.Label;
            Laya.stage.addChild(this.fps);
            this.fps.color = '#ffffff';
            this.fps.bold = true;
            this.fps.anchorX = 1;
            this.fps.fontSize = 36;
            this.fps.pos(700 * XnhdAPI.Param.screenScale, 20 * XnhdAPI.Param.screenScale);
            this.fps.scale(XnhdAPI.Param.screenScale, XnhdAPI.Param.screenScale);
            this.fps.zOrder = 1000;
            Laya.Stat.enable();
            // Laya.timer.frameLoop(1, this, this.showFPStxt)
        };
        Start.prototype.showFPStxt = function () {
            this.fps.text = 'FPS: ' + Laya.Stat.FPS;
        };
        Start.prototype.onLoad = function () {
            if (this.loadingSwitch == 0) {
                this.showFPS();
                var res = XnhdAPI.readDataFromCache("maxScore");
                if (res && res.length) {
                    try {
                        var jsonData = JSON.parse(res);
                        if (jsonData) {
                            core.GameDef.maxScore.normal = jsonData.normal;
                            core.GameDef.maxScore.ranking = jsonData.ranking;
                        }
                    }
                    catch (e) { }
                }
                core.SceneManager.Default.ShowScene(core.GameScene.MAINSCENE);
            }
            else {
                this.loadingSwitch--;
            }
        };
        return Start;
    }());
    GameMain.Start = Start;
})(GameMain || (GameMain = {}));
new GameMain.Start();
//# sourceMappingURL=GameMain.js.map