var XnhdAPI;
(function (XnhdAPI) {
    var DeviceInfo = /** @class */ (function () {
        function DeviceInfo() {
        }
        /**
         * 初始化，包含Laya引擎初始化适配
         */
        DeviceInfo.prototype.init = function () {
            var _this = this;
            // DeviceInfo.inst.initDeviceType();
            DeviceInfo.inst.initScreen();
            Laya.stage.on(Laya.Event.RESIZE, this, function () {
                XnhdAPI.logDebug("触发了屏幕尺寸变化");
                DeviceInfo.inst.initScreen();
                _this.resizeCallback && _this.resizeCallback();
            });
        };
        /**
         * 设置屏幕尺寸发生变化时执行的方法
         * @param callback
         */
        DeviceInfo.prototype.setResizeCallback = function (callback) {
            this.resizeCallback = callback;
        };
        /**
         * 查看运行环境，按照XnhdAPI的设计与当前游戏平台种类，已经没有什么用处
         */
        DeviceInfo.prototype.initDeviceType = function () {
            if (Laya.Browser.window.conch) {
                var os = Laya.Browser.window.conch.config.getOS();
                if (os == "Conch-ios") {
                    XnhdAPI.Param.deviceType = XnhdAPI.deviceOS.IOS;
                }
                else if (os == "Conch-android") {
                    XnhdAPI.Param.deviceType = XnhdAPI.deviceOS.Android;
                }
                else {
                    XnhdAPI.Param.deviceType = XnhdAPI.deviceOS.PC;
                }
            }
            else {
                if (Laya.Browser.onAndroid) {
                    XnhdAPI.Param.deviceType = XnhdAPI.deviceOS.Android;
                }
                else if (Laya.Browser.onIOS) {
                    XnhdAPI.Param.deviceType = XnhdAPI.deviceOS.IOS;
                }
                else if (Laya.Browser.onPC) {
                    XnhdAPI.Param.deviceType = XnhdAPI.deviceOS.PC;
                }
                // else if (Laya.Browser.onMiniGame){
                // }
                else {
                    XnhdAPI.Param.deviceType = XnhdAPI.deviceOS.PC;
                }
            }
        };
        DeviceInfo.prototype.initScreen = function () {
            if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
                var deviceInfo = Laya.Browser.window.wx.getSystemInfoSync();
                ((deviceInfo.model).indexOf("iPhone X") > -1) && (XnhdAPI.Param.wxLiteBannerUIadjustParam = 107);
                XnhdAPI.Param.screenHeight = Math.floor(XnhdAPI.Param.screenWidth * deviceInfo.screenHeight / deviceInfo.screenWidth);
            }
            else {
                XnhdAPI.Param.screenHeight = Math.floor(XnhdAPI.Param.screenWidth * Laya.Browser.clientHeight / Laya.Browser.clientWidth);
            }
            this.dealScreenMode();
        };
        DeviceInfo.prototype.dealScreenMode = function () {
            if (XnhdAPI.Param.platType === 1) {
                if (Laya.stage.scaleMode != Laya.Stage.SCALE_FIXED_AUTO) {
                    Laya.stage.screenMode = "none";
                    Laya.stage.scaleMode = Laya.Stage.SCALE_FIXED_AUTO;
                }
                XnhdAPI.Param.screenScale = Math.min(Laya.Browser.width / XnhdAPI.Param.screenWidth, Laya.Browser.height / XnhdAPI.Param.screenHeight);
                typeof DeviceInfo.inst._minScale != "number" && (DeviceInfo.inst._minScale = XnhdAPI.Param.screenScale);
                XnhdAPI.Param.screenScale < DeviceInfo.inst._minScale && (XnhdAPI.Param.screenScale = DeviceInfo.inst._minScale);
            }
            else {
                if (Laya.stage.scaleMode != Laya.Stage.SCALE_FIXED_WIDTH) {
                    Laya.stage.screenMode = XnhdAPI.Param.screenMode;
                    Laya.stage.scaleMode = Laya.Stage.SCALE_FIXED_WIDTH;
                }
                XnhdAPI.Param.screenScale = Laya.Browser.width / XnhdAPI.Param.screenWidth;
            }
        };
        DeviceInfo.inst = new DeviceInfo;
        return DeviceInfo;
    }());
    XnhdAPI.DeviceInfo = DeviceInfo;
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=DeviceInfo.js.map