var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var view;
(function (view) {
    var cardUnit = /** @class */ (function (_super) {
        __extends(cardUnit, _super);
        function cardUnit() {
            var _this = _super.call(this) || this;
            _this.anchorX = 0.5;
            _this.anchorY = 0.5;
            _this.on(Laya.Event.MOUSE_DOWN, _this, _this.clickFunc);
            return _this;
        }
        cardUnit.prototype.init = function (parent, x, y, clickCallback) {
            this.gray = false;
            this.cardColor.scale(1, 1);
            this.cardColor.alpha = 1;
            this.cardColor.pos(102, 139);
            this.pos(x, y);
            this.scale(0.67, 0.67);
            this.clickCallback = clickCallback;
            parent.addChild(this);
        };
        cardUnit.prototype.clickFunc = function () {
            this.clickCallback && this.clickCallback(parseInt(this.name));
        };
        cardUnit.prototype.changeSkin = function (prop) {
            if (prop.p1 === 1) {
                this.cardColor.skin = 'card/wnp.png';
                this.cardSkin.visible = false;
            }
            else {
                this.cardSkin.visible = true;
                this.cardSkin.skin = prop.p2 === 1 ? 'card/zd.png' : core.GameDef.stampParam[core.Player.Manager.getCurSkin_stamp()].url;
                var a = Math.floor(Math.log(prop.p1) / Math.log(2));
                this.cardColor.skin = 'card/1_' + a + '.png';
            }
        };
        cardUnit.prototype.changeSkin_ani = function (prop, aniTime, callback) {
            var _this = this;
            if (aniTime === void 0) { aniTime = 300; }
            var _s = this.scaleX;
            Laya.Tween.to(this, { scaleX: _s * 1.5, scaleY: _s * 1.5, alpha: 0 }, aniTime / 2, null, Laya.Handler.create(this, function () {
                _this.changeSkin(prop);
                Laya.Tween.to(_this, { scaleX: _s, scaleY: _s, alpha: 1 }, aniTime / 2, null, Laya.Handler.create(_this, function () {
                    callback && callback();
                }));
            }));
        };
        cardUnit.prototype.pickAni = function (pickOrNot) {
            if (pickOrNot) {
                Laya.Tween.to(this, { scaleX: 1, scaleY: 1 }, 100);
            }
            else {
                Laya.Tween.to(this, { scaleX: 0.67, scaleY: 0.67 }, 100);
            }
        };
        cardUnit.prototype.showFlash = function (showOrNot) {
            this.cardEff.skin = showOrNot ? 'card/kpfg.png' : 'card/kpty.png';
        };
        cardUnit.prototype.eliminate = function (aniTime, delay, callback, delayCallback) {
            var _this = this;
            if (aniTime === void 0) { aniTime = 200; }
            if (delayCallback === void 0) { delayCallback = null; }
            Laya.timer.once(delay, this, function () {
                delayCallback && delayCallback();
                Laya.Tween.to(_this.cardColor, { scaleX: 1.5, scaleY: 1.5, alpha: 0 }, aniTime, null, Laya.Handler.create(_this, function () {
                    callback && callback();
                    _this.destroy();
                }));
            });
        };
        cardUnit.prototype.destroy = function () {
            this.removeSelf();
            this.zOrder = 0;
            this.clickCallback = null;
            Laya.Pool.recover('CardUnit', this);
        };
        return cardUnit;
    }(ui.Comp.cardUnitUI));
    view.cardUnit = cardUnit;
})(view || (view = {}));
//# sourceMappingURL=pokerUnit.js.map