var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var view;
(function (view) {
    var cultivateLayer = /** @class */ (function (_super) {
        __extends(cultivateLayer, _super);
        function cultivateLayer(parent, closeCallback) {
            var _this = _super.call(this) || this;
            parent.addChild(_this);
            _this.UIAdjust();
            _this.adjustAllText();
            _this.OmnipotentBtn.on(Laya.Event.CLICK, _this, _this.pressBtn, [core.Player.ItemType.OmnipotentCard]);
            _this.BombBtn.on(Laya.Event.CLICK, _this, _this.pressBtn, [core.Player.ItemType.Bomb]);
            _this.SaveBtn.on(Laya.Event.CLICK, _this, _this.pressBtn, [core.Player.ItemType.CardSaved]);
            _this.ThinkingBtn.on(Laya.Event.CLICK, _this, _this.pressBtn, [core.Player.ItemType.ThinkingTime]);
            _this.closeBtn.on(Laya.Event.CLICK, _this, function () { _this.destroy(); closeCallback && closeCallback(); });
            return _this;
        }
        cultivateLayer.prototype.pressBtn = function (itemName) {
            var _this = this;
            var level = core.Player.Manager.rankItemLevel_get(itemName);
            if (level < 75) {
                var plus = core.GameDef.itemLevelParseNum(level);
                var i = core.GameDef.languageIndex;
                var l = core.GameDef.localizationConfig;
                var needCoin = core.GameDef.gameParam.rankLevelUpCoin[plus];
                if (core.Player.Manager.getCoinNum() > needCoin - 1 || core.GameDef.selfTest) {
                    !core.GameDef.selfTest && core.Player.Manager.adjustCoinNum(-needCoin);
                    core.Player.Manager.rankItemLevel_levelUp(itemName);
                    this.adjustAllText();
                    var level1 = core.Player.Manager.rankItemLevel_get(itemName);
                    var plus1 = core.GameDef.itemLevelParseNum(level1);
                    plus1 > plus && XnhdAPI.showTips(l.cultivateLayer.successLevelUp[i], true, 1000);
                }
                else {
                    new view.LackOfGold(this, function () {
                        _this.coinNum.text = core.Player.Manager.getCoinNum().toString();
                    });
                }
            }
        };
        cultivateLayer.prototype.adjustAllText = function () {
            this.dealWithText(this.middleZone.getChildAt(3), core.Player.ItemType.OmnipotentCard);
            this.dealWithText(this.middleZone.getChildAt(4), core.Player.ItemType.Bomb);
            this.dealWithText(this.middleZone.getChildAt(5), core.Player.ItemType.CardSaved);
            this.dealWithText(this.middleZone.getChildAt(6), core.Player.ItemType.ThinkingTime);
            this.coinNum.text = core.Player.Manager.getCoinNum().toString();
        };
        cultivateLayer.prototype.dealWithText = function (node, itemName) {
            var i = core.GameDef.languageIndex;
            var l = core.GameDef.localizationConfig;
            var level = core.Player.Manager.rankItemLevel_get(itemName);
            node.getChildAt(0).getChildAt(0).text = l.itemDescription[itemName][i];
            var a = l.cultivateLayer[itemName];
            node.getChildAt(1).getChildAt(0).text = a ? a[i] : l.cultivateLayer.availableTimes[i];
            if (level === 75) {
                node.getChildAt(2).getChildAt(1).visible = false;
                node.getChildAt(2).getChildAt(0).visible = false;
                node.getChildAt(2).getChildAt(2).y = 55;
                node.getChildAt(2).getChildAt(2).text = l.cultivateLayer.maxLevel[i];
                node.getChildAt(1).skin = '';
                node.getChildAt(1).getChildAt(1).text = a ? '15' : '10';
                node.getChildAt(1).getChildAt(2).visible = false;
                node.getChildAt(3).getChildAt(0).width = 440;
                node.getChildAt(3).getChildAt(1).visible = false;
            }
            else {
                var plus = core.GameDef.itemLevelParseNum(level);
                node.getChildAt(2).getChildAt(1).text = core.GameDef.gameParam.rankLevelUpCoin[plus].toString();
                node.getChildAt(2).getChildAt(2).text = l.cultivateLayer.levelUp[i];
                node.getChildAt(1).getChildAt(1).text = a ? (plus + 5).toString() : plus.toString();
                node.getChildAt(1).getChildAt(2).text = a ? (plus + 6).toString() : (plus + 1).toString();
                var r = level - (plus + 5) * plus / 2;
                node.getChildAt(3).getChildAt(0).width = 440 * r / (plus + 3);
                node.getChildAt(3).getChildAt(1).text = r.toString() + ' / ' + (plus + 3).toString();
            }
        };
        cultivateLayer.prototype.UIAdjust = function () {
            this.middleZone.y = XnhdAPI.Param.screenHeight / 2 - 110 + this.middleZone.height / 2;
            this.titleTxt.text = core.GameDef.localizationConfig.cultivateLayer.title[core.GameDef.languageIndex];
        };
        return cultivateLayer;
    }(ui.Layer.cultivateLayerUI));
    view.cultivateLayer = cultivateLayer;
})(view || (view = {}));
//# sourceMappingURL=cultivateLayer.js.map