var XnhdAPI;
(function (XnhdAPI) {
    /**
     * 全平台参数配置格式模板，实际使用过程中，需要在core.GameDef中建立静态变量plats_param来记录这些参数
     */
    //本游戏项目中的参数配置位置
    // core.GameDef.plats_param
    var plats_param = {
        screenMode: "vertical",
        version: "1.0.0",
        //平台类型，具体参见下方Param.channelList说明
        platType: 2,
        //渠道类型，具体参见下方Param.channelList说明
        channelType: 1,
        nativeType: {},
        webType: {
            QuToutiao: {
                appid: ""
            },
            FunPepper: {
                game_id: 0,
                client_id: 'ra2514vk',
                mode: 'gold',
                redirect_url: '' //特殊跳转链接处理，一般不要填写
            },
            Xiaomi: {
                appid: "",
            },
        },
        liteType: {
            WxLiteGame: {
                appid: "",
                banner_ad_id: "",
                video_ad_id: [""],
                interstitial_ad_id: "",
                share_txt: [""],
                share_img: [""],
                channelIndex: 0
            },
            OppoLiteGame: {
                appid: "",
                appkey: "",
                appSecret: "",
                packageName: "",
                appName: "",
                bannerAd: "",
                interstitialAd: "",
                videoAd: "",
                mediaId: ""
            },
            VivoLiteGame: {
                packageName: "",
                CpID: "",
                appid: "",
                bannerAd: "",
                interstitialAd: ""
            },
            HudieLiteGame: {
                gameId: "",
                gameKey: "",
                share_txt: [""],
                share_img: [""],
                other: {
                    appid: "",
                    appkey: "",
                    appSid: "",
                    bannerAd: "",
                    videoAd: ""
                }
            },
            VivoPKGame: {
                GameID: "",
                GameSecret: "",
                GameKey: ""
            },
            BdLiteGame: {
                appid: "",
                appkey: "",
                appSid: "",
                bannerAd: "",
                videoAd: "",
                share_txt: [""],
                share_img: [""]
            },
            XiaomiLiteGame: {
                appid: "",
                appkey: "",
                appSecret: "",
                packageName: "",
                appName: "",
                videoAd: "",
            }
        }
    };
    /**
     * Native:APK，一般使用Java层提供的接口
     * Web:纯网页，一般使用浏览器的通用标准接口，Laya引擎自带兼容
     * Lite:轻游戏，一般使用特殊接口
     */
    var platType;
    (function (platType) {
        platType[platType["Native"] = 0] = "Native";
        platType[platType["Web"] = 1] = "Web";
        platType[platType["Lite"] = 2] = "Lite";
    })(platType = XnhdAPI.platType || (XnhdAPI.platType = {}));
    /**
     * 轻游戏
     */
    var liteType;
    (function (liteType) {
        liteType[liteType["Default"] = 0] = "Default";
        liteType[liteType["WxGame"] = 1] = "WxGame";
        liteType[liteType["OppoGame"] = 2] = "OppoGame";
        liteType[liteType["VivoGame"] = 3] = "VivoGame";
        liteType[liteType["HudieLiteGame"] = 4] = "HudieLiteGame";
        liteType[liteType["VivoPKGame"] = 5] = "VivoPKGame";
        liteType[liteType["BdLiteGame"] = 6] = "BdLiteGame";
        liteType[liteType["XiaomiLiteGame"] = 7] = "XiaomiLiteGame";
    })(liteType = XnhdAPI.liteType || (XnhdAPI.liteType = {}));
    /**
     * APK渠道
     */
    var nativeType;
    (function (nativeType) {
        nativeType[nativeType["Default"] = 0] = "Default";
        nativeType[nativeType["Xiaomi"] = 1] = "Xiaomi";
        nativeType[nativeType["OPPO"] = 2] = "OPPO";
        nativeType[nativeType["VIVO"] = 3] = "VIVO";
        nativeType[nativeType["MEIZU"] = 4] = "MEIZU";
        nativeType[nativeType["M4399"] = 5] = "M4399";
    })(nativeType = XnhdAPI.nativeType || (XnhdAPI.nativeType = {}));
    /**
     * 标准H5网页，外挂一些JSSDK
     */
    var webType;
    (function (webType) {
        webType[webType["Default"] = 0] = "Default";
        webType[webType["FunPepper"] = 1] = "FunPepper";
        webType[webType["QuToutiao"] = 2] = "QuToutiao";
        webType[webType["Xiaomi"] = 3] = "Xiaomi";
    })(webType = XnhdAPI.webType || (XnhdAPI.webType = {}));
    var languageType;
    (function (languageType) {
        languageType[languageType["zh_CN"] = 0] = "zh_CN";
        languageType[languageType["en_US"] = 1] = "en_US";
        languageType[languageType["zh_TW"] = 2] = "zh_TW";
        languageType[languageType["id_ID"] = 3] = "id_ID";
        languageType[languageType["vi_VN"] = 4] = "vi_VN";
        languageType[languageType["ja_JP"] = 5] = "ja_JP";
        languageType[languageType["ar_EG"] = 6] = "ar_EG";
    })(languageType = XnhdAPI.languageType || (XnhdAPI.languageType = {}));
    var Param = /** @class */ (function () {
        function Param() {
        }
        //是否启用全平台日志打印
        Param.logSwitch = true;
        //屏幕方向，横版适配未做，暂不要搞横屏
        Param.screenMode = "vertical"; //horizontal,vertical
        //各平台渠道配置说明文件，json数据格式，各平台类型下方用数组记录渠道名称，各数组索引即对应渠道类型，如微信小游戏在平台=2 渠道=1位置
        Param.channelList = {
            //平台编号0：Android原生平台，一般使用Java层提供的接口
            0: ["Default", "Xiaomi", "OPPO", "VIVO", "MEIZU", "4399"],
            //平台编号1：网页原生平台，一般使用浏览器的通用标准接口，Laya引擎自带兼容
            1: ["Default", "FunPepper", "QuToutiao", "Xiaomi"],
            //平台编号2：小游戏平台，一般使用H5特殊接口
            2: ["Default", "WxLiteGame", "OppoLiteGame", "VivoLiteGame", "HudieLiteGame", "VivoPKGame", "BdLiteGame", "XiaomiLiteGame"],
        };
        //设计宽度，目前所有游戏的设计宽度恒定为750
        Param.screenWidth = 750;
        //根据设计宽度和屏幕实际长宽比例调整的设计高度，iPhone X系列高度=1624
        Param.screenHeight = 1334;
        //根据屏幕实际宽度，对设计宽度进行拉伸的比例倍数
        Param.screenScale = 1;
        //本地化语言专用，默认1-简体中文
        Param.languageList = ['zh-CN', 'en-US', 'zh-TW', 'id-ID', 'vi-VN', 'ja-JP', 'ar-EG'];
        Param.curLanguage = 0;
        //wxonShow事件暂存队列（废弃）
        Param.wxLiteOnShowLaunchArr = [];
        Param.wxLiteOnShowInGameArr = [];
        //处理微信小游戏环境下，iPhone X系列奇葩手机导航栏高度的屏幕适配调整
        Param.wxLiteBannerUIadjustParam = 0;
        //账号系统，如无特殊需求就不用
        Param.hasUserId = 0;
        return Param;
    }());
    XnhdAPI.Param = Param;
    /**
     * PC, IOS , Android
     */
    var deviceOS;
    (function (deviceOS) {
        deviceOS[deviceOS["PC"] = 0] = "PC";
        deviceOS[deviceOS["IOS"] = 1] = "IOS";
        deviceOS[deviceOS["Android"] = 2] = "Android";
    })(deviceOS = XnhdAPI.deviceOS || (XnhdAPI.deviceOS = {}));
    /**
     * 设备环境初始化，XnhdAPI初始化，Laya引擎初始化
     */
    function Init(callback, is3D) {
        if (callback === void 0) { callback = null; }
        if (is3D === void 0) { is3D = false; }
        if (window['qg']) {
            core.GameDef.plats_param.channelType === 2 && Laya.QGMiniAdapter.init();
            core.GameDef.plats_param.channelType === 7 && Laya.KGMiniAdapter.init();
        }
        else if (window['swan'] && laya.bd.mini.BMiniAdapter) {
            laya.bd.mini.BMiniAdapter.init();
        }
        else if (window['wx']) {
            Laya.MiniAdpter.init(true, false);
        }
        !is3D ? Laya.init(Laya.Browser.width, Laya.Browser.height, Laya.WebGL) : Laya3D.init(Laya.Browser.width, Laya.Browser.height);
        Laya.MouseManager.multiTouchEnabled = false;
        getLocalConfig();
        core.AudioAndSetting.Manager.init();
        XnhdAPI.DeviceInfo.inst.init();
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.init(Param.localConfig.liteType[Param.channelList["2"][1]], callback);
            return;
        }
        if (XnhdAPI.Param.platType === 0) {
            XnhdAPI.NativeGameAPI.init(callback);
            return;
        }
        callback && callback();
    }
    XnhdAPI.Init = Init;
    function setErrorCallback(_errorCallback) {
        Param.errorCallback = _errorCallback;
    }
    XnhdAPI.setErrorCallback = setErrorCallback;
    /**
     * 上传游戏最高分给对应渠道
     * @param score 分数
     */
    function updateHighScore(score) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.updateScore(score);
            return;
        }
    }
    XnhdAPI.updateHighScore = updateHighScore;
    /*
     * 读取本地配置文件，具体参见本页顶端
     */
    function getLocalConfig() {
        XnhdAPI.Param.localConfig = core.GameDef.plats_param;
        var a = core.GameDef.plats_param.platType;
        if (typeof a === "number" && Param.channelList[a.toString()]) {
            XnhdAPI.Param.platType = core.GameDef.plats_param.platType;
            var b = core.GameDef.plats_param.channelType;
            if (typeof b === "number" && Param.channelList[a.toString()][b]) {
                XnhdAPI.Param.channelType = b;
            }
            else if (typeof b === "string" && Param.channelList[a.toString()].indexOf(b) > -1) {
                XnhdAPI.Param.channelType = Param.channelList[a.toString()].indexOf(b);
            }
            else {
                XnhdAPI.logError("配置文件的channelType参数错误");
            }
        }
        else {
            XnhdAPI.logError("配置文件的platType参数错误");
        }
        // Laya.loader.load("res/config/game_config.json", Laya.Handler.create(this, e => {
        //     XnhdAPI.Param.localConfig = Laya.loader.getRes("res/config/game_config.json");
        //     if (XnhdAPI.Param.localConfig) {
        //         XnhdAPI.Param.platType = XnhdAPI.Param.localConfig.platType;
        //         XnhdAPI.Param.channelType = XnhdAPI.Param.localConfig.channelType;
        //     } else {
        //         XnhdAPI.logError("get loadConfig Error");
        //     }
        //     callback();
        // }), null, Laya.Loader.JSON);
    }
    /**
     * 登录
     */
    function Login() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.login();
            return;
        }
        // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 2) {
        //     OppoLiteGameAPI.login();
        //     return;
        // }
    }
    XnhdAPI.Login = Login;
    /**
     * 分享图片接口，目前仅供微信使用
     * @param forReward 是否是为了奖励而进行分享
     * @param sceneNum 调起分享图片的场景编号，自定
     * @param successCallback 分享成功回调
     * @param failCallback 分享失败回调
     * @param text 分享标题，暂不支持修改图片
     * @param query 分享所带参数
     */
    function shareImage(forReward, sceneNum, successCallback, failCallback, text, query) {
        if (forReward === void 0) { forReward = false; }
        if (sceneNum === void 0) { sceneNum = 0; }
        if (successCallback === void 0) { successCallback = null; }
        if (failCallback === void 0) { failCallback = null; }
        if (text === void 0) { text = null; }
        if (query === void 0) { query = null; }
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.shareImage(forReward, successCallback, failCallback, sceneNum, text, query);
            return;
        }
    }
    XnhdAPI.shareImage = shareImage;
    /**暂不用 */
    function shareScreen(title, x, y, width, height) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.shareScreen(title, x, y, width, height);
        }
    }
    XnhdAPI.shareScreen = shareScreen;
    /**
     * 存储数据缓存
     * @param key 数据标识
     * @param content 数据内容
     * @param isInt 数据是否为整数
     * @param successCallback 保存成功回调
     */
    function saveDataToCache(key, content, isInt, successCallback) {
        if (isInt === void 0) { isInt = false; }
        if (successCallback === void 0) { successCallback = null; }
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.saveDataToCache(key, content, successCallback);
            return;
        }
        isInt && (content = content.toString());
        Laya.LocalStorage.setItem(key, content);
    }
    XnhdAPI.saveDataToCache = saveDataToCache;
    /**
     * 读取缓存
     * @param key 数据标识
     * @param isInt 是否Int
     */
    function readDataFromCache(key, isInt) {
        if (isInt === void 0) { isInt = false; }
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            var d = XnhdAPI.WxLiteGameAPI.getDataFromCache(key);
            if (isInt && typeof d === "string") {
                if (d.length === 0) {
                    d = 0;
                }
                else {
                    d = parseInt(d);
                }
            }
            return d;
        }
        var a = Laya.LocalStorage.getItem(key);
        if (isInt && a) {
            return parseInt(a);
        }
        return a;
    }
    XnhdAPI.readDataFromCache = readDataFromCache;
    /**
     * http请求
     * @param url 请求地址
     * @param callback 请求成功回调，包含返回数据
     * @param data 请求的数据，字符串
     * @param failCallback 请求失败的回调
     */
    function requestHttp(url, successCallback, data, failCallback) {
        if (data === void 0) { data = ""; }
        if (failCallback === void 0) { failCallback = null; }
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.requestHttpOriginal(url, successCallback, data, failCallback);
            return;
        }
        normalRequestHttp(url, successCallback, data, failCallback);
    }
    XnhdAPI.requestHttp = requestHttp;
    var http_Instance;
    /**普通的http请求 */
    function normalRequestHttp(url, successCallback, data, failCallback) {
        http_Instance = new Laya.HttpRequest;
        http_Instance.http.timeout = 10000;
        http_Instance.http.withCredentials = true;
        http_Instance.once(Laya.Event.COMPLETE, this, function (res) {
            successCallback && successCallback(res);
        });
        http_Instance.once(Laya.Event.ERROR, this, function (f) {
            failCallback && failCallback(f);
        });
        http_Instance.send(url, data, 'post', 'text', ["Content-Type", "application/json"]);
    }
    // export function downloadFile(content, successCallback, failCallback) {
    // }
    /**
     * 程序回到前台时执行方法
     * @param callback 执行方法
     */
    function onShow(callback) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.setOnShow(callback);
            return;
        }
    }
    XnhdAPI.onShow = onShow;
    /**
     * 程序转入后台时执行方法
     * @param callback 执行方法
     */
    function onHide(callback) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.setOnHide(callback);
            return;
        }
    }
    XnhdAPI.onHide = onHide;
    /**
     * 初始化排行榜
     */
    function initRankList() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.init();
            return;
        }
    }
    XnhdAPI.initRankList = initRankList;
    /**
     * 显示竖版大排行榜
     * @param panel 加载到哪个panel区域
     */
    function showRankList(panel) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.showRankList(panel);
            return;
        }
    }
    XnhdAPI.showRankList = showRankList;
    /**
     * 竖版大排行榜上下拖动操作
     * @param offsetY 移动距离
     */
    function moveRankList(offsetY) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.moveRankList(offsetY);
            return;
        }
    }
    XnhdAPI.moveRankList = moveRankList;
    /**
     * 关闭所有类型排行榜
     */
    function closeRankList() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.closeWxSub();
            return;
        }
    }
    XnhdAPI.closeRankList = closeRankList;
    /**
     * 显示横版三人小排行榜
     * @param panel 加载到哪个panel区域
     */
    function showSmallRankList(panel) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.showSmallRankList(panel);
            return;
        }
    }
    XnhdAPI.showSmallRankList = showSmallRankList;
    /**
     * 初始化即将超越排行榜
     * @param panel 加载到哪个panel区域
     * @param score 初始化所需分数（或关卡等其他排序所需参数）
     */
    function initNextFriend(panel, score) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.showNextFriend(panel, score);
            return;
        }
    }
    XnhdAPI.initNextFriend = initNextFriend;
    /**
     * 更新即将超越排行榜
     * @param score 更新的分数（或关卡等其他排序所需参数）
     */
    function showNextFriend(score) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.Subcontent.Manager.changeNextFriend(score);
            return;
        }
    }
    XnhdAPI.showNextFriend = showNextFriend;
    /**
     * 显示banner广告（oppo小游戏的广告和NativeAPK的包还无法调整）
     * @param positionY banner广告显示到什么位置
     */
    function showBannerAd(positionY) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.AdManager.Default.showWxLiteGameBannerAd(positionY);
            return;
        }
        if (XnhdAPI.Param.platType === 0) {
            XnhdAPI.NativeGameAPI.showBannerAd(positionY);
            return;
        }
    }
    XnhdAPI.showBannerAd = showBannerAd;
    /**
     * 隐藏banner广告
     */
    function hideBannerAd() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.AdManager.Default.hideWxLiteGameBannerAd();
            return;
        }
        if (XnhdAPI.Param.platType === 0) {
            XnhdAPI.NativeGameAPI.hideBannerAd();
            return;
        }
    }
    XnhdAPI.hideBannerAd = hideBannerAd;
    /**
     * 显示视频广告
     * @param successCallback 视频广告完整看完时的回调
     * @param failCallback 其他情况回调，如回调参数为空，表明视频没有加载成功，如果回调参数是字符串，表示用户没有看完广告
     */
    function showVideoAd(successCallback, failCallback) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.AdManager.Default.showWxLiteGameVideoAd(successCallback, failCallback);
            return;
        }
        if (XnhdAPI.Param.platType === 0) {
            XnhdAPI.NativeGameAPI.showVideoAd(successCallback, failCallback);
            return;
        }
    }
    XnhdAPI.showVideoAd = showVideoAd;
    /**
     * 获取当前视频广告的状态，暂时仅限微信
     * 默认为0，此时广告状态异常，建议隐藏视频广告入口。
     * 返回1时，表明当前视频广告加载成功但没有适合该用户的情况，也建议隐藏广告入口，或者告知用户第二天再看。
     * 返回2时，表明当前视频广告正在加载中，可以稍后重试。
     * 返回3时，表明广告加载成功，可以拉起广告
     */
    function checkVideoAd() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            if (XnhdAPI.WxLiteGameAPI.AdManager.Default.getVideoStatus()) {
                return 3;
            }
            else {
                return 0;
            }
        }
        else if (XnhdAPI.Param.platType === 0) {
            return XnhdAPI.NativeGameAPI.checkVideoAd() ? 3 : 0;
        }
        else {
            return 0;
        }
    }
    XnhdAPI.checkVideoAd = checkVideoAd;
    /**
     * 显示插屏广告
     * @param successCallback 插屏广告关闭时的回调（即有广告收入时的成功回调）
     * @param failCallback 插屏广告显示失败时的回调
     */
    function showInterstitialAd(successCallback, failCallback) {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.AdManager.Default.showWxInterstitial(successCallback, failCallback);
            return;
        }
        if (XnhdAPI.Param.platType === 0) {
            XnhdAPI.NativeGameAPI.showInterstitialAd(successCallback, failCallback);
            return;
        }
    }
    XnhdAPI.showInterstitialAd = showInterstitialAd;
    /**
     * 显示悬浮窗广告
     */
    function showFloatAd() {
        if (XnhdAPI.Param.platType === 0) {
            XnhdAPI.NativeGameAPI.showFloatAd();
            return;
        }
    }
    XnhdAPI.showFloatAd = showFloatAd;
    /**
     * SBvivoLite导致界面适配性出现问题，使用这个函数处理"局部坐标转换全局坐标"
     * @param fromSpr 某一节点
     * @param pos 该节点的坐标点
     */
    function localToGlobal(fromSpr, pos) {
        fromSpr.localToGlobal(pos);
        var a = new Laya.Point(pos.x / Param.screenScale, pos.y / Param.screenScale);
        return a;
    }
    XnhdAPI.localToGlobal = localToGlobal;
    /**
     * SBvivoLite导致界面适配性出现问题，使用这个函数处理"全局坐标转换局部坐标"
     * @param toSpr 转换到某一节点
     * @param pos 全局坐标点
     */
    function globalToLocal(toSpr, pos) {
        var a = new Laya.Point(pos.x * Param.screenScale, pos.y * Param.screenScale);
        toSpr.globalToLocal(a);
        return a;
    }
    XnhdAPI.globalToLocal = globalToLocal;
    //SBvivoLite导致界面适配性出现问题，必须使用这个函数才能获取真实的鼠标坐标
    function realMousePosition() {
        return new Laya.Point(Laya.stage.mouseX / Param.screenScale, Laya.stage.mouseY / Param.screenScale);
    }
    XnhdAPI.realMousePosition = realMousePosition;
    /**
     * 游戏加载进度条
     * @param num 进度百分比，正常传入整数0-100即可，传入101表示将加载页面关闭
     */
    function setLoadingProgress(num) {
        if (XnhdAPI.Param.platType === 0) {
            num < 101 && Laya.Browser.window.loadingView.loading(num);
            return;
        }
    }
    XnhdAPI.setLoadingProgress = setLoadingProgress;
    /**
     * 设置语言
     * @param language 字符串，一般是国际标准代号，例如'zh-CN'代表简体中文
     */
    function setLanguage(language) {
        var a = Param.languageList.indexOf(language);
        if (a > -1) {
            Param.curLanguage = a;
        }
        else {
            XnhdAPI.logError('不支持当前传入的语言字符串：' + language);
        }
    }
    XnhdAPI.setLanguage = setLanguage;
    /**
     * 简易的屏幕居中黑色背景的Tips文字展示，lag秒钟后变淡销毁
     * @param tipsText 文字内容
     * @param lag 延迟销毁毫秒数
     */
    function showTips(tipsText, blackBg, lag) {
        if (blackBg === void 0) { blackBg = true; }
        if (lag === void 0) { lag = 2000; }
        // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === XnhdAPI.1) {
        //     WxLiteGameAPI.showWxToast(tipsText);
        // } else {
        var tips = Laya.stage.getChildByName("XnhdTips");
        if (tips) {
            Laya.Tween.clearAll(tips);
        }
        else {
            tips = new Laya.Label;
        }
        ;
        tips.width = 800;
        tips.scale(Param.screenScale, Param.screenScale);
        tips.color = "#ffffff";
        blackBg && (tips.bgColor = "#000000");
        tips.strokeColor = "#120bcf";
        tips.fontSize = 35;
        tips.stroke = 3;
        tips.bold = true;
        tips.align = "center";
        tips.padding = "20,35,20,35";
        tips.wordWrap = true;
        tips.text = tipsText;
        tips.cacheAs = "bitmap";
        tips.centerX = 0;
        tips.centerY = 0;
        tips.alpha = 0.9;
        tips.name = "XnhdTips";
        Laya.stage.addChild(tips);
        tips.zOrder = 10;
        Laya.Tween.to(tips, { alpha: 0 }, 2000, null, Laya.Handler.create(this, function () {
            tips.destroy();
        }), lag);
        // }
    }
    XnhdAPI.showTips = showTips;
    /**
     * 打印调试log
     * @param msg
     */
    function logDebug(msg) {
        if (Param.logSwitch) {
            if (XnhdAPI.Param.platType === 0) {
                XnhdAPI.NativeGameAPI.printLogToApk(msg);
            }
            else {
                // 当前时间
                console.log(formatDateTime(Date.now()) + ":" + msg);
            }
        }
    }
    XnhdAPI.logDebug = logDebug;
    /**
     * 打印错误log
     * @param msg
     */
    function logError(msg) {
        if (Param.logSwitch) {
            if (XnhdAPI.Param.platType === 0) {
                XnhdAPI.NativeGameAPI.printErrorLogToApk(msg);
            }
            else {
                // 当前时间
                console.error(formatDateTime(Date.now()) + ":" + msg);
            }
        }
    }
    XnhdAPI.logError = logError;
    function formatDateTime(time) {
        // 格式化日期，获取今天的日期和时间
        var Dates = new Date(time);
        var year = Dates.getFullYear();
        var month = (Dates.getMonth() + 1) < 10 ? '0' + (Dates.getMonth() + 1) : (Dates.getMonth() + 1).toString();
        var day = Dates.getDate() < 10 ? '0' + Dates.getDate() : Dates.getDate().toString();
        var hour = Dates.getHours() < 10 ? '0' + Dates.getHours() : Dates.getHours().toString();
        var min = Dates.getMinutes() < 10 ? '0' + Dates.getMinutes() : Dates.getMinutes().toString();
        var second = Dates.getSeconds() < 10 ? '0' + Dates.getSeconds() : Dates.getSeconds().toString();
        return year + '-' + month + '-' + day + " " + hour + ":" + min + ":" + second;
    }
    /**
     * 转成特殊用途的按钮方法，目前暂只用于将开始游戏按钮转化成微信小游戏的授权按钮，一次性使用，用户点击后直接销毁并显示原按钮
     * @param button 传入需特殊用途化处理的button
     * @param imageUrl 传入这个button图片的地址，注意！如果这个按钮图片打入了大图集，那么必须要将这个按钮图放到别的地址，不能打入到大图集中；如果没有打入大图的话，传个空字符串即可
     * @param successCallback 用户授权成功时的回调
     * @param failCallback 用户授权失败时的回调
     */
    function specializeBtn(button, imageUrl, successCallback, failCallback) {
        if (successCallback === void 0) { successCallback = null; }
        if (failCallback === void 0) { failCallback = null; }
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.createBtnWithAuthorize(button, imageUrl, successCallback, failCallback);
            return;
        }
    }
    XnhdAPI.specializeBtn = specializeBtn;
    function showSpecialBtn() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.showBtnWithAuthorize();
            return;
        }
    }
    XnhdAPI.showSpecialBtn = showSpecialBtn;
    function hideSpecialBtn() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.hideBtnWithAuthorize();
            return;
        }
    }
    XnhdAPI.hideSpecialBtn = hideSpecialBtn;
    function exitProgram() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.exitProgram();
            return;
        }
    }
    XnhdAPI.exitProgram = exitProgram;
    function vibrateShort() {
        if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
            XnhdAPI.WxLiteGameAPI.vibrateShort();
            return;
        }
    }
    XnhdAPI.vibrateShort = vibrateShort;
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=XnhdAPI.js.map