var XnhdAPI;
(function (XnhdAPI) {
    var NativeGameAPI;
    (function (NativeGameAPI) {
        /**
         * 参考laya官方文档，不要看2.0版本文档，看右边这个1.0版本文档，https://ldc.layabox.com/doc/?nav=zh-ts-7-2-2
         * 主要利用Java反射机制进行原生安卓的二次开发
         * 视频、开屏、横幅、悬浮窗等广告均在安卓层面开发，由JS代码进行主动调用
         * iOS系统也是一样的开发思路
         */
        var Param = /** @class */ (function () {
            function Param() {
            }
            Param.canPlayVideoAd = 0;
            return Param;
        }());
        NativeGameAPI.Param = Param;
        function init(callback) {
            Param.initCallback = callback;
            if (Laya.Browser.window.conch && Laya.Browser.window.conch.setOnBackPressedFunction) {
                Laya.Browser.window.conch.setOnBackPressedFunction(function () {
                    Laya.PlatformClass.createClass("xnhdAPI.ApkManager").call("PressBack");
                });
            }
            Laya.timer.frameLoop(10, this, getChannelType);
            Laya.timer.frameLoop(30, this, checkVideoAdStatus);
            window.onerror = function (errorMessage, scriptURI, lineNo, columnNo, error) {
                Laya.PlatformClass.createClass("xnhdAPI.ApkManager").call("ReportJSError", error.stack);
                XnhdAPI.Param.errorCallback && XnhdAPI.Param.errorCallback(error.stack);
            };
        }
        NativeGameAPI.init = init;
        function getChannelType() {
            var _this = this;
            Laya.PlatformClass.createClass("xnhdAPI.ApkManager").callWithBack(function (res) {
                XnhdAPI.Param.channelType = res;
                XnhdAPI.logError("获得渠道信息：" + res);
                Param.initCallback && Param.initCallback();
                Laya.timer.clear(_this, getChannelType);
                Param.initCallback = null;
            }, "CheckChannel");
        }
        function checkVideoAdStatus() {
            var _this = this;
            Laya.PlatformClass.createClass("xnhdAPI.AdManager").callWithBack(function (res) {
                typeof res === "number" && (Param.canPlayVideoAd = res);
                typeof res === "boolean" && (Param.canPlayVideoAd = res ? 1 : 0);
                XnhdAPI.logError("获得视频信息：" + res);
                res && Laya.timer.clear(_this, checkVideoAdStatus);
            }, "CheckVideoAdStatus");
        }
        function showBannerAd(position) {
            XnhdAPI.logDebug('显示banner');
            Laya.PlatformClass.createClass("xnhdAPI.AdManager").call("ShowBannerAd");
        }
        NativeGameAPI.showBannerAd = showBannerAd;
        function hideBannerAd() {
            Laya.PlatformClass.createClass("xnhdAPI.AdManager").call("HideBannerAd");
        }
        NativeGameAPI.hideBannerAd = hideBannerAd;
        function checkVideoAd() {
            return Param.canPlayVideoAd === 1;
        }
        NativeGameAPI.checkVideoAd = checkVideoAd;
        /**
         * 看视频
         * @param successCallback
         * @param failCallback
         */
        function showVideoAd(successCallback, failCallback) {
            var _this = this;
            Laya.PlatformClass.createClass("xnhdAPI.AdManager").callWithBack(function (res) {
                Laya.timer.frameLoop(30, _this, checkVideoAdStatus);
                if (res === "success") {
                    successCallback && successCallback();
                }
                else if (res === "Fail") {
                    failCallback && failCallback();
                }
                else {
                    failCallback && failCallback("other");
                    XnhdAPI.NativeGameAPI.printLogToApk("apk看视频失败，原因：" + res);
                }
            }, "ShowVideoAd");
        }
        NativeGameAPI.showVideoAd = showVideoAd;
        /**
         * 显示插屏广告
         * @param successCallback
         * @param failCallback
         */
        function showInterstitialAd(successCallback, failCallback) {
            Laya.PlatformClass.createClass("xnhdAPI.AdManager").callWithBack(function (res) {
                if (res === 1) {
                    successCallback && successCallback();
                }
                else {
                    failCallback && failCallback(res);
                }
            }, "ShowInterstitial");
        }
        NativeGameAPI.showInterstitialAd = showInterstitialAd;
        /**
         * 显示悬浮窗广告
         * @param position 悬浮球广告位置，暂无用
         */
        function showFloatAd(position) {
            if (position === void 0) { position = null; }
            if (position) {
                Laya.PlatformClass.createClass("xnhdAPI.AdManager").call("ShowFloatAd", position.x, position.y);
            }
            else {
                Laya.PlatformClass.createClass("xnhdAPI.AdManager").call("ShowFloatAd", 0, 0);
            }
        }
        NativeGameAPI.showFloatAd = showFloatAd;
        function printLogToApk(message) {
            Laya.PlatformClass.createClass("xnhdAPI.ApkManager").call("LogFromGame", message);
        }
        NativeGameAPI.printLogToApk = printLogToApk;
        function printErrorLogToApk(message) {
            Laya.PlatformClass.createClass("xnhdAPI.ApkManager").call("ErrorFromGame", message);
        }
        NativeGameAPI.printErrorLogToApk = printErrorLogToApk;
    })(NativeGameAPI = XnhdAPI.NativeGameAPI || (XnhdAPI.NativeGameAPI = {}));
})(XnhdAPI || (XnhdAPI = {}));
//# sourceMappingURL=NativeGameAPI.js.map