var core;
(function (core) {
    /**
     * 游戏场景字典
     */
    var GameScene;
    (function (GameScene) {
        GameScene[GameScene["MAINSCENE"] = 0] = "MAINSCENE";
        GameScene[GameScene["GAMESCENE"] = 1] = "GAMESCENE";
        GameScene[GameScene["SceneAmount"] = 2] = "SceneAmount"; //场景的数量
    })(GameScene = core.GameScene || (core.GameScene = {}));
    /**
     * 游戏场景管理器
     */
    var SceneManager = /** @class */ (function () {
        function SceneManager() {
            this.onshowReady = false;
        }
        SceneManager.prototype.getCurScene = function () {
            return this.currentScene;
        };
        /**
         * 运行场景
         * @param gameScene 场景
         */
        SceneManager.prototype._runScene = function (gameScene) {
            var scene;
            this.currentScene = gameScene;
            switch (gameScene) {
                case GameScene.MAINSCENE: {
                    scene = new view.MainView();
                    break;
                }
                case GameScene.GAMESCENE: {
                    scene = new view.GameView();
                    break;
                }
                default: {
                    this.currentScene = null;
                }
            }
            scene.scale(XnhdAPI.Param.screenScale, XnhdAPI.Param.screenScale);
            Laya.stage.addChild(scene);
            this.curScene = scene;
        };
        /**
         * 显示场景，会将其他场景destroy
         * @param gameScene 场景
         */
        SceneManager.prototype.ShowScene = function (gameScene) {
            // if (XnhdAPI.Param.platType === XnhdAPI.platType.Lite && XnhdAPI.Param.channelType === XnhdAPI.liteType.WxGame) {
            //     WxLiteGameAPI.AdManager.Default.hideCrazyMoreGame();
            //     WxLiteGameAPI.AdManager.Default.hideCrazyFavoNode();
            //     WxLiteGameAPI.AdManager.Default.hideGameBox();
            //     WxLiteGameAPI.destroyBtnWithAuthorize();
            // }
            this.curScene && this.curScene.destroy();
            this._runScene(gameScene);
        };
        SceneManager.prototype.onShowFunction = function () {
            core.AudioAndSetting.Manager.playMusic();
        };
        SceneManager.Default = new SceneManager();
        return SceneManager;
    }());
    core.SceneManager = SceneManager;
})(core || (core = {}));
//# sourceMappingURL=SceneManager.js.map