var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var view;
(function (view) {
    var GameView = /** @class */ (function (_super) {
        __extends(GameView, _super);
        function GameView() {
            var _this = _super.call(this) || this;
            _this._pressStatus = false;
            _this._mousePos = new Laya.Point;
            _this._allowPress = true;
            _this._countDownSwitch = true;
            //视频相关
            _this._videoSwitch = true;
            //新手引导相关
            _this._guideStep = -1;
            _this._handAniNum = 0;
            _this.UIAdjust();
            XnhdAPI.DeviceInfo.inst.setResizeCallback(function () {
                _this.UIAdjust();
            });
            _this._curScore = new view.curScoreComp;
            _this.topZone.addChild(_this._curScore);
            _this._curScore.pos(375, 100);
            _this.levelText.zOrder = 1;
            core.GameLogic.Default.initGame(_this);
            return _this;
        }
        GameView.prototype.UIAdjust = function () {
            var k = XnhdAPI.Param.screenHeight - 1334; //1624-1334 = 290
            var ratio = k / (1624 - 1334);
            ratio < 0 && (ratio = 0);
            this.bg.height = XnhdAPI.Param.screenHeight;
            this.gameArea.y = 145 + Math.floor(200 * ratio);
            this.topZone.y = Math.floor(200 * ratio);
            // this.topZone.y = Math.floor(ratio*100);
            this.highScoreText0.text = core.GameDef.localizationConfig.highScore[core.GameDef.languageIndex];
            this.highScoreText0.text = core.GameDef.localizationConfig.highScore[core.GameDef.languageIndex];
            this.bg.skin = core.GameDef.bgParam[core.Player.Manager.getCurSkin_bg()].url;
            this.showBannerAd();
        };
        GameView.prototype.setMonitor = function () {
            var _this = this;
            XnhdAPI.onHide(function () {
                _this.pressPauseBtn();
            });
            this.OmnipotentCardBtn.on(Laya.Event.CLICK, this, this.pressOmnipotentCard);
            this.bombBtn.on(Laya.Event.CLICK, this, this.pressBombBtn);
            this.gameZone.on(Laya.Event.MOUSE_UP, this, this.playerRelease);
            this.gameZone.on(Laya.Event.MOUSE_OUT, this, this.playerRelease);
            this.pauseBtn.on(Laya.Event.CLICK, this, this.pressPauseBtn);
            if (core.GameDef.isRank) {
                var a = core.GameDef.itemLevelParseNum(core.Player.Manager.rankItemLevel_get(core.Player.ItemType.ThinkingTime));
                this._countDownTime = (5 + a) * 1000;
            }
            else {
                this._countDownTime = 0;
            }
            Laya.timer.frameLoop(1, this, this.monitorLoop);
        };
        GameView.prototype.pressPauseBtn = function () {
            var _this = this;
            if (this._countDownSwitch) {
                this._countDownSwitch = false;
                new view.PauseLayer(this, core.GameLogic.Default.getCurScore().toString(), function () {
                    _this._countDownSwitch = true;
                });
            }
        };
        GameView.prototype.showBannerAd = function () {
            XnhdAPI.showBannerAd(XnhdAPI.Param.screenHeight - 220);
        };
        GameView.prototype.monitorLoop = function () {
            if (this._pressStatus && this._selectCard) {
                this._mousePos.setTo(Laya.stage.mouseX, Laya.stage.mouseY);
                this.gameZone.globalToLocal(this._mousePos);
                this._selectCard.pos(this._mousePos.x, this._mousePos.y - 139);
                core.GameLogic.Default.putDownCard_test(this._selectCard.x, this._selectCard.y, this._guideStep);
            }
            if (this._countDownSwitch) {
                this._countDownTime -= Laya.timer.delta;
                if (core.GameDef.isRank) {
                    if (this._countDownTime < 0) {
                        this.rankResetCountDown();
                        core.GameLogic.Default.randPutNextPoker();
                    }
                    var a = Math.floor(this._countDownTime / 100);
                    var s = Math.floor(a / 10);
                    var s1 = a - s * 10;
                    var l = core.GameDef.localizationConfig.GameView.rankingCountDown[core.GameDef.languageIndex];
                    this.tipsText.text = l + '\n' + s + '.' + s1;
                }
                else {
                    if (this._countDownTime < 0) {
                        this._countDownTime = 10000;
                        var k = core.GameDef.localizationConfig.GameView.gameTips[core.GameDef.languageIndex];
                        this.tipsText.text = k[XnhdAPI.Tools.randomInt(0, k.length - 1)];
                    }
                }
            }
        };
        GameView.prototype.rankResetCountDown = function () {
            var a = core.GameDef.itemLevelParseNum(core.Player.Manager.rankItemLevel_get(core.Player.ItemType.ThinkingTime));
            this._countDownTime = (5 + a) * 1000;
        };
        GameView.prototype.showRenewLayer = function (free, callback) {
            new view.renewLayer(this, !free, callback);
        };
        GameView.prototype.allowPlayerPress = function (allow) {
            this._allowPress = allow;
            if (!allow) {
                this._pressStatus = false;
                core.GameLogic.Default.cancelSelectCard();
            }
        };
        GameView.prototype.setLevel = function (level, goal) {
            var t = core.GameDef.localizationConfig.GameView.curLevel[core.GameDef.languageIndex];
            var a = t.indexOf('{0}');
            var b = t.indexOf('{1}');
            this.levelText.text = t.slice(0, a) + level.toString() + t.slice(a + 3, b) + goal.toString() + t.slice(b + 3);
            var toS = 750 / this.levelText.width * 0.9;
            // let textHeight = Math.floor(this.levelText.fontSize * toS * 2);
            var textHeight = 350;
            Laya.Tween.to(this.levelText, { scaleX: toS, scaleY: toS, y: textHeight }, 750, Laya.Ease.backOut);
            Laya.Tween.to(this.levelText, { scaleX: 1, scaleY: 1, y: 18 }, 750, Laya.Ease.backInOut, null, 1250);
        };
        GameView.prototype.setScore = function (score) {
            this._curScore.setNum(score);
            if (core.GameDef.isRank) {
                if (score > core.GameDef.maxScore.ranking) {
                    core.GameDef.maxScore.ranking = score;
                }
                this.highScoreText.text = core.GameDef.maxScore.ranking.toString();
            }
            else {
                if (score > core.GameDef.maxScore.normal) {
                    core.GameDef.maxScore.normal = score;
                }
                this.highScoreText.text = core.GameDef.maxScore.normal.toString();
            }
        };
        GameView.prototype.resetGameArea = function (gameData, isGuiding) {
            var _this = this;
            // console.log("resetGameArea",isGuiding,JSON.stringify(gameData));
            var areaParam = core.GameDef.gameParam.gameArea;
            // let isRankGame = core.GameDef.isRank;
            for (var i = 0; i < gameData.mairArr.length; i++) {
                for (var j = 0; j < gameData.mairArr[i].length; j++) {
                    var cardProp = gameData.mairArr[i][j];
                    var cardObj = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
                    cardObj.init(this.gameZone, areaParam.x0 + areaParam.x_Space * i, areaParam.y0 + areaParam.y_Space * j, function (id) {
                        _this.cardClickFunc(id);
                    });
                    cardObj.changeSkin(cardProp);
                    cardObj.name = cardProp.id.toString();
                    cardObj.zOrder = 1;
                }
            }
            var nextCard2 = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
            nextCard2.init(this.gameZone, this.nextCardZone.x - core.GameDef.gameParam.cardPickAniY + core.GameDef.gameParam.gameArea.x_Adjust, this.nextCardZone.y + 9, function (id) {
                _this.cardClickFunc(id);
            });
            nextCard2.changeSkin(gameData.nextCardArr[1]);
            nextCard2.name = gameData.nextCardArr[1].id.toString();
            nextCard2.zOrder = 1;
            nextCard2.scale(0.6, 0.6);
            var nextCard1 = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
            nextCard1.init(this.gameZone, this.nextCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust, this.nextCardZone.y, function (id) {
                _this.cardClickFunc(id);
            });
            nextCard1.changeSkin(gameData.nextCardArr[0]);
            nextCard1.name = gameData.nextCardArr[0].id.toString();
            nextCard1.zOrder = 1;
            if (gameData.readyCard) {
                var readyCard = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
                readyCard.init(this.gameZone, this.readyCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust, this.readyCardZone.y, function (id) {
                    _this.cardClickFunc(id);
                });
                readyCard.changeSkin(gameData.readyCard);
                readyCard.name = gameData.readyCard.id.toString();
                readyCard.zOrder = 1;
            }
            this.setScore(gameData.curScore);
            this.setMonitor();
            if (isGuiding && core.GameDef.isRank === false) {
                this._guideStep = 0;
                this.guideLayer.visible = true;
                this.hand.visible = true;
                var from = this.getCardById(9);
                var to = this.getCardById(7);
                this.guideTips.text = core.GameDef.localizationConfig.GameView.gameGuide[core.GameDef.languageIndex][0];
                this.handAni(from.x, from.y, to.x, to.y);
            }
        };
        GameView.prototype.handAni = function (fromX, fromY, toX, toY) {
            var _this = this;
            Laya.Tween.clearAll(this.hand);
            this.hand.alpha = 0;
            this.hand.pos(fromX, fromY);
            // this._handAniNum++;
            Laya.Tween.to(this.hand, { alpha: 1 }, 500, null, Laya.Handler.create(this, function () {
                Laya.Tween.to(_this.hand, { x: toX, y: toY }, 1000, null, Laya.Handler.create(_this, function () {
                    Laya.Tween.to(_this.hand, { alpha: 0 }, 500, null, Laya.Handler.create(_this, function () {
                        // this._handAniNum--;
                        if (_this._handAniNum === 0) {
                            _this.handAni(fromX, fromY, toX, toY);
                        }
                    }));
                }));
            }));
        };
        GameView.prototype.cardClickFunc = function (id) {
            if (this._allowPress) {
                this._pressStatus = true;
                var a = false;
                //拿扑克
                if (this._guideStep < 0) {
                    a = true;
                }
                else if (this._guideStep === 0 && id === 9) {
                    a = true;
                }
                else if (this._guideStep === 1 && id === 10) {
                    a = true;
                }
                else if (this._guideStep === 2 && id === 11) {
                    a = true;
                }
                else if (this._guideStep === 3 && id === 8) {
                    a = true;
                }
                a && core.GameLogic.Default.selectWhitchCard(id);
            }
        };
        GameView.prototype.showCardFlash = function (idArr) {
            var i = 2;
            for (; i < 6; i++) {
                var a = this.gameZone.getChildAt(i);
                a.getChildAt(0).visible = idArr.indexOf(a.name) > -1;
            }
            for (; i < this.gameZone.numChildren; i++) {
                var a = this.gameZone.getChildAt(i);
                a.name != '' && a.showFlash(idArr.indexOf(a.name) > -1);
            }
        };
        GameView.prototype.putCardDown = function (i, j, guideStatus) {
            var areaParam = core.GameDef.gameParam.gameArea;
            var a = this._selectCard;
            a.removeSelf();
            this.gameZone.addChild(a);
            Laya.Tween.to(a, { x: areaParam.x0 + areaParam.x_Space * i, y: areaParam.y0 + areaParam.y_Space * j }, 100);
            // a.pos(areaParam.x0 + areaParam.x_Space * i, areaParam.y0 + areaParam.y_Space * j);
            a.pickAni(false);
            a.zOrder = 1;
            core.AudioAndSetting.Manager.sound_putDown();
            this.showCardFlash([]);
            this._selectCard = null;
            if (core.GameDef.isRank) {
                this.rankResetCountDown();
            }
        };
        GameView.prototype.putCardReady = function (guideStatus) {
            var areaParam = core.GameDef.gameParam.gameArea;
            var a = this._selectCard;
            Laya.Tween.to(a, { x: this.readyCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust, y: this.readyCardZone.y }, 100);
            // this._selectCard.pos(this.readyCardZone.x+core.GameDef.gameParam.gameArea.x_Adjust, this.readyCardZone.y);
            a.pickAni(false);
            a.zOrder = 1;
            core.AudioAndSetting.Manager.sound_putDown();
            this.showCardFlash([]);
            this._selectCard = null;
        };
        GameView.prototype.playerRelease = function () {
            if (this._allowPress && this._pressStatus && this._selectCard) {
                this._pressStatus = false;
                this._mousePos.setTo(Laya.stage.mouseX, Laya.stage.mouseY);
                this.gameZone.globalToLocal(this._mousePos);
                core.GameLogic.Default.putDownCard(this._mousePos.x, this._mousePos.y - 139, this._guideStep);
            }
        };
        GameView.prototype.cancelSelect = function (selectType, j) {
            if (this._selectCard) {
                var a = this._selectCard;
                this._selectCard = null;
                a.pickAni(false);
                a.zOrder = 1;
                var _x = void 0, _y = void 0;
                if (selectType === core.selectCardType.nextCard) {
                    _x = this.nextCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust;
                    _y = this.nextCardZone.y;
                }
                else if (selectType === core.selectCardType.readyCard) {
                    _x = this.readyCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust;
                    _y = this.readyCardZone.y;
                }
                else {
                    var areaParam = core.GameDef.gameParam.gameArea;
                    _x = areaParam.x0 + areaParam.x_Space * (selectType - 1);
                    _y = areaParam.y0 + areaParam.y_Space * j;
                }
                Laya.Tween.to(a, { x: _x, y: _y }, 100);
                this.showCardFlash([]);
            }
        };
        GameView.prototype.pressOmnipotentCard = function () {
            if (this._allowPress) {
                core.GameLogic.Default.useOmnipotentCard();
            }
        };
        GameView.prototype.nextCardChange = function (nextCardArr, callback) {
            var b = 2;
            for (var i = 0; i < 2; i++) {
                var a = this.getCardById(nextCardArr[i].id);
                a.changeSkin_ani(nextCardArr[i], 300, function () {
                    b--;
                    if (b === 0) {
                        callback && callback();
                    }
                });
            }
        };
        GameView.prototype.pressBombBtn = function () {
            if (this._allowPress) {
                core.GameLogic.Default.useBomb();
            }
        };
        GameView.prototype.useBombEff = function (arr, scoreArr) {
            var _this = this;
            this.allowPlayerPress(false);
            var count = 0;
            for (var i = 0; i < arr.length; i++) {
                for (var j = 0; j < arr[i].length; j++) {
                    count++;
                }
            }
            var d = count;
            for (var i = 0; i < arr.length; i++) {
                var _loop_1 = function (j) {
                    var a = this_1.getCardById(arr[i][j].id);
                    var index = d - count;
                    var delay = Math.floor(index / 4);
                    a.eliminate(200, delay * 20, function () {
                        count--;
                        _this.setScore(scoreArr[index]);
                        var eff = new eliminateEff_Obj;
                        eff.init(a.x, a.y, _this.gameArea, 1);
                        if (count === 0) {
                            _this.allowPlayerPress(true);
                        }
                    });
                };
                var this_1 = this;
                for (var j = 0; j < arr[i].length; j++) {
                    _loop_1(j);
                }
            }
            core.AudioAndSetting.Manager.sound_bomb();
        };
        GameView.prototype.resetCoinNum = function () {
            this.coinText.text = core.Player.Manager.getCoinNum().toString();
        };
        GameView.prototype.resetOmnipotentCardNum = function (free, paid) {
            var t = core.GameDef.localizationConfig.itemDescription.OmnipotentCard[core.GameDef.languageIndex] + core.GameDef.localizationConfig.itemDescription.pluralType[core.GameDef.languageIndex];
            var txt = this.OmnipotentCardBtn.getChildAt(0);
            var videoImg = this.OmnipotentCardBtn.getChildAt(1);
            var itemSkin = this.OmnipotentCardBtn.getChildAt(2);
            videoImg.visible = free === 0 && paid > 0;
            itemSkin.x = !videoImg.visible ? this.OmnipotentCardBtn.width / 2 : 46;
            txt.text = t + (free > 0 ? free.toString() : paid.toString());
        };
        GameView.prototype.resetBombNum = function (free, paid) {
            var t = core.GameDef.localizationConfig.itemDescription.Bomb[core.GameDef.languageIndex] + core.GameDef.localizationConfig.itemDescription.pluralType[core.GameDef.languageIndex];
            var txt = this.bombBtn.getChildAt(0);
            var videoImg = this.bombBtn.getChildAt(1);
            var itemSkin = this.bombBtn.getChildAt(2);
            videoImg.visible = free === 0 && paid > 0;
            itemSkin.x = !videoImg.visible ? this.bombBtn.width / 2 : 46;
            txt.text = t + (free > 0 ? free.toString() : paid.toString());
        };
        GameView.prototype.resetCardSaveTimes = function (free, paid) {
            var t = core.GameDef.localizationConfig.itemDescription.CardSaved[core.GameDef.languageIndex] + core.GameDef.localizationConfig.itemDescription.pluralType[core.GameDef.languageIndex];
            var videoImg = this.readyCardZone.getChildAt(0);
            videoImg.visible = free === 0 && paid > 0;
            this.readyCardRemain.text = t + (free > 0 ? free.toString() : paid.toString());
            this.readyCardRemain.y = videoImg.visible ? 55 : this.readyCardZone.height / 2;
        };
        GameView.prototype.showNoSavedCard = function (successCallback, failCallback) {
            this.getVideoItem(successCallback, failCallback);
        };
        GameView.prototype.showNoOmnipotentCard = function (successCallback, failCallback) {
            this.getVideoItem(successCallback, failCallback);
        };
        GameView.prototype.showNoBomb = function (successCallback, failCallback) {
            this.getVideoItem(successCallback, failCallback);
        };
        GameView.prototype.getVideoItem = function (successCallback, failCallback) {
            var _this = this;
            if (!core.GameDef.isRank) {
                if (this._videoSwitch) {
                    if (XnhdAPI.checkVideoAd() === 3) {
                        this._videoSwitch = false;
                        XnhdAPI.showVideoAd(function () {
                            _this._videoSwitch = true;
                            successCallback && successCallback();
                        }, function (f) {
                            _this._videoSwitch = true;
                            failCallback && failCallback();
                        });
                    }
                    else {
                        XnhdAPI.showTips(core.GameDef.localizationConfig.noVideoTips[core.GameDef.languageIndex], true, 1000);
                        failCallback && failCallback();
                    }
                }
            }
            else {
                failCallback && failCallback();
            }
        };
        GameView.prototype.pickOneCard = function (id) {
            if (this._allowPress) {
                this._selectCard = this.getCardById(id);
                this._selectCard.zOrder = 3;
                this._selectCard.pickAni(true);
                core.AudioAndSetting.Manager.sound_pickUp();
                this._pressStatus = true;
                // if (isCurrent === 3) {
                this._mousePos.setTo(Laya.stage.mouseX, Laya.stage.mouseY);
                this.gameZone.globalToLocal(this._mousePos);
                // }
                // core.GameLogic.Default.selectWhitchCard(isCurrent, this._mousePos);
            }
        };
        GameView.prototype.getCardById = function (id) {
            return this.gameZone.getChildByName(id.toString());
        };
        GameView.prototype.showNextCardAni = function (nextArr, callback) {
            var _this = this;
            var nextCard2 = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
            nextCard2.init(this.gameZone, this.nextCardZone.x - core.GameDef.gameParam.cardPickAniY + core.GameDef.gameParam.gameArea.x_Adjust, this.nextCardZone.y + 9, function (id) {
                _this.cardClickFunc(id);
            });
            nextCard2.changeSkin(nextArr[1]);
            nextCard2.name = nextArr[1].id.toString();
            nextCard2.scale(0, 0);
            nextCard2.alpha = 0;
            nextCard2.zOrder = 0;
            Laya.Tween.to(nextCard2, { scaleX: 0.6, scaleY: 0.6, alpha: 1 }, 200);
            var nextCard1 = this.getCardById(nextArr[0].id);
            nextCard1.zOrder = 1;
            Laya.Tween.to(nextCard1, { x: this.nextCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust, y: this.nextCardZone.y, scaleX: 0.67, scaleY: 0.67, }, 200, null, Laya.Handler.create(this, function () {
                callback && callback();
            }));
        };
        GameView.prototype.eliminateCards = function (cardArr, scoreArr, changeCard, callback) {
            var _this = this;
            this.hand.visible = false;
            var i = 0;
            var delay = 200;
            var notHasBomb = true;
            var _loop_2 = function () {
                var card = this_2.getCardById(cardArr[i].id);
                var b = i + 1;
                var cardBack = i != cardArr.length - 1 ? this_2.getCardById(cardArr[b].id) : null;
                if (notHasBomb && cardArr[i].p2 === 1) {
                    notHasBomb = false;
                }
                var effSwitch = !notHasBomb;
                card.eliminate(200, delay, function () {
                    _this.setScore(scoreArr[b - 1]);
                    cardBack && cardBack.changeSkin(cardArr[b]);
                    if (effSwitch) {
                        // let eff = new eliminateEff_Obj;
                        // eff.init(card.x, card.y, this.gameZone);
                    }
                    else {
                        core.AudioAndSetting.Manager.soundCombo(b);
                    }
                }, function () {
                    var eff = new eliminateEff_Obj;
                    eff.init(card.x, card.y, _this.gameArea, 1);
                });
                delay += notHasBomb ? 300 : 50;
            };
            var this_2 = this;
            for (; i < cardArr.length; i++) {
                _loop_2();
            }
            Laya.timer.once(delay, this, function () {
                if (notHasBomb && i > 2) {
                    core.AudioAndSetting.Manager.soundCongratulate(i - 2);
                }
                if (changeCard) {
                    var card = _this.getCardById(changeCard.id);
                    card.changeSkin(changeCard);
                }
                //消除扑克
                if (_this._guideStep === 0) {
                    _this.hand.visible = true;
                    _this._guideStep++;
                    // let from = this.getCardById(10);
                    // let to = this.getCardById(7);
                    _this.guideTips.text = core.GameDef.localizationConfig.GameView.gameGuide[core.GameDef.languageIndex][1];
                    // this.handAni(from.x, from.y, to.x, to.y);
                }
                else if (_this._guideStep === 1) {
                    _this.hand.visible = true;
                    _this._guideStep++;
                    _this.guideTips.text = core.GameDef.localizationConfig.GameView.gameGuide[core.GameDef.languageIndex][2];
                    var from = _this.getCardById(11);
                    var to = _this.getCardById(4);
                    _this.handAni(from.x, from.y, to.x, to.y);
                }
                else if (_this._guideStep === 3) {
                    _this._guideStep++;
                    Laya.Tween.clearAll(_this.hand);
                    _this._handAniNum = 10;
                    _this.guideLayer.visible = false;
                    _this.hand.visible = false;
                    new guideFinish(_this, function () {
                        _this._guideStep = -1;
                        _this._countDownSwitch = true;
                        core.GameLogic.Default.finishGuiding();
                    });
                }
                callback && callback();
            });
        };
        GameView.prototype.showLevelUp = function (levelUpCard, score, level, callback) {
            var _this = this;
            this.allowPlayerPress(false);
            core.AudioAndSetting.Manager.sound_levelUp();
            this._countDownSwitch = false;
            var card = this.getCardById(levelUpCard.id);
            card.zOrder = 2;
            var coinNum = core.GameDef.gameParam.rewardGold[level];
            if (level > core.GameDef.gameParam.rewardGold.length - 1) {
                coinNum = core.GameDef.gameParam.rewardGold[core.GameDef.gameParam.rewardGold.length - 1];
            }
            Laya.Tween.to(card, { x: 375, y: 320, scaleX: 1, scaleY: 1 }, 500, null, Laya.Handler.create(this, function () {
                _this.setScore(score);
                card.eliminate(200, 0, function () {
                    var eff = new eliminateEff_Obj;
                    eff.init(card.x, card.y, _this.gameArea);
                    if (_this._guideStep === 2) {
                        _this.allowPlayerPress(true);
                        _this.hand.visible = true;
                        _this._guideStep++;
                        _this.guideTips.text = core.GameDef.localizationConfig.GameView.gameGuide[core.GameDef.languageIndex][3];
                        var from = _this.getCardById(8);
                        var to = _this.getCardById(3);
                        _this.handAni(from.x, from.y, to.x, to.y);
                    }
                    else if (core.GameDef.isRank) {
                        new view.TurntableLayer(_this, level, function (e) {
                            _this._countDownSwitch = true;
                            var a = core.GameDef.itemLevelParseNum(core.Player.Manager.rankItemLevel_get(core.Player.ItemType.ThinkingTime));
                            _this._countDownTime = (6 + a) * 1000;
                            callback && callback(e);
                        });
                    }
                    else {
                        new view.levelUpLayer(coinNum, function (e) {
                            if (e) {
                                callback && callback({
                                    name: 'Coin',
                                    num: coinNum + 10
                                });
                            }
                            else {
                                callback && callback({
                                    name: 'Coin',
                                    num: coinNum
                                });
                            }
                        }, function () {
                            _this._countDownSwitch = true;
                        }, _this);
                    }
                });
            }));
        };
        GameView.prototype.levelUpAddCard = function (cardArr, callback) {
            var _this = this;
            var areaParam = core.GameDef.gameParam.gameArea;
            for (var i = 0; i < cardArr.length; i++) {
                var card = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
                card.init(this.gameZone, 0, -145, function (id) {
                    _this.cardClickFunc(id);
                });
                card.changeSkin(cardArr[i].card);
                card.scale(0, 0);
                card.name = cardArr[i].card.id.toString();
                card.zOrder = 1;
                var ij = cardArr[i].ij;
                Laya.Tween.to(card, { scaleX: 0.67, scaleY: 0.67, x: areaParam.x0 + areaParam.x_Space * ij[0], y: areaParam.y0 + areaParam.y_Space * ij[1] }, 300, null, Laya.Handler.create(this, function () {
                    core.AudioAndSetting.Manager.sound_putDown();
                }), 100 + i * 100);
            }
            Laya.timer.once(cardArr.length * 100 + 400, this, function () {
                _this.allowPlayerPress(true);
                callback && callback();
            });
        };
        GameView.prototype.showGameOver = function () {
            var _this = this;
            core.AudioAndSetting.Manager.sound_gameOver();
            this._countDownSwitch = false;
            this.allowPlayerPress(false);
            // this.gameArea.offAll();
            Laya.timer.clear(this, this.monitorLoop);
            core.GameDef.updateHighScore();
            var _loop_3 = function (i) {
                var a = this_3.gameZone.getChildAt(i);
                Laya.timer.frameOnce(i * 2, this_3, function () {
                    a.gray = true;
                });
            };
            var this_3 = this;
            for (var i = 0; i < this.gameZone.numChildren; i++) {
                _loop_3(i);
            }
            Laya.timer.frameOnce(this.gameZone.numChildren * 2 + 10, this, function () {
                new view.overLayer(_this);
            });
        };
        return GameView;
    }(ui.GameViewUI));
    view.GameView = GameView;
    var eliminateEff_Obj = /** @class */ (function (_super) {
        __extends(eliminateEff_Obj, _super);
        function eliminateEff_Obj() {
            return _super.call(this) || this;
        }
        eliminateEff_Obj.prototype.init = function (x, y, parent, aniRound) {
            var _this = this;
            if (aniRound === void 0) { aniRound = 4; }
            this.pos(x, y);
            parent.addChild(this);
            this.gray = false;
            this.liftTime = 50;
            this._countDownTime = 300;
            var _loop_4 = function (i) {
                var r = [];
                for (var n = 0; n < 10; n++) {
                    var _ = Math.PI / 5 * (n + Math.random() * 0.9);
                    r.push(_);
                }
                r.sort(function (a, b) {
                    return Math.random() - 0.5;
                });
                for (var j = 0; j < 10; j++) {
                    Laya.timer.frameOnce(i * 10 + j, this_4, function () {
                        var unit = Laya.Pool.getItemByClass('eliminateEff_Unit', eliminateEff_Unit);
                        _this.addChild(unit);
                        var life = XnhdAPI.Tools.randomInt(40, 80);
                        var d = (Math.log(XnhdAPI.Tools.randomInt(1, 500)) / Math.log(10) * 100 + 50) / life;
                        var _r = r.shift();
                        unit.init(Math.cos(_r) * d, Math.sin(_r) * d, XnhdAPI.Tools.randomInt(0, 720) - 360, Math.random() * 0.5 + 0.5, Math.random() * 0.3 + 0.5, life, function () {
                            _this.liftTime--;
                        });
                    });
                }
            };
            var this_4 = this;
            for (var i = 1; i < aniRound + 1; i++) {
                _loop_4(i);
            }
            this.zOrder = 10;
            Laya.timer.frameLoop(1, this, this.onLoop);
        };
        eliminateEff_Obj.prototype.onLoop = function () {
            if (this.liftTime === 0 || this._countDownTime === 0) {
                Laya.timer.clear(this, this.onLoop);
                this.destroy();
                return;
            }
            for (var i = 0; i < this.numChildren; i++) {
                var a = this.getChildAt(i);
                a.moveLoop();
            }
            this._countDownTime--;
        };
        return eliminateEff_Obj;
    }(Laya.Image));
    var eliminateEff_Unit = /** @class */ (function (_super) {
        __extends(eliminateEff_Unit, _super);
        function eliminateEff_Unit() {
            var _this = _super.call(this, 'game/star.png') || this;
            _this._v = {
                x: 0,
                y: 0,
                r: 0,
                a: 0,
                s: 0
            };
            _this.pivot(32, 34);
            return _this;
        }
        eliminateEff_Unit.prototype.init = function (vx, vy, vr, scale, a, liftTime, callback) {
            var red = Math.random();
            var green = Math.random() * (1 - red);
            var blue = 1 - red - green;
            var f = new Laya.ColorFilter([
                red, 0, 0, 0, 0,
                0, green, 0, 0, 0,
                0, 0, blue, 0, 0,
                0, 0, 0, a, 0,
            ]);
            this.filters = [f];
            this.scale(scale, scale);
            this.rotation = 0;
            this.alpha = 1;
            this.pos(0, 0);
            this._v = {
                x: vx,
                y: vy,
                r: vr,
                a: 1 / liftTime,
                s: scale / liftTime
            };
            this._c = callback;
        };
        eliminateEff_Unit.prototype.moveLoop = function () {
            this.x += this._v.x;
            this.y += this._v.y;
            this.rotation += this._v.r;
            this.alpha -= this._v.a;
            this.scaleX -= this._v.s;
            this.scaleY -= this._v.s;
            if (this.scaleX < 0) {
                this.destroy();
            }
        };
        eliminateEff_Unit.prototype.destroy = function () {
            this.removeSelf();
            this._c && this._c();
            Laya.Pool.recover('eliminateEff_Unit', this);
        };
        return eliminateEff_Unit;
    }(Laya.Image));
    var guideFinish = /** @class */ (function (_super) {
        __extends(guideFinish, _super);
        function guideFinish(parent, closeCallback) {
            var _this = _super.call(this) || this;
            parent.addChild(_this);
            _this.blackBg.height = 1624;
            _this.container.y = _this.blackBg.height / 2;
            _this.closeBtn.on(Laya.Event.CLICK, _this, function () {
                _this.destroy();
                closeCallback && closeCallback();
            });
            _this.confirmBtn.on(Laya.Event.CLICK, _this, function () {
                _this.destroy();
                closeCallback && closeCallback();
            });
            var l = core.GameDef.localizationConfig;
            var i = core.GameDef.languageIndex;
            _this.tittleTxt.text = l.GameView.gameGuideFinish[i];
            _this.tips.text = l.GameView.gameGuide[i][4];
            _this.confirmBtn.getChildAt(0).text = l.GameView.gameGuideFinishConfirmBtn[i];
            return _this;
        }
        return guideFinish;
    }(ui.Layer.guideFinishLayerUI));
})(view || (view = {}));
//# sourceMappingURL=GameView.js.map