var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var view;
(function (view) {
    var PauseLayer = /** @class */ (function (_super) {
        __extends(PauseLayer, _super);
        function PauseLayer(parent, curScore, closeCallback) {
            var _this = _super.call(this) || this;
            parent.addChild(_this);
            _this._closeCallback = closeCallback;
            _this.UIAdjust();
            var i = core.GameDef.languageIndex;
            var l = core.GameDef.localizationConfig;
            _this.curScore.text = curScore;
            _this.maxScore.text = l.highScore[i] + " : " + (core.GameDef.isRank ? core.GameDef.maxScore.ranking.toString() : core.GameDef.maxScore.normal.toString());
            _this.middleZone.getChildAt(8).text = l.PauseLayer.tips[i];
            _this.middleZone.getChildAt(0).getChildAt(1).text = l.PauseLayer.title[i];
            _this.continueBtn.getChildAt(1).text = l.PauseLayer.continueBtn[i];
            _this.backMainBtn.getChildAt(1).text = l.GameOverView.backMain[i];
            _this.restartBtn.getChildAt(1).text = l.GameOverView.restart[i];
            if (!core.GameDef.isRank) {
                _this.restartBtn.getChildAt(1).y = 55;
            }
            else {
                _this.coin_img.visible = true;
            }
            _this.continueBtn.on(Laya.Event.CLICK, _this, _this.Destroy);
            _this.closeBtn.on(Laya.Event.CLICK, _this, _this.Destroy);
            _this.restartBtn.on(Laya.Event.CLICK, _this, function () {
                if (core.GameDef.isRank) {
                    if (core.Player.Manager.getCoinNum() > 99 || core.GameDef.selfTest) {
                        core.Player.Manager.adjustCoinNum(-100);
                        XnhdAPI.saveDataToCache("RankData", '');
                        core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                    }
                    else {
                        new view.LackOfGold(_this, null);
                    }
                }
                else {
                    XnhdAPI.saveDataToCache("GameData", '');
                    _this.destroy();
                    core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                }
            });
            var soundBtnSkin = _this.soundBtn.getChildAt(0);
            if (core.AudioAndSetting.Manager.volumeMusic === 0) {
                soundBtnSkin.skin = "game/sound_off.png";
            }
            else {
                soundBtnSkin.skin = "game/sound_on.png";
            }
            _this.soundBtn.on(Laya.Event.CLICK, _this, function () {
                if (core.AudioAndSetting.Manager.volumeMusic == 0) {
                    core.AudioAndSetting.Manager.setMusicVolume(70);
                    core.AudioAndSetting.Manager.setSoundVolume(100);
                    soundBtnSkin.skin = "game/sound_on.png";
                }
                else {
                    core.AudioAndSetting.Manager.setMusicVolume(0);
                    core.AudioAndSetting.Manager.setSoundVolume(0);
                    soundBtnSkin.skin = "game/sound_off.png";
                }
            });
            _this.backMainBtn.on(Laya.Event.CLICK, _this, function () {
                core.SceneManager.Default.ShowScene(core.GameScene.MAINSCENE);
            });
            return _this;
        }
        PauseLayer.prototype.Destroy = function () {
            this.destroy();
            this._closeCallback && this._closeCallback();
        };
        PauseLayer.prototype.UIAdjust = function () {
            this.middleZone.y = XnhdAPI.Param.screenHeight / 2 - 110;
        };
        return PauseLayer;
    }(ui.Layer.PauseLayerUI));
    view.PauseLayer = PauseLayer;
})(view || (view = {}));
//# sourceMappingURL=PauseLayer.js.map