var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var view;
(function (view) {
    var TurntableLayer = /** @class */ (function (_super) {
        __extends(TurntableLayer, _super);
        function TurntableLayer(parent, level, closeCallback) {
            var _this = _super.call(this) || this;
            _this._rewards = core.GameDef.gameParam.rankTurntable;
            _this.startAccuration = 0.2;
            _this.startAccurateTime = 60;
            _this.stopAccuration = 0.05;
            parent.addChild(_this);
            _this.closeCallback = closeCallback;
            _this.startBtn.y = XnhdAPI.Param.screenHeight - 220 - _this.startBtn.height / 2;
            _this.all.y = _this.startBtn.y - _this.startBtn.height / 2;
            _this.dealWithRewardImg();
            _this.startBtn.once(Laya.Event.CLICK, _this, _this.startRolling);
            var l = core.GameDef.localizationConfig.turntableLayer;
            var i = core.GameDef.languageIndex;
            _this.startBtn.getChildAt(0).text = l.startBtn[i];
            var a = l.title[i].indexOf('{0}');
            var t = l.title[i].substring(0, a) + level.toString() + l.title[i].substring(a + 3);
            XnhdAPI.showTips(t);
            return _this;
        }
        TurntableLayer.prototype.startRolling = function () {
            this.startBtn.visible = false;
            core.AudioAndSetting.Manager.sound_startTurntable();
            this.chooseRewardIndex();
        };
        TurntableLayer.prototype.getReward = function () {
            var _this = this;
            var l = core.GameDef.localizationConfig;
            var i = core.GameDef.languageIndex;
            var item = l.itemDescription[this.callbackReward.name][i] + l.itemDescription.pluralType[i] + this.callbackReward.num.toString();
            XnhdAPI.showTips(l.turntableLayer.tips[i] + item);
            var a = JSON.parse(JSON.stringify(this.callbackReward));
            Laya.timer.once(1000, this, function () {
                _this.closeCallback && _this.closeCallback(a);
                _this.destroy();
            });
        };
        TurntableLayer.prototype.chooseRewardIndex = function () {
            var allProbability = 0;
            for (var i = 0; i < this._rewards.length; i++) {
                allProbability += this._rewards[i].probability;
            }
            var chooseNum = XnhdAPI.Tools.randomInt(1, allProbability);
            for (var i = 0; i < this._rewards.length; i++) {
                this._rewardGetIndex = i;
                chooseNum -= this._rewards[i].probability;
                if (chooseNum < 1) {
                    break;
                }
            }
            this.callbackReward = this._rewards[this._rewardGetIndex];
            var startRotation = 0.5 * this.startAccuration * Math.pow(this.startAccurateTime, 2);
            var maxVelocity = this.startAccuration * this.startAccurateTime;
            var stopAccurateTime = maxVelocity / this.stopAccuration;
            var stopRotation = stopAccurateTime * maxVelocity - 0.5 * this.stopAccuration * Math.pow(stopAccurateTime, 2);
            var allRotation = startRotation + stopRotation;
            var destinyRotation = ((this._rewardGetIndex - 0.5) * 360 / this._rewards.length + XnhdAPI.Tools.randomInt(1, Math.floor(360 / this._rewards.length / maxVelocity)) * maxVelocity + 360) % 360;
            XnhdAPI.logDebug("destinyRotation >" + destinyRotation.toString());
            var needRotate = (destinyRotation - allRotation % 360 - this.imgZhizhen.rotation % 360 + 3 * 360) % 360;
            var middleTime = (needRotate + 2 * 360) / maxVelocity;
            this.zhuanpanFrames = 0;
            this.rotateZhuanpan(middleTime);
        };
        TurntableLayer.prototype.rotateZhuanpan = function (middleTime) {
            var velocity = 0;
            this.zhuanpanFrames++;
            if (this.zhuanpanFrames < this.startAccurateTime) {
                velocity = this.zhuanpanFrames * this.startAccuration;
            }
            else if (this.zhuanpanFrames < this.startAccurateTime + middleTime) {
                velocity = this.startAccurateTime * this.startAccuration;
            }
            else {
                velocity = this.startAccurateTime * this.startAccuration - (this.zhuanpanFrames - this.startAccurateTime - middleTime) * this.stopAccuration;
            }
            if (velocity <= 0) {
                this.imgZhizhen.rotation = this.imgZhizhen.rotation % 360;
                XnhdAPI.logDebug("Rotation >>" + this.imgZhizhen.rotation.toString());
                core.AudioAndSetting.Manager.sound_stopTurntable();
                this.getReward();
            }
            else {
                this.imgZhizhen.rotation += velocity;
                Laya.timer.frameOnce(1, this, this.rotateZhuanpan, [middleTime]);
            }
        };
        TurntableLayer.prototype.dealWithRewardImg = function () {
            var n = this._rewards.length;
            var ro = 180 / n;
            // let shadow = this.blackBg.getChildAt(0) as Laya.Sprite;
            var shadow = this.blackBg.mask;
            for (var i = 0; i < this._rewards.length; i++) {
                if (i % 2 === 0) {
                    // let a = new Laya.Sprite;
                    // a.graphics.drawPie(262, 262, 262, i * 2 * ro - ro - 90, i * 2 * ro + ro - 90, '#000000');
                    // shadow.addChild(a);
                    shadow.graphics.drawPie(262, 262, 262, i * 2 * ro - ro - 90, i * 2 * ro + ro - 90, '#000000');
                }
                var zone = new Laya.Image;
                this.itemLayer.addChild(zone);
                zone.rotation = i * 2 * ro;
                var a = this.getItemImage(this._rewards[i].name);
                a.anchorX = 0.5;
                a.anchorY = 0.5;
                a.pos(0, -215);
                a.rotation = -zone.rotation;
                zone.addChild(a);
                var _l = core.GameDef.localizationConfig.itemDescription;
                var _i = core.GameDef.languageIndex;
                var b = new Laya.Label(_l[this._rewards[i].name][_i] + '\n' + _l.pluralType[_i] + this._rewards[i].num.toString());
                b.align = 'center';
                b.valign = 'middle';
                b.wordWrap = true;
                b.anchorX = 0.5;
                b.anchorY = 0.5;
                b.size(120, 40);
                b.color = '#101010';
                b.fontSize = 20;
                b.pos(0, -150);
                b.rotation = -zone.rotation;
                zone.addChild(b);
            }
        };
        TurntableLayer.prototype.getItemImage = function (itemName) {
            var l = core.GameDef.localizationConfig.itemDescription;
            var i = core.GameDef.languageIndex;
            if (itemName === 'OmnipotentCard') {
                var a = new Laya.Image('game/wnxt.png');
                a.size(64, 64);
                return a;
            }
            if (itemName === 'Bomb') {
                var a = new Laya.Image('game/fjxt.png');
                a.size(64, 64);
                return a;
            }
            if (itemName === 'CardSaved') {
                var a = new Laya.Image('game/cpxt.png');
                a.size(64, 64);
                return a;
            }
            if (itemName === 'Coin') {
                var a = new Laya.Image('game/jixt.png');
                a.size(64, 64);
                return a;
            }
            XnhdAPI.logError('TurntableLayer getItemImage Fail: ' + itemName);
            return null;
        };
        return TurntableLayer;
    }(ui.Layer.TurntableViewUI));
    view.TurntableLayer = TurntableLayer;
})(view || (view = {}));
//# sourceMappingURL=Turntable.js.map