var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var view;
(function (view) {
    /**
     * 排行榜，通过界面内的rankListZone(一个Laya.Panel类)来做微信子域排行榜显示适配
     */
    var RankListLayer = /** @class */ (function (_super) {
        __extends(RankListLayer, _super);
        /**
         * 排行榜，通过界面内的rankListZone(一个Laya.Panel类)来做微信子域排行榜显示适配，必须提前准备好用户信息
         * @param parent 父节点
         * @param closeCallback
         */
        function RankListLayer(parent, closeCallback) {
            if (closeCallback === void 0) { closeCallback = null; }
            var _this = _super.call(this) || this;
            //微信相关参数
            _this._pressDown = false;
            _this._wxRankListSwitch = false;
            _this._lastMouseY = 0;
            _this._worldRankShowTestData = 0;
            _this._worldCurRank = 0;
            _this._ranklistCompArr = [];
            _this.UIAdjust();
            _this.platNodeInit();
            parent.addChild(_this);
            //微信好友排行榜示意
            _this.worldBtn.visible = false;
            _this.friendBtn.x = 179;
            XnhdAPI.showRankList(_this.rankListZone);
            _this.closeBtn.on(Laya.Event.CLICK, _this, function (e) {
                // e.stopPropagation();
                _this.Destroy();
                closeCallback && closeCallback();
            });
            _this.shareBtn.on(Laya.Event.CLICK, _this, function () {
                XnhdAPI.shareImage(false, 2);
            });
            //根据世界排行榜信息进行处理
            var myWorldInfo = core.GameDef.myWorldRankInfo;
            if (myWorldInfo.appid.length > 0 && myWorldInfo.openid.length > 0) {
                //排行榜未接，仅以世界排行榜为例
                core.GameDef.updateWorldRankData(0, function (e) {
                    _this._worldRankData = JSON.parse(e);
                    //世界排行榜数据格式,"rankList":[{"idx":1,"openid":"a","nick":"ccc","icon":"44","score":22}],"myRank":1,"myScore":22
                    //处理我的相关信息
                    var my = _this.rankListZone_W.parent.getChildAt(1);
                    my.getChildAt(1).text = e.myRank.toString();
                    my.getChildAt(0).visible = e.myRank < 99;
                    var a = e.myRank > 4 ? 4 : e.myRank;
                    my.getChildAt(0).skin = 'game/rank_' + a + '.png';
                    my.getChildAt(2).skin = myWorldInfo.avatarUrl;
                    my.getChildAt(3).text = myWorldInfo.nickName;
                    my.getChildAt(4).text = e.myScore.toString();
                    _this.friendBtn.on(Laya.Event.CLICK, _this, _this.pressFriendBtn);
                    _this.worldBtn.on(Laya.Event.CLICK, _this, _this.pressWorldBtn);
                    _this.pressWorldBtn();
                    //开启世界排行榜处理循环
                    Laya.timer.frameLoop(1, _this, _this.rankListLoop);
                }, function (f) {
                    XnhdAPI.logDebug('RankListLayer get WorldRankData fail ' + f.toString());
                });
            }
            else {
                _this._worldRankShowTestData = 4;
                var _myUrl = "card/1_" + XnhdAPI.Tools.randomInt(1, 13) + ".png";
                _this._worldRankData = {
                    rankList: [
                        { "idx": 1, "openid": "ab1", "nick": "其他玩家", "icon": "card/1_" + XnhdAPI.Tools.randomInt(1, 13) + ".png", "score": 99999999 },
                        { "idx": 2, "openid": "ab2", "nick": "其他玩家", "icon": "card/1_" + XnhdAPI.Tools.randomInt(1, 13) + ".png", "score": 99999998 },
                        { "idx": 3, "openid": "ab3", "nick": "我自测名字示意", "icon": _myUrl, "score": 99999997 },
                    ],
                    myRank: 3,
                    myScore: 99999997
                };
                for (var i = 0; i < 7; i++) {
                    _this._test_createNewTestWorldRankPlayer();
                }
                var my = _this.rankListZone_W.parent.getChildAt(1);
                var a = _this._worldRankData.myRank > 4 ? 4 : _this._worldRankData.myRank;
                my.getChildAt(0).skin = 'game/rank_' + a + '.png';
                my.getChildAt(0).visible = _this._worldRankData.myRank < 99;
                my.getChildAt(1).text = _this._worldRankData.myRank.toString();
                my.getChildAt(2).skin = _myUrl;
                my.getChildAt(3).text = '我自测名字示意';
                my.getChildAt(4).text = _this._worldRankData.myScore.toString();
                _this.friendBtn.on(Laya.Event.CLICK, _this, _this.pressFriendBtn);
                // this.worldBtn.on(Laya.Event.CLICK, this, this.pressWorldBtn);
                // this.pressWorldBtn();
                _this.pressFriendBtn();
                //开启世界排行榜处理循环
                Laya.timer.frameLoop(1, _this, _this.rankListLoop);
            }
            return _this;
        }
        RankListLayer.prototype._test_createNewTestWorldRankPlayer = function () {
            if (this._worldRankShowTestData > 0) {
                this._worldRankData.rankList.push({
                    "idx": this._worldRankShowTestData,
                    "openid": "ab" + this._worldRankShowTestData,
                    "nick": "其他玩家",
                    "icon": "card/1_" + XnhdAPI.Tools.randomInt(1, 13) + ".png",
                    "score": 100000000 - this._worldRankShowTestData
                });
                this._worldRankShowTestData++;
            }
        };
        RankListLayer.prototype.pressFriendBtn = function () {
            this.worldBtn.getChildAt(1).visible = true;
            this.friendBtn.getChildAt(1).visible = false;
            this.rankListZone.parent.visible = true;
            this.rankListZone_W.parent.visible = false;
        };
        RankListLayer.prototype.pressWorldBtn = function () {
            this.worldBtn.getChildAt(1).visible = false;
            this.friendBtn.getChildAt(1).visible = true;
            this.rankListZone.parent.visible = false;
            this.rankListZone_W.parent.visible = true;
        };
        RankListLayer.prototype.rankListLoop = function () {
            //微信好友排行榜示意
            if (this._wxRankListSwitch && this._pressDown) {
                var a = Laya.stage.mouseY - this._lastMouseY;
                if (a != 0) {
                    // XnhdAPI.logDebug('大排行榜移动：' + a);
                    XnhdAPI.moveRankList(a);
                }
                this._lastMouseY = Laya.stage.mouseY;
            }
            //世界排行榜示意
            if (this.rankListZone_W.parent.visible && this.rankListZone_W.vScrollBar.value + this.rankListZone_W.height > (this._ranklistCompArr.length - 5) * 145) {
                var rankList = this._worldRankData['rankList'];
                //世界排行榜数据格式,"rankList":[{"idx":1,"openid":"a","nick":"ccc","icon":"44","score":22}],"myRank":1,"myScore":22
                //检查世界排行榜情况，如果下滑超过一定数量，则新增5个人
                for (var i = 0; i < 5; i++) {
                    if (this._worldCurRank === rankList.length) {
                        return;
                    }
                    else {
                        this._test_createNewTestWorldRankPlayer();
                        var onePiece = new rankListComp;
                        var thisData = rankList[this._worldCurRank];
                        onePiece.init(this.rankListZone_W, thisData.idx, thisData.icon, thisData.nick, thisData.score);
                        this._worldCurRank++;
                        this._ranklistCompArr.push(onePiece);
                    }
                }
            }
        };
        RankListLayer.prototype.Destroy = function () {
            XnhdAPI.closeRankList();
            this.destroy();
        };
        RankListLayer.prototype.UIAdjust = function () {
            this.bg.height = XnhdAPI.Param.screenHeight;
            var k = this.bg.height - 1334; //1624-1334 = 290
            var ratio = k / (1624 - 1334);
            ratio < 0 && (ratio = 0);
            var a = Math.floor(150 * ratio);
            this.shareBtn.y = 1170 + a;
            this.middleZone.y = 605 + a;
            this.closeBtn.y = a;
            var i = core.GameDef.languageIndex;
            var l = core.GameDef.localizationConfig;
            this.friendBtn.getChildAt(0).text = l.ranklistLayer.friend[i];
            this.worldBtn.getChildAt(0).text = l.ranklistLayer.world[i];
            this.shareBtn.getChildAt(0).text = l.share[i];
        };
        RankListLayer.prototype.platNodeInit = function () {
            var _this = this;
            if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
                this._wxRankListSwitch = true;
                this.rankListZone.on(Laya.Event.MOUSE_DOWN, this, function () {
                    if (!_this._pressDown) {
                        _this._pressDown = true;
                        _this._lastMouseY = Laya.stage.mouseY;
                    }
                });
                this.on(Laya.Event.MOUSE_UP, this, function () {
                    _this._pressDown = false;
                });
            }
        };
        return RankListLayer;
    }(ui.Layer.ranklistLayerUI));
    view.RankListLayer = RankListLayer;
    var rankListComp = /** @class */ (function (_super) {
        __extends(rankListComp, _super);
        function rankListComp() {
            return _super.call(this) || this;
        }
        rankListComp.prototype.init = function (parent, id, avatarUrl, nickName, score) {
            parent.addChild(this);
            this.pos(0, (id - 1) * 145 + 25);
            this.rankScore.text = id.toString();
            this.rankScoreBg.visible = id < 99;
            var a = id > 4 ? 4 : id;
            this.rankScoreBg.skin = 'game/rank_' + a + '.png';
            this.avatar.skin = avatarUrl;
            this.playName.text = nickName;
            this.playScore.text = score.toString();
        };
        return rankListComp;
    }(ui.Comp.ranklistCompUI));
})(view || (view = {}));
//# sourceMappingURL=ranklistLayer.js.map