var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var view;
(function (view) {
    var MainView = /** @class */ (function (_super) {
        __extends(MainView, _super);
        function MainView() {
            var _this = _super.call(this) || this;
            _this.UIAdjust();
            XnhdAPI.DeviceInfo.inst.setResizeCallback(function () {
                _this.UIAdjust();
            });
            _this.languageSet();
            _this.resetBgSkin();
            _this.updateCoinNum();
            _this.platNodeInit();
            _this.monitorOn();
            var needGuide = XnhdAPI.readDataFromCache('Guide');
            if (needGuide === 'Guide') {
                _this.storeGuideLayer.visible = true;
                _this.guideHandAni();
            }
            return _this;
        }
        MainView.prototype.guideHandAni = function () {
            var _this = this;
            this.hand.pos(580, 604 + this.leftZone.y);
            this.storeGuideLayer.visible && Laya.Tween.to(this.hand, { x: 540, y: 644 + this.leftZone.y }, 500, null, Laya.Handler.create(this, function () {
                _this.storeGuideLayer.visible && Laya.Tween.to(_this.hand, { x: 580, y: 604 + _this.leftZone.y }, 500, null, Laya.Handler.create(_this, function () {
                    _this.guideHandAni();
                }));
            }));
        };
        MainView.prototype.gameStart = function (isRank) {
            var _this = this;
            // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 4) {
            //     HudieLiteGameAPI.update_login(true)
            // }
            if (!this.storeGuideLayer.visible) {
                if (isRank > 0) {
                    if (this.coin_img.visible) {
                        if (core.Player.Manager.getCoinNum() > 99 || core.GameDef.selfTest) {
                            core.Player.Manager.adjustCoinNum(-100);
                            core.GameDef.isRank = true;
                            Laya.timer.clearAll(this);
                            core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                        }
                        else {
                            new view.LackOfGold(this, function () {
                                _this.updateCoinNum();
                            });
                        }
                    }
                    else {
                        core.GameDef.isRank = true;
                        Laya.timer.clearAll(this);
                        core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                    }
                }
                else {
                    core.GameDef.isRank = false;
                    Laya.timer.clearAll(this);
                    core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                }
            }
        };
        MainView.prototype.monitorOn = function () {
            var _this = this;
            var soundBtnSkin = this.soundBtn.getChildAt(0);
            if (core.AudioAndSetting.Manager.volumeMusic === 0) {
                soundBtnSkin.skin = "game/sound_off.png";
            }
            else {
                soundBtnSkin.skin = "game/sound_on.png";
            }
            this.soundBtn.on(Laya.Event.CLICK, this, function () {
                if (!_this.storeGuideLayer.visible) {
                    if (core.AudioAndSetting.Manager.volumeMusic == 0) {
                        core.AudioAndSetting.Manager.setMusicVolume(70);
                        core.AudioAndSetting.Manager.setSoundVolume(100);
                        soundBtnSkin.skin = "game/sound_on.png";
                    }
                    else {
                        core.AudioAndSetting.Manager.setMusicVolume(0);
                        core.AudioAndSetting.Manager.setSoundVolume(0);
                        soundBtnSkin.skin = "game/sound_off.png";
                    }
                }
            });
            this.normalBtn.on(Laya.Event.CLICK, this, this.gameStart, [0]);
            this.rankBtn.on(Laya.Event.CLICK, this, this.gameStart, [1]);
            this.cultivateBtn.on(Laya.Event.CLICK, this, function () {
                if (!_this.storeGuideLayer.visible) {
                    new view.cultivateLayer(_this, function () {
                        _this.updateCoinNum();
                    });
                }
            });
            this.storeBtn.on(Laya.Event.CLICK, this, function () {
                if (_this.storeGuideLayer.visible) {
                    _this.storeGuideLayer.visible = false;
                }
                new view.storeLayer(_this, function () {
                    _this.resetBgSkin();
                    _this.updateCoinNum();
                });
            });
            this.languageSettingBtn.on(Laya.Event.CLICK, this, function () {
                if (!_this.storeGuideLayer.visible) {
                    new view.langView(function () {
                        _this.languageSet();
                    });
                }
            });
            this.ranklistBtn.on(Laya.Event.CLICK, this, function () {
                if (!_this.storeGuideLayer.visible) {
                    new view.RankListLayer(_this);
                }
            });
            if (this.checkRankingCost()) {
                this.rankBtn.getChildAt(0).y = 75;
            }
            else {
                this.coin_img.visible = true;
            }
            // this.addCoin.on(Laya.Event.CLICK, this, () => {
            //     if (!this.storeGuideLayer.visible) {
            //         core.Player.Manager.adjustCoinNum(200);
            //         this.updateCoinNum();
            //     }
            // })
            this.addCoin.visible = false;
            Laya.timer.frameLoop(120, this, this.buttonEff, [this.storeBtn]);
        };
        MainView.prototype.buttonEff = function (spr) {
            var p = Math.PI / 15;
            var _loop_1 = function (i) {
                Laya.timer.once(i * 15, this_1, function () {
                    spr.scale(1 + 0.1 * Math.sin(2 * p * i), 1 + 0.1 * Math.sin(2 * p * i));
                });
            };
            var this_1 = this;
            for (var i = 0; i < 30; i++) {
                _loop_1(i);
            }
        };
        MainView.prototype.checkRankingCost = function () {
            var data = XnhdAPI.readDataFromCache("RankData");
            if (data && data.length > 0) {
                return true;
            }
            return false;
        };
        MainView.prototype.resetBgSkin = function () {
            this.bg.skin = core.GameDef.bgParam[core.Player.Manager.getCurSkin_bg()].url;
        };
        MainView.prototype.updateCoinNum = function () {
            this.coinZone.getChildAt(1).text = core.Player.Manager.getCoinNum().toString();
        };
        MainView.prototype.platNodeInit = function () {
            if (XnhdAPI.Param.platType === 2 && [1, 4, 6].indexOf(XnhdAPI.Param.channelType) > -1) {
                // this.btnShare.visible = true;
                // this.btnShare.on(Laya.Event.CLICK, this, () => {
                //     XnhdAPI.shareImage(false, 2)
                // });
                // if (XnhdAPI.Param.channelType === 1) {
                //     this.btnRanklist.visible = true;
                //     this.btnRanklist.on(Laya.Event.CLICK, this, () => {
                //         this.hideSpecialStart();
                //         new view.RankListLayer(this, () => {
                //             this.specializeStart();
                //         });
                //     })
                //     XnhdAPI.XnhdWxPush.showBotBanner(this.botBanner);
                //     XnhdAPI.XnhdWxPush.showExitBtn(this.exitBtn);
                //     XnhdAPI.XnhdWxPush.showShakeIcon(this.shakeIcon);
                //     return;
                // }
            }
            // this.logo.visible = false;
            Laya.timer.frameOnce(60, this, function () { XnhdAPI.showBannerAd(XnhdAPI.Param.screenHeight - 220); });
        };
        MainView.prototype.specializeStart = function () {
            // XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 4 && HudieLiteGameAPI.showBtnWithAuthorize()
        };
        MainView.prototype.hideSpecialStart = function () {
            // XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 4 && HudieLiteGameAPI.hideBtnWithAuthorize();
        };
        MainView.prototype.UIAdjust = function () {
            this.bg.height = XnhdAPI.Param.screenHeight;
            var k = XnhdAPI.Param.screenHeight - 1334; //1624-1334 = 290
            var ratio = k / (1624 - 1334);
            ratio < 0 && (ratio = 0);
            this.middleZone.y = 250 + Math.floor(150 * ratio);
            this.storeGuideLayer.getChildAt(0).height = 454 + this.leftZone.y;
            this.storeGuideLayer.getChildAt(1).y = 454 + this.leftZone.y;
            this.storeGuideLayer.getChildAt(2).y = 605 + this.leftZone.y;
            this.hand.y = 605 + this.leftZone.y;
        };
        MainView.prototype.languageSet = function () {
            var i = core.GameDef.languageIndex;
            var l = core.GameDef.localizationConfig;
            this.logo.skin = l.MainView.logo[i];
            this.cultivateBtn.getChildAt(0).text = l.MainView.cultivateBtn[i];
            this.normalBtn.getChildAt(0).text = l.MainView.normalBtn[i];
            this.rankBtn.getChildAt(0).text = l.MainView.rankBtn[i];
            this.soundBtn.getChildAt(1).text = l.MainView.soundBtn[i];
            this.languageSettingBtn.getChildAt(1).text = l.MainView.languageBtn[i];
            this.ranklistBtn.getChildAt(1).text = l.MainView.ranklistBtn[i];
            this.storeBtn.getChildAt(0).text = l.MainView.storeBtn[i];
        };
        return MainView;
    }(ui.MainViewUI));
    view.MainView = MainView;
})(view || (view = {}));
//# sourceMappingURL=MainView.js.map