var view;
(function (view) {
    class cardUnit extends ui.Comp.cardUnitUI {
        constructor() {
            super();
            this.anchorX = 0.5;
            this.anchorY = 0.5;
            this.on(Laya.Event.MOUSE_DOWN, this, this.clickFunc);
        }
        init(parent, x, y, clickCallback) {
            this.gray = false;
            this.cardColor.scale(1, 1);
            this.cardColor.alpha = 1;
            this.cardColor.pos(102, 139);
            this.pos(x, y);
            this.scale(0.67, 0.67);
            this.clickCallback = clickCallback;
            parent.addChild(this);
        }
        clickFunc() {
            this.clickCallback && this.clickCallback(parseInt(this.name));
        }
        changeSkin(prop) {
            if (prop && prop.p1 === 1) {
                this.cardColor.skin = 'card/wnp.png';
                this.cardSkin.visible = false;
            }
            else {
                this.cardSkin.visible = true;
                this.cardSkin.skin = prop.p2 === 1 ? 'card/zd.png' : core.GameDef.stampParam[core.Player.Manager.getCurSkin_stamp()].url;
                let a = Math.floor(Math.log(prop.p1) / Math.log(2));
                this.cardColor.skin = 'card/1_' + a + '.png';
            }
        }
        changeSkin_ani(prop, aniTime = 300, callback) {
            let _s = this.scaleX;
            Laya.Tween.to(this, { scaleX: _s * 1.5, scaleY: _s * 1.5, alpha: 0 }, aniTime / 2, null, Laya.Handler.create(this, () => {
                this.changeSkin(prop);
                Laya.Tween.to(this, { scaleX: _s, scaleY: _s, alpha: 1 }, aniTime / 2, null, Laya.Handler.create(this, () => {
                    callback && callback();
                }));
            }));
        }
        pickAni(pickOrNot) {
            if (pickOrNot) {
                Laya.Tween.to(this, { scaleX: 1, scaleY: 1 }, 100);
            }
            else {
                Laya.Tween.to(this, { scaleX: 0.67, scaleY: 0.67 }, 100);
            }
        }
        showFlash(showOrNot) {
            this.cardEff.skin = showOrNot ? 'card/kpfg.png' : 'card/kpty.png';
        }
        eliminate(aniTime = 200, delay, callback, delayCallback = null) {
            Laya.timer.once(delay, this, () => {
                delayCallback && delayCallback();
                Laya.Tween.to(this.cardColor, { scaleX: 1.5, scaleY: 1.5, alpha: 0 }, aniTime, null, Laya.Handler.create(this, () => {
                    callback && callback();
                    this.destroy();
                }));
            });
        }
        destroy() {
            this.removeSelf();
            this.zOrder = 0;
            this.clickCallback = null;
            Laya.Pool.recover('CardUnit', this);
        }
    }
    view.cardUnit = cardUnit;
})(view || (view = {}));
