var view;
(function (view) {
    class GameView extends ui.GameViewUI {
        constructor() {
            super();
            this._pressStatus = false;
            this._mousePos = new Laya.Point;
            this._allowPress = true;
            this._countDownSwitch = true;
            //视频相关
            this._videoSwitch = true;
            //新手引导相关
            this._guideStep = -1;
            this._handAniNum = 0;
            //是否在录屏
            this._isrecording = false;
            this._recordTime = 0;
            this._recorderVideoPath = "";
            this.UIAdjust();
            XnhdAPI.DeviceInfo.inst.setResizeCallback(() => {
                this.UIAdjust();
            });
            this._curScore = new view.curScoreComp;
            this.topZone.addChild(this._curScore);
            this._curScore.pos(375, 100);
            this.levelText.zOrder = 1;
            core.GameLogic.Default.initGame(this);
        }
        UIAdjust() {
            let k = XnhdAPI.Param.screenHeight - 1334; //1624-1334 = 290
            let ratio = k / (1624 - 1334);
            ratio < 0 && (ratio = 0);
            this.bg.height = XnhdAPI.Param.screenHeight;
            this.gameArea.y = 145 + Math.floor(200 * ratio);
            this.topZone.y = Math.floor(200 * ratio);
            // this.topZone.y = Math.floor(ratio*100);
            this.highScoreText0.text = core.GameDef.localizationConfig.highScore[core.GameDef.languageIndex];
            this.highScoreText0.text = core.GameDef.localizationConfig.highScore[core.GameDef.languageIndex];
            this.bg.skin = core.GameDef.bgParam[core.Player.Manager.getCurSkin_bg()].url;
            if (window['tt']) {
                console.log("GameView.tt");
                this.startVideoBtn.visible = true;
                this._recorder = window['tt'].getGameRecorderManager();
                this._recorder.onStart(res => {
                    console.log("jlog, run in this.recorder.onStart");
                });
                this._recorder.onStop(({ videoPath }) => {
                    if (this._isrecording) {
                        //说明不是用户触发的停止录屏
                        XnhdAPI.showTips("录屏已达到最大时长～");
                        this._recorderVideoPath = videoPath;
                        // this._isrecording = false;
                        // this.startVideoBtn.visible = true;
                        // this.stopVideoBtn.visible = false;
                        return;
                    }
                    window['tt'].shareAppMessage({
                        channel: 'video',
                        title: '看我给你摆个1024哈～',
                        imageUrl: '',
                        query: '',
                        extra: {
                            videoPath: videoPath,
                            videoTopics: ['2048', '消除', '休闲游戏']
                        },
                        success() {
                            console.log('分享视频成功');
                        },
                        fail(e) {
                            console.log('分享视频失败:', e);
                            XnhdAPI.showTips("分享视频失败，请稍后重试");
                        }
                    });
                });
            }
            else {
                console.log("GameView.not_tt");
                this.startVideoBtn.visible = false;
            }
            // this.showBannerAd();
            XnhdAPI.hideBanner("home");
        }
        pressStartVideoBtn() {
            if (!this._isrecording) {
                XnhdAPI.showTips("开始录屏");
                this.startVideoBtn.visible = false;
                this.stopVideoBtn.visible = true;
                this._isrecording = true;
                this._recorder.start({
                    duration: 300,
                });
                this._recordTime = new Date().getTime();
                console.log("jlog, start to record1");
            }
        }
        pressStopVideoBtn() {
            if (this._recorderVideoPath.length != 0) {
                this._isrecording = false;
                this.startVideoBtn.visible = true;
                this.stopVideoBtn.visible = false;
                window['tt'].shareAppMessage({
                    channel: 'video',
                    title: '看我给你摆个1024哈～',
                    imageUrl: '',
                    query: '',
                    extra: {
                        videoPath: this._recorderVideoPath,
                        videoTopics: ['2048', '消除', '休闲游戏']
                    },
                    success() {
                        console.log('分享视频成功');
                    },
                    fail(e) {
                        console.log('分享视频失败:', e);
                        XnhdAPI.showTips("分享视频失败，请稍后重试");
                    }
                });
                this._recorderVideoPath = "";
                return;
            }
            if (this._isrecording) {
                let dt_time = new Date().getTime() - this._recordTime;
                if (dt_time >= 3000) {
                    this._isrecording = false;
                    this.startVideoBtn.visible = true;
                    this.stopVideoBtn.visible = false;
                    this._recorder.stop();
                }
                else {
                    XnhdAPI.showTips("录屏时长太短");
                }
            }
        }
        setMonitor() {
            XnhdAPI.onHide(() => {
                this.pressPauseBtn();
            });
            this.OmnipotentCardBtn.on(Laya.Event.CLICK, this, this.pressOmnipotentCard);
            this.bombBtn.on(Laya.Event.CLICK, this, this.pressBombBtn);
            this.gameZone.on(Laya.Event.MOUSE_UP, this, this.playerRelease);
            this.gameZone.on(Laya.Event.MOUSE_OUT, this, this.playerRelease);
            this.pauseBtn.on(Laya.Event.CLICK, this, this.pressPauseBtn);
            this.startVideoBtn.on(Laya.Event.CLICK, this, this.pressStartVideoBtn);
            this.stopVideoBtn.on(Laya.Event.CLICK, this, this.pressStopVideoBtn);
            this.test1.on(Laya.Event.CLICK, this, () => {
                let noNeedGuide = XnhdAPI.readDataFromCache('Guide');
                if (!noNeedGuide)
                    return;
                if (core.GameLogic.Default.getCanSaveCardNum() === 0) {
                    // XnhdAPI.showRewardAd(4);
                    XnhdAPI.showVideoAd("cunpai", () => {
                        core.GameLogic.Default.setCanSaveCardNum(1); //加一个存牌
                        core.GameLogic.Default._gameView.resetCardSaveTimes(core.GameLogic.Default.getCanSaveCardNum(), 1);
                    }, f => {
                        XnhdAPI.showTips(core.GameDef.localizationConfig.finishVideoTips[core.GameDef.languageIndex]);
                    }, f => {
                        XnhdAPI.showTips(core.GameDef.localizationConfig.noVideoTips[core.GameDef.languageIndex]);
                    });
                    //this.resetCardSaveTimes(core.GameLogic.Default.getCanSaveCardNum(),core.GameLogic.Default.getCanPaidCardNum());
                }
            });
            if (core.GameDef.isRank) {
                let a = core.GameDef.itemLevelParseNum(core.Player.Manager.rankItemLevel_get(core.Player.ItemType.ThinkingTime));
                this._countDownTime = (5 + a) * 1000;
            }
            else {
                this._countDownTime = 0;
            }
            Laya.timer.frameLoop(1, this, this.monitorLoop);
        }
        pressPauseBtn() {
            if (this._countDownSwitch) {
                this._countDownSwitch = false;
                new view.PauseLayer(this, core.GameLogic.Default.getCurScore().toString(), () => {
                    this._countDownSwitch = true;
                });
            }
        }
        showBannerAd() {
            XnhdAPI.showBannerAd("over", XnhdAPI.Param.screenHeight - 220);
        }
        monitorLoop() {
            this.resetCoinNum();
            if (this._pressStatus && this._selectCard) {
                this._mousePos.setTo(Laya.stage.mouseX, Laya.stage.mouseY);
                this.gameZone.globalToLocal(this._mousePos);
                this._selectCard.pos(this._mousePos.x, this._mousePos.y - 139);
                core.GameLogic.Default.putDownCard_test(this._selectCard.x, this._selectCard.y, this._guideStep);
            }
            if (this._countDownSwitch) {
                this._countDownTime -= Laya.timer.delta;
                if (core.GameDef.isRank) {
                    if (this._countDownTime < 0) {
                        this.rankResetCountDown();
                        core.GameLogic.Default.randPutNextPoker();
                    }
                    let a = Math.floor(this._countDownTime / 100);
                    let s = Math.floor(a / 10);
                    let s1 = a - s * 10;
                    let l = core.GameDef.localizationConfig.GameView.rankingCountDown[core.GameDef.languageIndex];
                    this.tipsText.text = l + '\n' + s + '.' + s1;
                }
                else {
                    if (this._countDownTime < 0) {
                        this._countDownTime = 10000;
                        let k = core.GameDef.localizationConfig.GameView.gameTips[core.GameDef.languageIndex];
                        this.tipsText.text = k[XnhdAPI.Tools.randomInt(0, k.length - 1)];
                    }
                }
            }
        }
        rankResetCountDown() {
            let a = core.GameDef.itemLevelParseNum(core.Player.Manager.rankItemLevel_get(core.Player.ItemType.ThinkingTime));
            this._countDownTime = (5 + a) * 1000;
        }
        showRenewLayer(free, callback) {
            new view.renewLayer(this, !free, callback);
        }
        allowPlayerPress(allow) {
            this._allowPress = allow;
            if (!allow) {
                this._pressStatus = false;
                core.GameLogic.Default.cancelSelectCard();
            }
        }
        setLevel(level, goal) {
            let t = core.GameDef.localizationConfig.GameView.curLevel[core.GameDef.languageIndex];
            let a = t.indexOf('{0}');
            let b = t.indexOf('{1}');
            this.levelText.text = t.slice(0, a) + level.toString() + t.slice(a + 3, b) + goal.toString() + t.slice(b + 3);
            let toS = 750 / this.levelText.width * 0.9;
            // let textHeight = Math.floor(this.levelText.fontSize * toS * 2);
            let textHeight = 350;
            Laya.Tween.to(this.levelText, { scaleX: toS, scaleY: toS, y: textHeight }, 750, Laya.Ease.backOut);
            Laya.Tween.to(this.levelText, { scaleX: 1, scaleY: 1, y: 18 }, 750, Laya.Ease.backInOut, null, 1250);
        }
        setScore(score) {
            this._curScore.setNum(score);
            if (core.GameDef.isRank) {
                if (score > core.GameDef.maxScore.ranking) {
                    core.GameDef.maxScore.ranking = score;
                    core.GameDef.updateHighScore();
                }
                this.highScoreText.text = core.GameDef.maxScore.ranking.toString();
            }
            else {
                if (score > core.GameDef.maxScore.normal) {
                    core.GameDef.maxScore.normal = score;
                    core.GameDef.updateHighScore();
                }
                this.highScoreText.text = core.GameDef.maxScore.normal.toString();
            }
        }
        resetGameArea(gameData, isGuiding) {
            // console.log("resetGameArea",isGuiding,JSON.stringify(gameData));
            let areaParam = core.GameDef.gameParam.gameArea;
            // let isRankGame = core.GameDef.isRank;
            for (let i = 0; i < gameData.mairArr.length; i++) {
                for (let j = 0; j < gameData.mairArr[i].length; j++) {
                    let cardProp = gameData.mairArr[i][j];
                    let cardObj = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
                    cardObj.init(this.gameZone, areaParam.x0 + areaParam.x_Space * i, areaParam.y0 + areaParam.y_Space * j, id => {
                        this.cardClickFunc(id);
                    });
                    console.log("dsad-change1Skin");
                    cardObj.changeSkin(cardProp);
                    cardObj.name = cardProp.id.toString();
                    cardObj.zOrder = 1;
                }
            }
            let nextCard2 = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
            nextCard2.init(this.gameZone, this.nextCardZone.x - core.GameDef.gameParam.cardPickAniY + core.GameDef.gameParam.gameArea.x_Adjust, this.nextCardZone.y + 9, id => {
                this.cardClickFunc(id);
            });
            console.log("dsad-change2Skin");
            nextCard2.changeSkin(gameData.nextCardArr[1]);
            nextCard2.name = gameData.nextCardArr[1].id.toString();
            nextCard2.zOrder = 1;
            nextCard2.scale(0.6, 0.6);
            let nextCard1 = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
            nextCard1.init(this.gameZone, this.nextCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust, this.nextCardZone.y, id => {
                this.cardClickFunc(id);
            });
            console.log("dsad-change3Skin");
            nextCard1.changeSkin(gameData.nextCardArr[0]);
            nextCard1.name = gameData.nextCardArr[0].id.toString();
            nextCard1.zOrder = 1;
            if (gameData.readyCard) {
                let readyCard = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
                readyCard.init(this.gameZone, this.readyCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust, this.readyCardZone.y, id => {
                    this.cardClickFunc(id);
                });
                console.log("dsad-change4Skin");
                readyCard.changeSkin(gameData.readyCard);
                readyCard.name = gameData.readyCard.id.toString();
                readyCard.zOrder = 1;
            }
            this.setScore(gameData.curScore);
            this.setMonitor();
            if (isGuiding && core.GameDef.isRank === false) {
                this._guideStep = 0;
                this.guideLayer.visible = true;
                this.hand.visible = true;
                let from = this.getCardById(9);
                let to = this.getCardById(7);
                this.guideTips.text = core.GameDef.localizationConfig.GameView.gameGuide[core.GameDef.languageIndex][0];
                this.handAni(from.x, from.y, to.x, to.y);
            }
        }
        handAni(fromX, fromY, toX, toY) {
            Laya.Tween.clearAll(this.hand);
            this.hand.alpha = 0;
            this.hand.pos(fromX, fromY);
            // this._handAniNum++;
            Laya.Tween.to(this.hand, { alpha: 1 }, 500, null, Laya.Handler.create(this, () => {
                Laya.Tween.to(this.hand, { x: toX, y: toY }, 1000, null, Laya.Handler.create(this, () => {
                    Laya.Tween.to(this.hand, { alpha: 0 }, 500, null, Laya.Handler.create(this, () => {
                        // this._handAniNum--;
                        if (this._handAniNum === 0) {
                            this.handAni(fromX, fromY, toX, toY);
                        }
                    }));
                }));
            }));
        }
        cardClickFunc(id) {
            if (this._allowPress) {
                this._pressStatus = true;
                let a = false;
                //拿扑克
                if (this._guideStep < 0) {
                    a = true;
                }
                else if (this._guideStep === 0 && id === 9) {
                    a = true;
                }
                else if (this._guideStep === 1 && id === 10) {
                    a = true;
                }
                else if (this._guideStep === 2 && id === 11) {
                    a = true;
                }
                else if (this._guideStep === 3 && id === 8) {
                    a = true;
                }
                a && core.GameLogic.Default.selectWhitchCard(id);
            }
        }
        showCardFlash(idArr) {
            let i = 2;
            for (; i < 6; i++) {
                let a = this.gameZone.getChildAt(i);
                a.getChildAt(0).visible = idArr.indexOf(a.name) > -1;
            }
            for (; i < this.gameZone.numChildren; i++) {
                let a = this.gameZone.getChildAt(i);
                a.name != '' && a.showFlash(idArr.indexOf(a.name) > -1);
            }
        }
        putCardDown(i, j, guideStatus) {
            let areaParam = core.GameDef.gameParam.gameArea;
            let a = this._selectCard;
            if (!a) {
                console.log("dsAd-jlog, _selectCard === null !!!");
                return;
            }
            a.removeSelf();
            this.gameZone.addChild(a);
            Laya.Tween.to(a, { x: areaParam.x0 + areaParam.x_Space * i, y: areaParam.y0 + areaParam.y_Space * j }, 100);
            // a.pos(areaParam.x0 + areaParam.x_Space * i, areaParam.y0 + areaParam.y_Space * j);
            a.pickAni(false);
            a.zOrder = 1;
            core.AudioAndSetting.Manager.sound_putDown();
            this.showCardFlash([]);
            this._selectCard = null;
            if (core.GameDef.isRank) {
                this.rankResetCountDown();
            }
        }
        putCardReady(guideStatus) {
            let areaParam = core.GameDef.gameParam.gameArea;
            let a = this._selectCard;
            Laya.Tween.to(a, { x: this.readyCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust, y: this.readyCardZone.y }, 100);
            // this._selectCard.pos(this.readyCardZone.x+core.GameDef.gameParam.gameArea.x_Adjust, this.readyCardZone.y);
            a.pickAni(false);
            a.zOrder = 1;
            core.AudioAndSetting.Manager.sound_putDown();
            this.showCardFlash([]);
            this._selectCard = null;
        }
        playerRelease() {
            if (this._allowPress && this._pressStatus && this._selectCard) {
                this._pressStatus = false;
                this._mousePos.setTo(Laya.stage.mouseX, Laya.stage.mouseY);
                this.gameZone.globalToLocal(this._mousePos);
                core.GameLogic.Default.putDownCard(this._mousePos.x, this._mousePos.y - 139, this._guideStep);
            }
        }
        cancelSelect(selectType, j) {
            if (this._selectCard) {
                let a = this._selectCard;
                this._selectCard = null;
                a.pickAni(false);
                a.zOrder = 1;
                let _x, _y;
                if (selectType === core.selectCardType.nextCard) {
                    _x = this.nextCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust;
                    _y = this.nextCardZone.y;
                }
                else if (selectType === core.selectCardType.readyCard) {
                    _x = this.readyCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust;
                    _y = this.readyCardZone.y;
                }
                else {
                    let areaParam = core.GameDef.gameParam.gameArea;
                    _x = areaParam.x0 + areaParam.x_Space * (selectType - 1);
                    _y = areaParam.y0 + areaParam.y_Space * j;
                }
                Laya.Tween.to(a, { x: _x, y: _y }, 100);
                this.showCardFlash([]);
            }
        }
        pressOmnipotentCard() {
            if (this._allowPress) {
                let noNeedGuide = XnhdAPI.readDataFromCache('Guide');
                if (noNeedGuide)
                    core.GameLogic.Default.useOmnipotentCard();
            }
        }
        nextCardChange(nextCardArr, callback) {
            let b = 2;
            for (let i = 0; i < 2; i++) {
                let a = this.getCardById(nextCardArr[i].id);
                console.log("dsad-change5Skin");
                a.changeSkin_ani(nextCardArr[i], 300, () => {
                    b--;
                    if (b === 0) {
                        callback && callback();
                    }
                });
            }
        }
        pressBombBtn() {
            let noNeedGuide = XnhdAPI.readDataFromCache('Guide');
            // if (this._allowPress) {
            if (noNeedGuide)
                core.GameLogic.Default.useBomb();
            // }
        }
        useBombEff(arr, scoreArr) {
            this.allowPlayerPress(false);
            let count = 0;
            for (let i = 0; i < arr.length; i++) {
                for (let j = 0; j < arr[i].length; j++) {
                    count++;
                }
            }
            if (count === 0) {
                this.allowPlayerPress(true);
            }
            let d = count;
            for (let i = 0; i < arr.length; i++) {
                for (let j = 0; j < arr[i].length; j++) {
                    let a = this.getCardById(arr[i][j].id);
                    let index = d - count;
                    let delay = Math.floor(index / 4);
                    a.eliminate(200, delay * 20, () => {
                        count--;
                        this.setScore(scoreArr[index]);
                        let eff = new eliminateEff_Obj;
                        eff.init(a.x, a.y, this.gameArea, 1);
                        if (count === 0) {
                            this.allowPlayerPress(true);
                        }
                    });
                }
            }
            core.AudioAndSetting.Manager.sound_bomb();
        }
        resetCoinNum() {
            this.coinText.text = core.Player.Manager.getCoinNum().toString();
        }
        resetOmnipotentCardNum(free, paid) {
            console.log("run in resetOmnipotentCardNum, free:", free, ", paid:", paid);
            let t = core.GameDef.localizationConfig.itemDescription.OmnipotentCard[core.GameDef.languageIndex] + core.GameDef.localizationConfig.itemDescription.pluralType[core.GameDef.languageIndex];
            let txt = this.OmnipotentCardBtn.getChildAt(0);
            let videoImg = this.OmnipotentCardBtn.getChildAt(1);
            let itemSkin = this.OmnipotentCardBtn.getChildAt(2);
            videoImg.visible = free === 0; //&& paid > 0;
            itemSkin.x = !videoImg.visible ? this.OmnipotentCardBtn.width / 2 : 46;
            // txt.text = t + (free > 0 ? free.toString() : paid.toString());
            txt.text = t + (free > 0 ? free.toString() : "1");
        }
        resetBombNum(free, paid) {
            let t = core.GameDef.localizationConfig.itemDescription.Bomb[core.GameDef.languageIndex] + core.GameDef.localizationConfig.itemDescription.pluralType[core.GameDef.languageIndex];
            let txt = this.bombBtn.getChildAt(0);
            let videoImg = this.bombBtn.getChildAt(1);
            let itemSkin = this.bombBtn.getChildAt(2);
            videoImg.visible = free === 0; //&& paid > 0;
            itemSkin.x = !videoImg.visible ? this.bombBtn.width / 2 : 46;
            txt.text = t + (free > 0 ? free.toString() : paid.toString());
        }
        resetCardSaveTimes(free, paid) {
            console.log("run in resetCardSaveTimes, free:", free, ", paid:", paid);
            let t = core.GameDef.localizationConfig.itemDescription.CardSaved[core.GameDef.languageIndex] + core.GameDef.localizationConfig.itemDescription.pluralType[core.GameDef.languageIndex];
            let videoImg = this.readyCardZone.getChildAt(0);
            videoImg.visible = free === 0; //&& paid > 0;
            this.readyCardRemain.text = t + (free > 0 ? free.toString() : paid.toString());
            this.readyCardRemain.y = videoImg.visible ? 55 : this.readyCardZone.height / 2;
        }
        showNoSavedCard(successCallback, failCallback) {
            this.getVideoItem(successCallback, failCallback, "cunpai");
        }
        showNoOmnipotentCard(successCallback, failCallback) {
            this.getVideoItem(successCallback, failCallback, "wannengpai");
        }
        showNoBomb(successCallback, failCallback) {
            this.getVideoItem(successCallback, failCallback, "zhadan");
        }
        getVideoItem(successCallback, failCallback, adName) {
            if (!core.GameDef.isRank) {
                if (this._videoSwitch) {
                    let that = this;
                    if (XnhdAPI.checkVideoAd() === 3) {
                        this._videoSwitch = false;
                        XnhdAPI.showVideoAd(adName, () => {
                            that._videoSwitch = true;
                            successCallback && successCallback();
                        }, f => {
                            that._videoSwitch = true;
                            XnhdAPI.showTips(core.GameDef.localizationConfig.finishVideoTips[core.GameDef.languageIndex], true, 1000);
                            failCallback && failCallback();
                        }, f => {
                            that._videoSwitch = true;
                            XnhdAPI.showTips(core.GameDef.localizationConfig.noVideoTips[core.GameDef.languageIndex], true, 1000);
                            failCallback && failCallback();
                        });
                    }
                    else {
                        XnhdAPI.showTips(core.GameDef.localizationConfig.noVideoTips[core.GameDef.languageIndex], true, 1000);
                        failCallback && failCallback();
                    }
                }
            }
            else {
                failCallback && failCallback();
            }
        }
        pickOneCard(id) {
            if (this._allowPress) {
                this._selectCard = this.getCardById(id);
                this._selectCard.zOrder = 3;
                this._selectCard.pickAni(true);
                core.AudioAndSetting.Manager.sound_pickUp();
                this._pressStatus = true;
                // if (isCurrent === 3) {
                this._mousePos.setTo(Laya.stage.mouseX, Laya.stage.mouseY);
                this.gameZone.globalToLocal(this._mousePos);
                // }
                // core.GameLogic.Default.selectWhitchCard(isCurrent, this._mousePos);
            }
        }
        getCardById(id) {
            // console.log("dsAd-jlog, run in getCardById, id:" + id);
            return this.gameZone.getChildByName(id.toString());
        }
        showNextCardAni(nextArr, callback) {
            let nextCard2 = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
            nextCard2.init(this.gameZone, this.nextCardZone.x - core.GameDef.gameParam.cardPickAniY + core.GameDef.gameParam.gameArea.x_Adjust, this.nextCardZone.y + 9, id => {
                this.cardClickFunc(id);
            });
            nextCard2.changeSkin(nextArr[1]);
            nextCard2.name = nextArr[1].id.toString();
            nextCard2.scale(0, 0);
            nextCard2.alpha = 0;
            nextCard2.zOrder = 0;
            Laya.Tween.to(nextCard2, { scaleX: 0.6, scaleY: 0.6, alpha: 1 }, 200);
            let nextCard1 = this.getCardById(nextArr[0].id);
            nextCard1.zOrder = 1;
            Laya.Tween.to(nextCard1, { x: this.nextCardZone.x + core.GameDef.gameParam.gameArea.x_Adjust, y: this.nextCardZone.y, scaleX: 0.67, scaleY: 0.67, }, 200, null, Laya.Handler.create(this, () => {
                callback && callback();
            }));
        }
        eliminateCards(cardArr, scoreArr, changeCard, callback) {
            this.hand.visible = false;
            let i = 0;
            let delay = 200;
            let notHasBomb = true;
            for (; i < cardArr.length; i++) {
                let card = this.getCardById(cardArr[i].id);
                let b = i + 1;
                let cardBack = i != cardArr.length - 1 ? this.getCardById(cardArr[b].id) : null;
                if (notHasBomb && cardArr[i].p2 === 1) {
                    notHasBomb = false;
                }
                let effSwitch = !notHasBomb;
                card.eliminate(200, delay, () => {
                    this.setScore(scoreArr[b - 1]);
                    console.log("dsad-change7Skin");
                    cardBack && cardBack.changeSkin(cardArr[b]);
                    if (effSwitch) {
                        // let eff = new eliminateEff_Obj;
                        // eff.init(card.x, card.y, this.gameZone);
                    }
                    else {
                        core.AudioAndSetting.Manager.soundCombo(b);
                    }
                }, () => {
                    let eff = new eliminateEff_Obj;
                    eff.init(card.x, card.y, this.gameArea, 1);
                });
                delay += notHasBomb ? 300 : 50;
            }
            Laya.timer.once(delay, this, () => {
                if (notHasBomb && i > 2) {
                    core.AudioAndSetting.Manager.soundCongratulate(i - 2);
                }
                if (changeCard) {
                    let card = this.getCardById(changeCard.id);
                    console.log("dsad-change8Skin");
                    card.changeSkin(changeCard);
                }
                //消除扑克
                if (this._guideStep === 0) {
                    this.hand.visible = true;
                    this._guideStep++;
                    // let from = this.getCardById(10);
                    // let to = this.getCardById(7);
                    this.guideTips.text = core.GameDef.localizationConfig.GameView.gameGuide[core.GameDef.languageIndex][1];
                    // this.handAni(from.x, from.y, to.x, to.y);
                }
                else if (this._guideStep === 1) {
                    this.hand.visible = true;
                    this._guideStep++;
                    this.guideTips.text = core.GameDef.localizationConfig.GameView.gameGuide[core.GameDef.languageIndex][2];
                    let from = this.getCardById(11);
                    let to = this.getCardById(4);
                    this.handAni(from.x, from.y, to.x, to.y);
                }
                else if (this._guideStep === 3) {
                    this._guideStep++;
                    Laya.Tween.clearAll(this.hand);
                    this._handAniNum = 10;
                    this.guideLayer.visible = false;
                    this.hand.visible = false;
                    new guideFinish(this, () => {
                        this._guideStep = -1;
                        this._countDownSwitch = true;
                        core.GameLogic.Default.finishGuiding();
                    });
                }
                callback && callback();
            });
        }
        showLevelUp(levelUpCard, score, level, callback) {
            this.allowPlayerPress(false);
            core.AudioAndSetting.Manager.sound_levelUp();
            this._countDownSwitch = false;
            let card = this.getCardById(levelUpCard.id);
            card.zOrder = 2;
            let coinNum = core.GameDef.gameParam.rewardGold[level];
            if (level > core.GameDef.gameParam.rewardGold.length - 1) {
                coinNum = core.GameDef.gameParam.rewardGold[core.GameDef.gameParam.rewardGold.length - 1];
            }
            Laya.Tween.to(card, { x: 375, y: 320, scaleX: 1, scaleY: 1 }, 500, null, Laya.Handler.create(this, () => {
                this.setScore(score);
                card.eliminate(200, 0, () => {
                    let eff = new eliminateEff_Obj;
                    eff.init(card.x, card.y, this.gameArea);
                    if (this._guideStep === 2) {
                        this.allowPlayerPress(true);
                        this.hand.visible = true;
                        this._guideStep++;
                        this.guideTips.text = core.GameDef.localizationConfig.GameView.gameGuide[core.GameDef.languageIndex][3];
                        let from = this.getCardById(8);
                        let to = this.getCardById(3);
                        this.handAni(from.x, from.y, to.x, to.y);
                    }
                    else if (core.GameDef.isRank) {
                        new view.TurntableLayer(this, level, e => {
                            this._countDownSwitch = true;
                            let a = core.GameDef.itemLevelParseNum(core.Player.Manager.rankItemLevel_get(core.Player.ItemType.ThinkingTime));
                            this._countDownTime = (6 + a) * 1000;
                            callback && callback(e);
                        });
                    }
                    else {
                        new view.levelUpLayer(coinNum, e => {
                            if (e) {
                                callback && callback({
                                    name: 'Coin',
                                    num: coinNum + 10
                                });
                            }
                            else {
                                callback && callback({
                                    name: 'Coin',
                                    num: coinNum
                                });
                            }
                        }, () => {
                            this._countDownSwitch = true;
                        }, this);
                    }
                });
            }));
        }
        levelUpAddCard(cardArr, callback) {
            let areaParam = core.GameDef.gameParam.gameArea;
            for (let i = 0; i < cardArr.length; i++) {
                let card = Laya.Pool.getItemByClass('cardObj', view.cardUnit);
                card.init(this.gameZone, 0, -145, id => {
                    this.cardClickFunc(id);
                });
                console.log("dsad-change9Skin");
                card.changeSkin(cardArr[i].card);
                card.scale(0, 0);
                card.name = cardArr[i].card.id.toString();
                card.zOrder = 1;
                let ij = cardArr[i].ij;
                Laya.Tween.to(card, { scaleX: 0.67, scaleY: 0.67, x: areaParam.x0 + areaParam.x_Space * ij[0], y: areaParam.y0 + areaParam.y_Space * ij[1] }, 300, null, Laya.Handler.create(this, () => {
                    core.AudioAndSetting.Manager.sound_putDown();
                }), 100 + i * 100);
            }
            Laya.timer.once(cardArr.length * 100 + 400, this, () => {
                this.allowPlayerPress(true);
                callback && callback();
            });
        }
        showGameOver() {
            core.AudioAndSetting.Manager.sound_gameOver();
            this._countDownSwitch = false;
            this.allowPlayerPress(false);
            // this.gameArea.offAll();
            Laya.timer.clear(this, this.monitorLoop);
            core.GameDef.updateHighScore();
            for (let i = 0; i < this.gameZone.numChildren; i++) {
                let a = this.gameZone.getChildAt(i);
                Laya.timer.frameOnce(i * 2, this, () => {
                    a.gray = true;
                });
            }
            Laya.timer.frameOnce(this.gameZone.numChildren * 2 + 10, this, () => {
                new view.overLayer(this);
            });
        }
    }
    view.GameView = GameView;
    class eliminateEff_Obj extends Laya.Image {
        constructor() {
            super();
        }
        init(x, y, parent, aniRound = 4) {
            this.pos(x, y);
            parent.addChild(this);
            this.gray = false;
            this.liftTime = 50;
            this._countDownTime = 300;
            for (let i = 1; i < aniRound + 1; i++) {
                let r = [];
                for (let n = 0; n < 10; n++) {
                    let _ = Math.PI / 5 * (n + Math.random() * 0.9);
                    r.push(_);
                }
                r.sort((a, b) => {
                    return Math.random() - 0.5;
                });
                for (let j = 0; j < 10; j++) {
                    Laya.timer.frameOnce(i * 10 + j, this, () => {
                        let unit = Laya.Pool.getItemByClass('eliminateEff_Unit', eliminateEff_Unit);
                        this.addChild(unit);
                        let life = XnhdAPI.Tools.randomInt(40, 80);
                        let d = (Math.log(XnhdAPI.Tools.randomInt(1, 500)) / Math.log(10) * 100 + 50) / life;
                        let _r = r.shift();
                        unit.init(Math.cos(_r) * d, Math.sin(_r) * d, XnhdAPI.Tools.randomInt(0, 720) - 360, Math.random() * 0.5 + 0.5, Math.random() * 0.3 + 0.5, life, () => {
                            this.liftTime--;
                        });
                    });
                }
            }
            this.zOrder = 10;
            Laya.timer.frameLoop(1, this, this.onLoop);
        }
        onLoop() {
            if (this.liftTime === 0 || this._countDownTime === 0) {
                Laya.timer.clear(this, this.onLoop);
                this.destroy();
                return;
            }
            for (let i = 0; i < this.numChildren; i++) {
                let a = this.getChildAt(i);
                a.moveLoop();
            }
            this._countDownTime--;
        }
    }
    class eliminateEff_Unit extends Laya.Image {
        constructor() {
            super('game/star.png');
            this._v = {
                x: 0,
                y: 0,
                r: 0,
                a: 0,
                s: 0
            };
            this.pivot(32, 34);
        }
        init(vx, vy, vr, scale, a, liftTime, callback) {
            let red = Math.random();
            let green = Math.random() * (1 - red);
            let blue = 1 - red - green;
            let f = new Laya.ColorFilter([
                red, 0, 0, 0, 0,
                0, green, 0, 0, 0,
                0, 0, blue, 0, 0,
                0, 0, 0, a, 0,
            ]);
            this.filters = [f];
            this.scale(scale, scale);
            this.rotation = 0;
            this.alpha = 1;
            this.pos(0, 0);
            this._v = {
                x: vx,
                y: vy,
                r: vr,
                a: 1 / liftTime,
                s: scale / liftTime
            };
            this._c = callback;
        }
        moveLoop() {
            this.x += this._v.x;
            this.y += this._v.y;
            this.rotation += this._v.r;
            this.alpha -= this._v.a;
            this.scaleX -= this._v.s;
            this.scaleY -= this._v.s;
            if (this.scaleX < 0) {
                this.destroy();
            }
        }
        destroy() {
            this.removeSelf();
            this._c && this._c();
            Laya.Pool.recover('eliminateEff_Unit', this);
        }
    }
    class guideFinish extends ui.Layer.guideFinishLayerUI {
        constructor(parent, closeCallback) {
            super();
            parent.addChild(this);
            this.blackBg.height = 1624;
            this.container.y = this.blackBg.height / 2;
            this.closeBtn.on(Laya.Event.CLICK, this, () => {
                this.destroy();
                closeCallback && closeCallback();
            });
            this.confirmBtn.on(Laya.Event.CLICK, this, () => {
                this.destroy();
                closeCallback && closeCallback();
            });
            let l = core.GameDef.localizationConfig;
            let i = core.GameDef.languageIndex;
            this.tittleTxt.text = l.GameView.gameGuideFinish[i];
            this.tips.text = l.GameView.gameGuide[i][4];
            this.confirmBtn.getChildAt(0).text = l.GameView.gameGuideFinishConfirmBtn[i];
        }
    }
})(view || (view = {}));
