var view;
(function (view) {
    class PauseLayer extends ui.Layer.PauseLayerUI {
        constructor(parent, curScore, closeCallback) {
            super();
            parent.addChild(this);
            this._closeCallback = closeCallback;
            this.UIAdjust();
            let i = core.GameDef.languageIndex;
            let l = core.GameDef.localizationConfig;
            this.curScore.text = curScore;
            this.maxScore.text = l.highScore[i] + " : " + (core.GameDef.isRank ? core.GameDef.maxScore.ranking.toString() : core.GameDef.maxScore.normal.toString());
            this.middleZone.getChildAt(8).text = l.PauseLayer.tips[i];
            this.middleZone.getChildAt(0).getChildAt(1).text = l.PauseLayer.title[i];
            this.continueBtn.getChildAt(1).text = l.PauseLayer.continueBtn[i];
            this.backMainBtn.getChildAt(1).text = l.GameOverView.backMain[i];
            this.restartBtn.getChildAt(1).text = l.GameOverView.restart[i];
            if (!core.GameDef.isRank) {
                this.restartBtn.getChildAt(1).y = 55;
            }
            else {
                this.coin_img.visible = true;
            }
            this.continueBtn.on(Laya.Event.CLICK, this, this.Destroy);
            this.closeBtn.on(Laya.Event.CLICK, this, this.Destroy);
            this.restartBtn.on(Laya.Event.CLICK, this, () => {
                if (core.GameDef.isRank) {
                    if (core.Player.Manager.getCoinNum() > 99 || core.GameDef.selfTest) {
                        core.Player.Manager.adjustCoinNum(-100);
                        XnhdAPI.saveDataToCache("RankData", '');
                        core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                    }
                    else {
                        new view.LackOfGold(this, null);
                    }
                }
                else {
                    XnhdAPI.saveDataToCache("GameData", '');
                    this.destroy();
                    core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                }
            });
            let soundBtnSkin = this.soundBtn.getChildAt(0);
            if (core.AudioAndSetting.Manager.volumeMusic === 0) {
                soundBtnSkin.skin = "game/sound_off.png";
            }
            else {
                soundBtnSkin.skin = "game/sound_on.png";
            }
            this.soundBtn.on(Laya.Event.CLICK, this, () => {
                if (core.AudioAndSetting.Manager.volumeMusic == 0) {
                    core.AudioAndSetting.Manager.setMusicVolume(70);
                    core.AudioAndSetting.Manager.setSoundVolume(100);
                    soundBtnSkin.skin = "game/sound_on.png";
                }
                else {
                    core.AudioAndSetting.Manager.setMusicVolume(0);
                    core.AudioAndSetting.Manager.setSoundVolume(0);
                    soundBtnSkin.skin = "game/sound_off.png";
                }
            });
            this.backMainBtn.on(Laya.Event.CLICK, this, () => {
                core.SceneManager.Default.ShowScene(core.GameScene.MAINSCENE);
            });
        }
        Destroy() {
            this.destroy();
            this._closeCallback && this._closeCallback();
        }
        UIAdjust() {
            this.middleZone.y = XnhdAPI.Param.screenHeight / 2 - 110;
        }
    }
    view.PauseLayer = PauseLayer;
})(view || (view = {}));
