var view;
(function (view) {
    class TurntableLayer extends ui.Layer.TurntableViewUI {
        constructor(parent, level, closeCallback) {
            super();
            this._rewards = core.GameDef.gameParam.rankTurntable;
            this.startAccuration = 0.2;
            this.startAccurateTime = 60;
            this.stopAccuration = 0.05;
            parent.addChild(this);
            this.closeCallback = closeCallback;
            this.startBtn.y = XnhdAPI.Param.screenHeight - 220 - this.startBtn.height / 2;
            this.all.y = this.startBtn.y - this.startBtn.height / 2;
            this.dealWithRewardImg();
            this.startBtn.once(Laya.Event.CLICK, this, this.startRolling);
            let l = core.GameDef.localizationConfig.turntableLayer;
            let i = core.GameDef.languageIndex;
            this.startBtn.getChildAt(0).text = l.startBtn[i];
            let a = l.title[i].indexOf('{0}');
            let t = l.title[i].substring(0, a) + level.toString() + l.title[i].substring(a + 3);
            XnhdAPI.showTips(t);
        }
        startRolling() {
            this.startBtn.visible = false;
            core.AudioAndSetting.Manager.sound_startTurntable();
            this.chooseRewardIndex();
        }
        getReward() {
            let l = core.GameDef.localizationConfig;
            let i = core.GameDef.languageIndex;
            let item = l.itemDescription[this.callbackReward.name][i] + l.itemDescription.pluralType[i] + this.callbackReward.num.toString();
            XnhdAPI.showTips(l.turntableLayer.tips[i] + item);
            let a = JSON.parse(JSON.stringify(this.callbackReward));
            Laya.timer.once(1000, this, () => {
                this.closeCallback && this.closeCallback(a);
                this.destroy();
            });
        }
        chooseRewardIndex() {
            let allProbability = 0;
            for (let i = 0; i < this._rewards.length; i++) {
                allProbability += this._rewards[i].probability;
            }
            let chooseNum = XnhdAPI.Tools.randomInt(1, allProbability);
            for (let i = 0; i < this._rewards.length; i++) {
                this._rewardGetIndex = i;
                chooseNum -= this._rewards[i].probability;
                if (chooseNum < 1) {
                    break;
                }
            }
            this.callbackReward = this._rewards[this._rewardGetIndex];
            let startRotation = 0.5 * this.startAccuration * Math.pow(this.startAccurateTime, 2);
            let maxVelocity = this.startAccuration * this.startAccurateTime;
            let stopAccurateTime = maxVelocity / this.stopAccuration;
            let stopRotation = stopAccurateTime * maxVelocity - 0.5 * this.stopAccuration * Math.pow(stopAccurateTime, 2);
            let allRotation = startRotation + stopRotation;
            let destinyRotation = ((this._rewardGetIndex - 0.5) * 360 / this._rewards.length + XnhdAPI.Tools.randomInt(1, Math.floor(360 / this._rewards.length / maxVelocity)) * maxVelocity + 360) % 360;
            XnhdAPI.logDebug("destinyRotation >" + destinyRotation.toString());
            let needRotate = (destinyRotation - allRotation % 360 - this.imgZhizhen.rotation % 360 + 3 * 360) % 360;
            let middleTime = (needRotate + 2 * 360) / maxVelocity;
            this.zhuanpanFrames = 0;
            this.rotateZhuanpan(middleTime);
        }
        rotateZhuanpan(middleTime) {
            let velocity = 0;
            this.zhuanpanFrames++;
            if (this.zhuanpanFrames < this.startAccurateTime) {
                velocity = this.zhuanpanFrames * this.startAccuration;
            }
            else if (this.zhuanpanFrames < this.startAccurateTime + middleTime) {
                velocity = this.startAccurateTime * this.startAccuration;
            }
            else {
                velocity = this.startAccurateTime * this.startAccuration - (this.zhuanpanFrames - this.startAccurateTime - middleTime) * this.stopAccuration;
            }
            if (velocity <= 0) {
                this.imgZhizhen.rotation = this.imgZhizhen.rotation % 360;
                XnhdAPI.logDebug("Rotation >>" + this.imgZhizhen.rotation.toString());
                core.AudioAndSetting.Manager.sound_stopTurntable();
                this.getReward();
            }
            else {
                this.imgZhizhen.rotation += velocity;
                Laya.timer.frameOnce(1, this, this.rotateZhuanpan, [middleTime]);
            }
        }
        dealWithRewardImg() {
            let n = this._rewards.length;
            let ro = 180 / n;
            // let shadow = this.blackBg.getChildAt(0) as Laya.Sprite;
            let shadow = this.blackBg.mask;
            for (let i = 0; i < this._rewards.length; i++) {
                if (i % 2 === 0) {
                    // let a = new Laya.Sprite;
                    // a.graphics.drawPie(262, 262, 262, i * 2 * ro - ro - 90, i * 2 * ro + ro - 90, '#000000');
                    // shadow.addChild(a);
                    shadow.graphics.drawPie(262, 262, 262, i * 2 * ro - ro - 90, i * 2 * ro + ro - 90, '#000000');
                }
                let zone = new Laya.Image;
                this.itemLayer.addChild(zone);
                zone.rotation = i * 2 * ro;
                let a = this.getItemImage(this._rewards[i].name);
                a.anchorX = 0.5;
                a.anchorY = 0.5;
                a.pos(0, -215);
                a.rotation = -zone.rotation;
                zone.addChild(a);
                let _l = core.GameDef.localizationConfig.itemDescription;
                let _i = core.GameDef.languageIndex;
                let b = new Laya.Label(_l[this._rewards[i].name][_i] + '\n' + _l.pluralType[_i] + this._rewards[i].num.toString());
                b.align = 'center';
                b.valign = 'middle';
                b.wordWrap = true;
                b.anchorX = 0.5;
                b.anchorY = 0.5;
                b.size(120, 40);
                b.color = '#101010';
                b.fontSize = 20;
                b.pos(0, -150);
                b.rotation = -zone.rotation;
                zone.addChild(b);
            }
        }
        getItemImage(itemName) {
            let l = core.GameDef.localizationConfig.itemDescription;
            let i = core.GameDef.languageIndex;
            if (itemName === 'OmnipotentCard') {
                let a = new Laya.Image('game/wnxt.png');
                a.size(64, 64);
                return a;
            }
            if (itemName === 'Bomb') {
                let a = new Laya.Image('game/fjxt.png');
                a.size(64, 64);
                return a;
            }
            if (itemName === 'CardSaved') {
                let a = new Laya.Image('game/cpxt.png');
                a.size(64, 64);
                return a;
            }
            if (itemName === 'Coin') {
                let a = new Laya.Image('game/jixt.png');
                a.size(64, 64);
                return a;
            }
            XnhdAPI.logError('TurntableLayer getItemImage Fail: ' + itemName);
            return null;
        }
    }
    view.TurntableLayer = TurntableLayer;
})(view || (view = {}));
