var view;
(function (view) {
    class cultivateLayer extends ui.Layer.cultivateLayerUI {
        constructor(parent, closeCallback) {
            super();
            parent.addChild(this);
            this.UIAdjust();
            this.adjustAllText();
            this.OmnipotentBtn.on(Laya.Event.CLICK, this, this.pressBtn, [core.Player.ItemType.OmnipotentCard]);
            this.BombBtn.on(Laya.Event.CLICK, this, this.pressBtn, [core.Player.ItemType.Bomb]);
            this.SaveBtn.on(Laya.Event.CLICK, this, this.pressBtn, [core.Player.ItemType.CardSaved]);
            this.ThinkingBtn.on(Laya.Event.CLICK, this, this.pressBtn, [core.Player.ItemType.ThinkingTime]);
            this.closeBtn.on(Laya.Event.CLICK, this, () => { this.destroy(); closeCallback && closeCallback(); });
        }
        pressBtn(itemName) {
            let level = core.Player.Manager.rankItemLevel_get(itemName);
            if (level < 75) {
                let plus = core.GameDef.itemLevelParseNum(level);
                let i = core.GameDef.languageIndex;
                let l = core.GameDef.localizationConfig;
                let needCoin = core.GameDef.gameParam.rankLevelUpCoin[plus];
                if (core.Player.Manager.getCoinNum() > needCoin - 1 || core.GameDef.selfTest) {
                    !core.GameDef.selfTest && core.Player.Manager.adjustCoinNum(-needCoin);
                    core.Player.Manager.rankItemLevel_levelUp(itemName);
                    this.adjustAllText();
                    let level1 = core.Player.Manager.rankItemLevel_get(itemName);
                    let plus1 = core.GameDef.itemLevelParseNum(level1);
                    plus1 > plus && XnhdAPI.showTips(l.cultivateLayer.successLevelUp[i], true, 1000);
                }
                else {
                    new view.LackOfGold(this, () => {
                        this.coinNum.text = core.Player.Manager.getCoinNum().toString();
                    });
                }
            }
        }
        adjustAllText() {
            this.dealWithText(this.middleZone.getChildAt(3), core.Player.ItemType.OmnipotentCard);
            this.dealWithText(this.middleZone.getChildAt(4), core.Player.ItemType.Bomb);
            this.dealWithText(this.middleZone.getChildAt(5), core.Player.ItemType.CardSaved);
            this.dealWithText(this.middleZone.getChildAt(6), core.Player.ItemType.ThinkingTime);
            this.coinNum.text = core.Player.Manager.getCoinNum().toString();
        }
        dealWithText(node, itemName) {
            let i = core.GameDef.languageIndex;
            let l = core.GameDef.localizationConfig;
            let level = core.Player.Manager.rankItemLevel_get(itemName);
            node.getChildAt(0).getChildAt(0).text = l.itemDescription[itemName][i];
            let a = l.cultivateLayer[itemName];
            node.getChildAt(1).getChildAt(0).text = a ? a[i] : l.cultivateLayer.availableTimes[i];
            if (level === 75) {
                node.getChildAt(2).getChildAt(1).visible = false;
                node.getChildAt(2).getChildAt(0).visible = false;
                node.getChildAt(2).getChildAt(2).y = 55;
                node.getChildAt(2).getChildAt(2).text = l.cultivateLayer.maxLevel[i];
                node.getChildAt(1).skin = '';
                node.getChildAt(1).getChildAt(1).text = a ? '15' : '10';
                node.getChildAt(1).getChildAt(2).visible = false;
                node.getChildAt(3).getChildAt(0).width = 440;
                node.getChildAt(3).getChildAt(1).visible = false;
            }
            else {
                let plus = core.GameDef.itemLevelParseNum(level);
                node.getChildAt(2).getChildAt(1).text = core.GameDef.gameParam.rankLevelUpCoin[plus].toString();
                node.getChildAt(2).getChildAt(2).text = l.cultivateLayer.levelUp[i];
                node.getChildAt(1).getChildAt(1).text = a ? (plus + 5).toString() : plus.toString();
                node.getChildAt(1).getChildAt(2).text = a ? (plus + 6).toString() : (plus + 1).toString();
                let r = level - (plus + 5) * plus / 2;
                node.getChildAt(3).getChildAt(0).width = 440 * r / (plus + 3);
                node.getChildAt(3).getChildAt(1).text = r.toString() + ' / ' + (plus + 3).toString();
            }
        }
        UIAdjust() {
            this.middleZone.y = XnhdAPI.Param.screenHeight / 2 - 110 + this.middleZone.height / 2;
            this.titleTxt.text = core.GameDef.localizationConfig.cultivateLayer.title[core.GameDef.languageIndex];
        }
    }
    view.cultivateLayer = cultivateLayer;
})(view || (view = {}));
