var view;
(function (view) {
    /**
     * 排行榜，通过界面内的rankListZone(一个Laya.Panel类)来做微信子域排行榜显示适配
     */
    class RankListLayer extends ui.Layer.ranklistLayerUI {
        /**
         * 排行榜，通过界面内的rankListZone(一个Laya.Panel类)来做微信子域排行榜显示适配，必须提前准备好用户信息
         * @param parent 父节点
         * @param closeCallback
         */
        constructor(parent, closeCallback = null) {
            super();
            //微信相关参数
            this._pressDown = false;
            this._wxRankListSwitch = false;
            this._lastMouseY = 0;
            this._worldRankShowTestData = 0;
            this._worldCurRank = 0;
            this._ranklistCompArr = [];
            //隐藏banner广告
            XnhdAPI.hideBanner("over");
            //显示插屏广告
            XnhdAPI.showIneAd();
            this.UIAdjust();
            this.platNodeInit();
            parent.addChild(this);
            //微信好友排行榜示意
            this.worldBtn.visible = true;
            this.friendBtn.visible = false;
            // this.friendBtn.x = 179;
            XnhdAPI.showRankList(this.rankListZone);
            this.closeBtn.on(Laya.Event.CLICK, this, (e) => {
                // e.stopPropagation();
                this.Destroy();
                closeCallback && closeCallback();
            });
            //先把微信的显示给关了，暂时使用游客登录。
            this.shareBtn.visible = false;
            // this.shareBtn.on(Laya.Event.CLICK, this, () => {
            //     // XnhdAPI.shareImage(false, 2);
            //       // 分享，主动拉起转发，进入选择通讯录界面
            //     Laya.Browser.window.wx.aldShareAppMessage({
            //         imageUrl : 'https://mmocgame.qpic.cn/wechatgame/tkqueHfeL6Q339O6SXVTZxpKrttNLx1R003f2MPpL4ORIvniauMCLfn11ichMsjSX1/0',//转发标题
            //         title    : '今天，一起来消除方块吧！',//转发标题
            //         query    : "",
            //         success: function (res) {
            //             console.log('分享成功')
            //         },
            //         fail: function () {
            //             console.log('分享失败')
            //         }
            //     });
            // });
            core.GameDef.myWorldRankInfo.avatarUrl = XnhdAPI.WxLiteGameAPI.Param.userInfo.avatarUrl;
            core.GameDef.myWorldRankInfo.nickName = XnhdAPI.WxLiteGameAPI.Param.userInfo.nickName;
            core.GameDef.myWorldRankInfo.appid = "tt9abbec060591b6d7"; //XnhdAPI.WxLiteGameAPI.Param.appInfo.appid;
            core.GameDef.myWorldRankInfo.openid = XnhdAPI.WxLiteGameAPI.Param.openid;
            //根据世界排行榜信息进行处理
            let myWorldInfo = core.GameDef.myWorldRankInfo;
            console.log("myWorldInfo:", myWorldInfo);
            // if (myWorldInfo.appid.length > 0 && myWorldInfo.openid.length > 0) {
            core.GameDef.updateWorldRankData(core.GameDef.maxScore.ranking, e => {
                if (typeof (e) == "string")
                    e = JSON.parse(e);
                this._worldRankData = e;
                //世界排行榜数据格式,"rankList":[{"idx":1,"openid":"a","nick":"ccc","icon":"44","score":22}],"myRank":1,"myScore":22
                //处理我的相关信息
                console.log("目前世界排行榜的数据", this._worldRankData);
                let my = this.rankListZone_W.parent.getChildAt(1);
                var rankT = e['myRank'] > 1000 ? "1000+" : e['myRank'].toString();
                this.rankScore.text = rankT; //e['myRank']?e['myRank'].toString():0;
                this.rankScoreBg.visible = e['myRank'] ? e['myRank'] < 99 : false;
                let a = 4;
                if (e['myRank']) {
                    a = e['myRank'] > 4 ? 4 : e['myRank'];
                }
                this.rankScoreBg.skin = 'game/rank_' + a + '.png';
                my.getChildAt(2).skin = myWorldInfo.avatarUrl || "card/1_2.png";
                my.getChildAt(3).text = myWorldInfo.nickName || "我";
                my.getChildAt(4).text = e['myScore'] ? e['myScore'].toString() : 0;
                this.friendBtn.on(Laya.Event.CLICK, this, this.pressFriendBtn);
                this.worldBtn.on(Laya.Event.CLICK, this, this.pressWorldBtn);
                this.pressWorldBtn();
                //this.pressFriendBtn();
                //开启世界排行榜处理循环
                Laya.timer.frameLoop(1, this, this.rankListLoop);
            }, f => {
                XnhdAPI.logDebug('RankListLayer get WorldRankData fail ' + f.toString());
            });
            //排行榜未接，仅以世界排行榜为例  
            // } else {
            //     this._worldRankShowTestData = 4;
            //     let _myUrl = "card/1_" + XnhdAPI.Tools.randomInt(1, 13) + ".png";
            //     this._worldRankData = {
            //         rankList: [
            //             { "idx": 1, "openid": "ab1", "nick": "其他玩家", "icon": "card/1_" + XnhdAPI.Tools.randomInt(1, 13) + ".png", "score": 99999999 },
            //             { "idx": 2, "openid": "ab2", "nick": "其他玩家", "icon": "card/1_" + XnhdAPI.Tools.randomInt(1, 13) + ".png", "score": 99999998 },
            //             { "idx": 3, "openid": "ab3", "nick": "我自测名字示意", "icon": _myUrl, "score": 99999997 },
            //         ],
            //         myRank: 3,
            //         myScore: 99999997
            //     };
            //     // for (let i = 0; i < 7; i++) {
            //     //     this._test_createNewTestWorldRankPlayer();
            //     // }
            //     let my = this.rankListZone_W.parent.getChildAt(1) as Laya.Image;
            //     let a = this._worldRankData.myRank > 4 ? 4 : this._worldRankData.myRank;
            //     (my.getChildAt(0) as Laya.Image).skin = 'game/rank_' + a + '.png';
            //     (my.getChildAt(0) as Laya.Image).visible = this._worldRankData.myRank < 99;
            //     (my.getChildAt(1) as Laya.Label).text = this._worldRankData.myRank.toString();
            //     (my.getChildAt(2) as Laya.Image).skin = _myUrl;
            //     (my.getChildAt(3) as Laya.Label).text = '我自测名字示意';
            //     (my.getChildAt(4) as Laya.Label).text = this._worldRankData.myScore.toString();
            //     this.friendBtn.on(Laya.Event.CLICK, this, this.pressFriendBtn);
            //     this.worldBtn.on(Laya.Event.CLICK, this, this.pressWorldBtn);
            //     this.pressWorldBtn();
            //     // this.pressFriendBtn();
            //     //开启世界排行榜处理循环
            //     Laya.timer.frameLoop(1, this, this.rankListLoop);
            // }
        }
        _test_createNewTestWorldRankPlayer() {
            if (this._worldRankShowTestData > 0) {
                this._worldRankData.rankList.push({
                    "idx": this._worldRankShowTestData,
                    "openid": "ab" + this._worldRankShowTestData,
                    "nick": "其他玩家",
                    "icon": "card/1_" + XnhdAPI.Tools.randomInt(1, 13) + ".png",
                    "score": 100000000 - this._worldRankShowTestData
                });
                this._worldRankShowTestData++;
            }
        }
        pressFriendBtn() {
            this.worldBtn.getChildAt(1).visible = true;
            this.friendBtn.getChildAt(1).visible = false;
            this.rankListZone.parent.visible = true;
            this.rankListZone_W.parent.visible = false;
        }
        pressWorldBtn() {
            this.worldBtn.getChildAt(1).visible = false;
            this.friendBtn.getChildAt(1).visible = true;
            this.rankListZone.parent.visible = false;
            this.rankListZone_W.parent.visible = true;
        }
        rankListLoop() {
            //微信好友排行榜示意
            if (this._wxRankListSwitch && this._pressDown) {
                let a = Laya.stage.mouseY - this._lastMouseY;
                if (a != 0) {
                    // XnhdAPI.logDebug('大排行榜移动：' + a);
                    XnhdAPI.moveRankList(a);
                }
                this._lastMouseY = Laya.stage.mouseY;
            }
            //世界排行榜示意
            if (this.rankListZone_W.parent.visible && this.rankListZone_W.vScrollBar.value + this.rankListZone_W.height > (this._ranklistCompArr.length - 5) * 145) {
                let rankList = this._worldRankData['rankList'];
                //世界排行榜数据格式,"rankList":[{"idx":1,"openid":"a","nick":"ccc","icon":"44","score":22}],"myRank":1,"myScore":22
                //检查世界排行榜情况，如果下滑超过一定数量，则新增5个人
                for (let i = 0; i < 5; i++) {
                    if (this._worldCurRank === rankList.length) {
                        return;
                    }
                    else {
                        //this._test_createNewTestWorldRankPlayer();
                        let onePiece = new rankListComp;
                        let thisData = rankList[this._worldCurRank];
                        onePiece.init(this.rankListZone_W, thisData.idx, thisData.icon, thisData.nick, thisData.score);
                        this._worldCurRank++;
                        this._ranklistCompArr.push(onePiece);
                    }
                }
            }
        }
        Destroy() {
            XnhdAPI.closeRankList();
            this.destroy();
        }
        UIAdjust() {
            this.bg.height = XnhdAPI.Param.screenHeight;
            let k = this.bg.height - 1334; //1624-1334 = 290
            let ratio = k / (1624 - 1334);
            ratio < 0 && (ratio = 0);
            let a = Math.floor(150 * ratio);
            this.shareBtn.y = 1170 + a;
            this.middleZone.y = 605 + a;
            this.closeBtn.y = a;
            let i = core.GameDef.languageIndex;
            let l = core.GameDef.localizationConfig;
            this.friendBtn.getChildAt(0).text = l.ranklistLayer.friend[i];
            this.worldBtn.getChildAt(0).text = l.ranklistLayer.world[i];
            this.shareBtn.getChildAt(0).text = l.share[i];
        }
        platNodeInit() {
            if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 1) {
                this._wxRankListSwitch = true;
                this.rankListZone.on(Laya.Event.MOUSE_DOWN, this, () => {
                    if (!this._pressDown) {
                        this._pressDown = true;
                        this._lastMouseY = Laya.stage.mouseY;
                    }
                });
                this.on(Laya.Event.MOUSE_UP, this, () => {
                    this._pressDown = false;
                });
            }
        }
    }
    view.RankListLayer = RankListLayer;
    class rankListComp extends ui.Comp.ranklistCompUI {
        constructor() {
            super();
        }
        init(parent, id, avatarUrl, nickName, score) {
            parent.addChild(this);
            this.pos(0, (id - 1) * 145 + 25);
            this.rankScore.text = id.toString();
            this.rankScoreBg.visible = id < 99;
            let a = id > 4 ? 4 : id;
            this.rankScoreBg.skin = 'game/rank_' + a + '.png';
            this.avatar.skin = avatarUrl;
            this.playName.text = nickName;
            this.playScore.text = score.toString();
        }
    }
})(view || (view = {}));
