var view;
(function (view) {
    class storeLayer extends ui.Layer.StoreLayerUI {
        constructor(parent, closeCallback) {
            super();
            this._stamp = {
                curId: 0,
                ani: false,
            };
            this._bg = {
                curId: 0,
                ani: false,
                sampleI: 0,
            };
            this._stampArr = [];
            this._bgArr = [];
            this._bgSample = [];
            this._bgSampleI = 0;
            this._guideStep = 0;
            this.UIAdjust();
            parent.addChild(this);
            this.stampBtn.on(Laya.Event.CLICK, this, this.pressStampBtn);
            this.stampLeft.on(Laya.Event.MOUSE_DOWN, this, this.pressStampRight);
            this.stampRight.on(Laya.Event.MOUSE_DOWN, this, this.pressStampLeft);
            this.bgLeft.on(Laya.Event.MOUSE_DOWN, this, this.pressBgRight);
            this.bgRight.on(Laya.Event.MOUSE_DOWN, this, this.pressBgLeft);
            this._stamp.curId = core.Player.Manager.getCurSkin_stamp();
            this._bg.curId = core.Player.Manager.getCurSkin_bg();
            this.closeBtn.on(Laya.Event.CLICK, this, () => {
                //if (this._guideStep === 0) {
                this.destroy();
                closeCallback && closeCallback();
                //}
            });
            for (let i = 0; i < core.GameDef.stampParam.length; i++) {
                let a = new stampUnit(this.effLayer);
                a.init(i);
                if (i === this._stamp.curId) {
                    a.pos(315, 317);
                }
                else if (i === this.getLeftId(this._stamp.curId, true)) {
                    a.alpha = 0.85;
                    a.scale(0.8, 0.8);
                    a.pos(120, 317);
                }
                else if (i === this.getRightId(this._stamp.curId, true)) {
                    a.alpha = 0.85;
                    a.scale(0.8, 0.8);
                    a.pos(510, 317);
                }
                else {
                    a.alpha = 0;
                    a.scale(0.8, 0.8);
                    a.pos(315, 317);
                }
                this._stampArr.push(a);
            }
            for (let i = 0; i < core.GameDef.bgParam.length; i++) {
                let a = new bgUnit(this.effLayer);
                a.init(i);
                if (i === this._bg.curId) {
                    a.pos(315, 855);
                }
                else if (i === this.getLeftId(this._bg.curId, false)) {
                    a.alpha = 0.85;
                    a.scale(0.8, 0.8);
                    a.pos(112, 855);
                }
                else if (i === this.getRightId(this._bg.curId, false)) {
                    a.alpha = 0.85;
                    a.scale(0.8, 0.8);
                    a.pos(518, 855);
                }
                else {
                    a.alpha = 0;
                    a.scale(0.8, 0.8);
                    a.pos(315, 855);
                }
                this._bgArr.push(a);
            }
            this.adjustStampBtn();
            this.adjustBgTips();
            let needGuide = XnhdAPI.readDataFromCache('Guide');
            if (needGuide === 'Guide') {
                this._guideStep = 1;
                this.hand.visible = true;
                this.guideHandAni1();
            }
        }
        guideHandAni1() {
            this.hand.pos(505, 380);
            this.hand.visible && Laya.Tween.to(this.hand, { x: 535, y: 410 }, 500, null, Laya.Handler.create(this, () => {
                this.hand.visible && Laya.Tween.to(this.hand, { x: 505, y: 380 }, 500, null, Laya.Handler.create(this, () => {
                    this.guideHandAni1();
                }));
            }));
        }
        guideHandAni2() {
            this.hand.pos(420, 525);
            this.hand.visible && Laya.Tween.to(this.hand, { x: 450, y: 555 }, 500, null, Laya.Handler.create(this, () => {
                this.hand.visible && Laya.Tween.to(this.hand, { x: 420, y: 525 }, 500, null, Laya.Handler.create(this, () => {
                    this.guideHandAni2();
                }));
            }));
        }
        getLeftId(id, isStamp) {
            if (id === 0) {
                return isStamp ? core.GameDef.stampParam.length - 1 : core.GameDef.bgParam.length - 1;
            }
            else {
                return id - 1;
            }
        }
        getRightId(id, isStamp) {
            let m = isStamp ? core.GameDef.stampParam.length - 1 : core.GameDef.bgParam.length - 1;
            if (id === m) {
                return 0;
            }
            else {
                return id + 1;
            }
        }
        pressStampBtn() {
            let coinLabel = this.stampBtn.getChildAt(1);
            if (coinLabel.visible && (this._guideStep === 0 || this._guideStep === 2)) {
                let t = core.GameDef.stampParam[this._stamp.curId].param1;
                let l = core.GameDef.localizationConfig;
                let i = core.GameDef.languageIndex;
                if (core.Player.Manager.getCoinNum() > t - 1 || core.GameDef.selfTest) {
                    !core.GameDef.selfTest && core.Player.Manager.adjustCoinNum(-t);
                    core.Player.Manager.unlockSkin_stamp(this._stamp.curId);
                    if (this._guideStep === 2) {
                        this._guideStep = 0;
                        this.hand.visible = false;
                        XnhdAPI.saveDataToCache('Guide', 'GuideFinish');
                    }
                    this.adjustStampBtn();
                }
                else {
                    new view.LackOfGold(this, () => {
                        this.adjustStampBtn();
                    });
                }
            }
        }
        adjustStampBtn() {
            let a = core.Player.Manager.checkSkin_stamp(this._stamp.curId);
            let l = core.GameDef.localizationConfig.storeLayer;
            let i = core.GameDef.languageIndex;
            let coinLabel = this.stampBtn.getChildAt(0);
            let txt = this.stampBtn.getChildAt(1);
            if (a) {
                coinLabel.visible = false;
                txt.y = 45;
                txt.text = l.Activated[i];
                core.Player.Manager.setCurSkin_stamp(this._stamp.curId);
            }
            else {
                coinLabel.visible = true;
                coinLabel.text = core.GameDef.stampParam[this._stamp.curId].param1.toString();
                txt.y = 65;
                txt.text = l.purchase[i];
            }
            this.coinNum.text = core.Player.Manager.getCoinNum().toString();
        }
        adjustBgTips() {
            let a = core.Player.Manager.checkSkin_bg(this._bg.curId);
            let l = core.GameDef.localizationConfig.storeLayer;
            let i = core.GameDef.languageIndex;
            if (a || core.GameDef.selfTest) {
                this.bgStatusTips.text = l.Activated[i];
                let m = this._bgSample[this._bgSampleI];
                this._bgSampleI = (this._bgSampleI + 1) % 2;
                let n = this._bgSample[this._bgSampleI];
                m.zOrder = 0;
                Laya.Tween.to(m, { alpha: 0 }, 500);
                n.zOrder = 1;
                n.skin = core.GameDef.bgParam[this._bg.curId].url;
                Laya.Tween.to(n, { alpha: 1 }, 500);
                core.Player.Manager.setCurSkin_bg(this._bg.curId);
            }
            else {
                let t = core.GameDef.bgParam[this._bg.curId].param1;
                let t0 = l.unlock[i];
                let d = t0.indexOf('{0}');
                this.bgStatusTips.text = t0.substring(0, d) + t.toString() + t0.substring(d + 3);
            }
        }
        pressStampLeft() {
            if (!this._stamp.ani && (this._guideStep === 0 || this._guideStep === 1)) {
                if (this._guideStep === 1) {
                    this._guideStep = 2;
                    Laya.Tween.clearAll(this.hand);
                    this.guideHandAni2();
                }
                this._stamp.ani = true;
                let id = this._stamp.curId;
                let cur = this._stampArr[id];
                let left = this._stampArr[this.getLeftId(id, true)];
                let right1 = this._stampArr[this.getRightId(id, true)];
                let right2 = this._stampArr[this.getRightId(this.getRightId(id, true), true)];
                Laya.Tween.to(cur, { x: 120, alpha: 0.85, scaleX: 0.8, scaleY: 0.8 }, 500);
                Laya.Tween.to(left, { alpha: 0 }, 500);
                right1.zOrder = 1;
                Laya.Tween.to(right1, { x: 315, alpha: 1, scaleX: 1, scaleY: 1 }, 500);
                right2.x = 510;
                Laya.Tween.to(right2, { alpha: 0.8 }, 500);
                Laya.timer.once(500, this, () => {
                    cur.zOrder = 0;
                    this._stamp.ani = false;
                    this._stamp.curId = this.getRightId(id, true);
                    this.adjustStampBtn();
                });
            }
        }
        pressStampRight() {
            if (!this._stamp.ani && this._guideStep === 0) {
                this._stamp.ani = true;
                let id = this._stamp.curId;
                let cur = this._stampArr[id];
                let right = this._stampArr[this.getRightId(id, true)];
                let left1 = this._stampArr[this.getLeftId(id, true)];
                let left2 = this._stampArr[this.getLeftId(this.getLeftId(id, true), true)];
                Laya.Tween.to(cur, { x: 510, alpha: 0.85, scaleX: 0.8, scaleY: 0.8 }, 500);
                Laya.Tween.to(right, { alpha: 0 }, 500);
                left1.zOrder = 1;
                Laya.Tween.to(left1, { x: 315, alpha: 1, scaleX: 1, scaleY: 1 }, 500);
                left2.x = 120;
                Laya.Tween.to(left2, { alpha: 0.8 }, 500);
                Laya.timer.once(500, this, () => {
                    cur.zOrder = 0;
                    this._stamp.ani = false;
                    this._stamp.curId = this.getLeftId(id, true);
                    this.adjustStampBtn();
                });
            }
        }
        pressBgLeft() {
            if (!this._bg.ani && this._guideStep === 0) {
                this._bg.ani = true;
                let id = this._bg.curId;
                let cur = this._bgArr[id];
                let left = this._bgArr[this.getLeftId(id, false)];
                let right1 = this._bgArr[this.getRightId(id, false)];
                let right2 = this._bgArr[this.getRightId(this.getRightId(id, false), false)];
                Laya.Tween.to(cur, { x: 112, alpha: 0.85, scaleX: 0.8, scaleY: 0.8 }, 500);
                Laya.Tween.to(left, { alpha: 0 }, 500);
                right1.zOrder = 1;
                Laya.Tween.to(right1, { x: 315, alpha: 1, scaleX: 1, scaleY: 1 }, 500);
                right2.x = 518;
                Laya.Tween.to(right2, { alpha: 0.8 }, 500);
                Laya.timer.once(500, this, () => {
                    cur.zOrder = 0;
                    this._bg.ani = false;
                    this._bg.curId = this.getRightId(id, false);
                    this.adjustBgTips();
                });
            }
        }
        pressBgRight() {
            if (!this._bg.ani && this._guideStep === 0) {
                this._bg.ani = true;
                let id = this._bg.curId;
                let cur = this._bgArr[id];
                let right = this._bgArr[this.getRightId(id, false)];
                let left1 = this._bgArr[this.getLeftId(id, false)];
                let left2 = this._bgArr[this.getLeftId(this.getLeftId(id, false), false)];
                Laya.Tween.to(cur, { x: 518, alpha: 0.85, scaleX: 0.8, scaleY: 0.8 }, 500);
                Laya.Tween.to(right, { alpha: 0 }, 500);
                left1.zOrder = 1;
                Laya.Tween.to(left1, { x: 315, alpha: 1, scaleX: 1, scaleY: 1 }, 500);
                left2.x = 112;
                Laya.Tween.to(left2, { alpha: 0.8 }, 500);
                Laya.timer.once(500, this, () => {
                    cur.zOrder = 0;
                    this._bg.ani = false;
                    this._bg.curId = this.getLeftId(id, false);
                    this.adjustBgTips();
                });
            }
        }
        UIAdjust() {
            this.bgLayer.height = XnhdAPI.Param.screenHeight;
            this._bgSample = [this.bgLayer.getChildAt(0), this.bgLayer.getChildAt(1)];
            this._bgSample[0].height = this.bgLayer.height;
            this._bgSample[1].height = this.bgLayer.height;
            this.middleZone.y = this.bgLayer.height / 2;
            this.middleZone.getChildAt(0).getChildAt(1).text = core.GameDef.localizationConfig.storeLayer.title[core.GameDef.languageIndex];
        }
    }
    view.storeLayer = storeLayer;
    class bgUnit extends ui.Comp.store_bgUnitUI {
        constructor(parent) {
            super();
            this.anchorX = 0.5;
            this.anchorY = 1;
            parent.addChild(this);
        }
        init(id) {
            this.bgSkin.skin = core.GameDef.bgParam[id].url;
            this.lock.visible = !core.Player.Manager.checkSkin_bg(id);
        }
    }
    class stampUnit extends ui.Comp.store_stampUnitUI {
        constructor(parent) {
            super();
            this.anchorX = 0.5;
            this.anchorY = 1;
            parent.addChild(this);
        }
        init(id) {
            this.bgSkin.skin = core.GameDef.stampParam[id].url;
        }
    }
})(view || (view = {}));
