var view;
(function (view) {
    class MainView extends ui.MainViewUI {
        constructor() {
            console.log("run in MainView.constructor0");
            super();
            this.UIAdjust();
            XnhdAPI.DeviceInfo.inst.setResizeCallback(() => {
                this.UIAdjust();
            });
            this.languageSet();
            this.resetBgSkin();
            this.updateCoinNum();
            this.platNodeInit();
            this.monitorOn();
            // let needGuide = XnhdAPI.readDataFromCache('Guide');
            // if (needGuide === 'Guide') {
            //     this.storeGuideLayer.visible = true;
            //     this.guideHandAni();
            // }
            //初始化bannerAD
            XnhdAPI.initBannerAD();
            XnhdAPI.showBanner("home");
            XnhdAPI.initRewardAd();
            if (window['tt']) {
                this.ranklistBtn.visible = true;
                console.log("tt set ranklistBtn = true;");
            }
            this.ranklistBtn.visible = true;
            console.log("run in MainView.constructor9");
        }
        guideHandAni() {
            this.hand.pos(580, 604 + this.leftZone.y);
            this.storeGuideLayer.visible && Laya.Tween.to(this.hand, { x: 540, y: 644 + this.leftZone.y }, 500, null, Laya.Handler.create(this, () => {
                this.storeGuideLayer.visible && Laya.Tween.to(this.hand, { x: 580, y: 604 + this.leftZone.y }, 500, null, Laya.Handler.create(this, () => {
                    this.guideHandAni();
                }));
            }));
        }
        gameStart(isRank) {
            // if (XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 4) {
            //     HudieLiteGameAPI.update_login(true)
            // }
            if (!this.storeGuideLayer.visible) {
                if (isRank > 0) {
                    if (this.coin_img.visible) {
                        if (core.Player.Manager.getCoinNum() > 99 || core.GameDef.selfTest) {
                            core.Player.Manager.adjustCoinNum(-100);
                            core.GameDef.isRank = true;
                            Laya.timer.clearAll(this);
                            core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                        }
                        else {
                            new view.LackOfGold(this, () => {
                                this.updateCoinNum();
                            });
                        }
                    }
                    else {
                        core.GameDef.isRank = true;
                        Laya.timer.clearAll(this);
                        core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                    }
                }
                else {
                    core.GameDef.isRank = false;
                    Laya.timer.clearAll(this);
                    core.SceneManager.Default.ShowScene(core.GameScene.GAMESCENE);
                }
            }
        }
        monitorOn() {
            let soundBtnSkin = this.soundBtn.getChildAt(0);
            if (core.AudioAndSetting.Manager.volumeMusic === 0) {
                soundBtnSkin.skin = "game/sound_off.png";
            }
            else {
                soundBtnSkin.skin = "game/sound_on.png";
            }
            this.soundBtn.on(Laya.Event.CLICK, this, () => {
                if (!this.storeGuideLayer.visible) {
                    if (core.AudioAndSetting.Manager.volumeMusic == 0) {
                        core.AudioAndSetting.Manager.setMusicVolume(70);
                        core.AudioAndSetting.Manager.setSoundVolume(100);
                        soundBtnSkin.skin = "game/sound_on.png";
                    }
                    else {
                        core.AudioAndSetting.Manager.setMusicVolume(0);
                        core.AudioAndSetting.Manager.setSoundVolume(0);
                        soundBtnSkin.skin = "game/sound_off.png";
                    }
                }
            });
            this.normalBtn.on(Laya.Event.CLICK, this, this.gameStart, [0]);
            this.rankBtn.on(Laya.Event.CLICK, this, this.gameStart, [1]);
            this.cultivateBtn.on(Laya.Event.CLICK, this, () => {
                if (!this.storeGuideLayer.visible) {
                    new view.cultivateLayer(this, () => {
                        this.updateCoinNum();
                    });
                }
            });
            this.storeBtn.on(Laya.Event.CLICK, this, () => {
                if (this.storeGuideLayer.visible) {
                    this.storeGuideLayer.visible = false;
                }
                new view.storeLayer(this, () => {
                    this.resetBgSkin();
                    this.updateCoinNum();
                });
            });
            this.languageSettingBtn.on(Laya.Event.CLICK, this, () => {
                if (!this.storeGuideLayer.visible) {
                    new view.langView(() => {
                        this.languageSet();
                    });
                }
            });
            this.ranklistBtn.on(Laya.Event.CLICK, this, () => {
                if (!this.storeGuideLayer.visible) {
                    new view.RankListLayer(this);
                }
            });
            if (this.checkRankingCost()) {
                this.rankBtn.getChildAt(0).y = 75;
            }
            else {
                this.coin_img.visible = true;
            }
            // this.addCoin.on(Laya.Event.CLICK, this, () => {
            //     if (!this.storeGuideLayer.visible) {
            //         core.Player.Manager.adjustCoinNum(200);
            //         this.updateCoinNum();
            //     }
            // })
            this.addCoin.visible = false;
            Laya.timer.frameLoop(120, this, this.buttonEff, [this.storeBtn]);
        }
        buttonEff(spr) {
            let p = Math.PI / 15;
            for (let i = 0; i < 30; i++) {
                Laya.timer.once(i * 15, this, () => {
                    spr.scale(1 + 0.1 * Math.sin(2 * p * i), 1 + 0.1 * Math.sin(2 * p * i));
                });
            }
        }
        checkRankingCost() {
            let data = XnhdAPI.readDataFromCache("RankData");
            if (data && data.length > 0) {
                return true;
            }
            return false;
        }
        resetBgSkin() {
            this.bg.skin = core.GameDef.bgParam[core.Player.Manager.getCurSkin_bg()].url;
        }
        updateCoinNum() {
            this.coinZone.getChildAt(1).text = core.Player.Manager.getCoinNum().toString();
        }
        platNodeInit() {
            if (XnhdAPI.Param.platType === 2 && [1, 4, 6].indexOf(XnhdAPI.Param.channelType) > -1) {
                // this.btnShare.visible = true;
                // this.btnShare.on(Laya.Event.CLICK, this, () => {
                //     XnhdAPI.shareImage(false, 2)
                // });
                // if (XnhdAPI.Param.channelType === 1) {
                //     this.btnRanklist.visible = true;
                //     this.btnRanklist.on(Laya.Event.CLICK, this, () => {
                //         this.hideSpecialStart();
                //         new view.RankListLayer(this, () => {
                //             this.specializeStart();
                //         });
                //     })
                //     XnhdAPI.XnhdWxPush.showBotBanner(this.botBanner);
                //     XnhdAPI.XnhdWxPush.showExitBtn(this.exitBtn);
                //     XnhdAPI.XnhdWxPush.showShakeIcon(this.shakeIcon);
                //     return;
                // }
            }
            // this.logo.visible = false;
            Laya.timer.frameOnce(60, this, () => { XnhdAPI.showBannerAd("home", XnhdAPI.Param.screenHeight - 220); });
        }
        specializeStart() {
            // XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 4 && HudieLiteGameAPI.showBtnWithAuthorize()
        }
        hideSpecialStart() {
            // XnhdAPI.Param.platType === 2 && XnhdAPI.Param.channelType === 4 && HudieLiteGameAPI.hideBtnWithAuthorize();
        }
        UIAdjust() {
            this.bg.height = XnhdAPI.Param.screenHeight;
            let k = XnhdAPI.Param.screenHeight - 1334; //1624-1334 = 290
            let ratio = k / (1624 - 1334);
            ratio < 0 && (ratio = 0);
            this.middleZone.y = 250 + Math.floor(150 * ratio);
            this.storeGuideLayer.getChildAt(0).height = 454 + this.leftZone.y;
            this.storeGuideLayer.getChildAt(1).y = 454 + this.leftZone.y;
            this.storeGuideLayer.getChildAt(2).y = 605 + this.leftZone.y;
            this.hand.y = 605 + this.leftZone.y;
        }
        languageSet() {
            let i = core.GameDef.languageIndex;
            let l = core.GameDef.localizationConfig;
            this.logo.skin = l.MainView.logo[i];
            this.cultivateBtn.getChildAt(0).text = l.MainView.cultivateBtn[i];
            this.normalBtn.getChildAt(0).text = l.MainView.normalBtn[i];
            this.rankBtn.getChildAt(0).text = l.MainView.rankBtn[i];
            this.soundBtn.getChildAt(1).text = l.MainView.soundBtn[i];
            this.languageSettingBtn.getChildAt(1).text = l.MainView.languageBtn[i];
            this.ranklistBtn.getChildAt(1).text = l.MainView.ranklistBtn[i];
            this.storeBtn.getChildAt(0).text = l.MainView.storeBtn[i];
        }
    }
    view.MainView = MainView;
})(view || (view = {}));
